# BrnTech makefile Version 1.01
#   Created by Huang Tzu-Fong, 2002/12/20

# config used modules in this file and set up module related compile flags(CFLAGS),
# defined macros(Cdefined) and include path(ModulePath)
# this file is included and processed only in GNUmakefile of root directory of the project



# process defined macros definitions ==========================
# ---------------------------------------------------------------------

#ifneq "$(strip $(_PCI_BUS))" "0"
   Cdefined += -D_PCI_BUS=$(_PCI_BUS)
#endif

ifneq "$(strip $(_PCI_BUS))" "0"
  ifneq "$(strip $(_PCI_BUS_FUNCTION))" "NORMAL"
    # SHOWTYPE : Show Card Type
    ifeq "$(strip $(_PCI_BUS_FUNCTION))" "SHOWTYPE"
       Cdefined += -D_PCI_BUS_SHOWTYPE
    endif
  endif
endif

# USB System and HOST controller
ifneq "$(strip $(_USB))" "0"
   Cdefined += -D_USB=$(_USB)
   ifneq "$(strip $(_USB))" "0"
     Cdefined += -D_USB2=$(_USB2)
   endif
endif

# USB LPT
ifneq "$(strip $(_USB_LPT))" "0"
Cdefined += -D_USB_LPT=$(_USB_LPT)
endif

# USB MAC Layer Device
ifneq "$(strip $(_USB_MAC))" "0"
Cdefined += -D_USB_MAC=$(_USB_MAC)
endif

# USB Mass Storage Class
ifneq "$(strip $(_USB_MS))" "0"
Cdefined += -D_USB_MS=$(_USB_MS)
endif

# VLYNQ Interfacce  # PTR-TI-0056 2004.07.01
ifneq "$(strip $(_VLYNQ))" "0"
  ifeq "$(strip $(_VLYNQ))" "1"
   Cdefined += -DVLYNQ0
  endif
  ifeq "$(strip $(_VLYNQ))" "2"
   Cdefined += -DVLYNQ1
  endif
endif

# USB Slave Driver
ifeq "$(strip $(_USB_SLAVE))" "1"
Cdefined += -D_USB_SLAVE=$(_USB_SLAVE)
endif

ifeq "$(strip $(_EMI_TEST))" "1"
    Cdefined +=  -DEMI_TEST
endif

# VLAN support
ifeq "$(strip $(_VLAN))" "1"
Cdefined += -D_VLAN
endif
# ---------------------------------------------------------------------
ifeq "$(strip $(_NEWLIB))" "1"
    Cdefined += -I../newlib/libc/include -D_NEWLIB
endif

ifeq "$(strip $(_ETCPIP))" "1"
    Cdefined += -D_ETCPIP
endif

    Cdefined += -D_HWLAN=$(_HWLAN)
ifneq "$(strip $(_HWLAN))" "0"
ifeq "$(strip $(_JAVELIN))" "1"
  Cdefined += -D_JAVELIN=$(_JAVELIN)
endif

ifeq "$(strip $(_HWLAN))" "6"
	# _ATHEROS,AR5312=1,AR5311=0 must be defined for Atheros PCI wireless driver
	Cdefined += -DATHEROS_A_OR_G #-D_ATHEROS=6 -DAR5312=1 -DAR5311=0
endif

ifeq "$(strip $(_WLAN_ACCMAC))" "1"
  Cdefined += -D_WLAN_ACCMAC
endif
ifeq "$(strip $(_802DOT1X))" "1"
  Cdefined += -D_802DOT1X=$(_802DOT1X)
endif
#  ifeq "$(strip $(_802DOT1X))" "2"
#    Cdefined += -D_802DOT1X=$(_802DOT1X) -D_DOT1X_LITE
#  endif
ifeq "$(strip $(_802DOT1X))" "3"
  Cdefined += -D_802DOT1X=$(_802DOT1X)
endif
ifeq "$(strip $(_802DOT1X))" "5"
  Cdefined += -D_802DOT1X=$(_802DOT1X)
endif

ifneq "$(strip $(_WPA))" "0"
  Cdefined += -D_WPA=$(_WPA)
endif

ifeq "$(strip $(_WLAN_WDS))" "1"
  Cdefined += -DBRN_WDS_LINKS
endif
endif

ifeq "$(strip $(_ART))" "1"
    Cdefined += -D_ART
endif
ifeq "$(strip $(_ELAN))" "1"
    Cdefined += -D_ELAN
endif

ifeq "$(strip $(_UNZIP))" "1"
    Cdefined += -D_UNZIP
endif

ifeq "$(strip $(_AAL5))" "1"
    Cdefined += -D_AAL5
endif

ifeq "$(strip $(_IPOA))" "1"
    Cdefined += -D_IPOA
endif

ifeq "$(strip $(_ADSL))" "1"
    Cdefined += -D_ADSL

    ifeq "$(strip $(_AUTO_HUNT))" "1"
    	Cdefined += -D_AUTO_CFG_VC
    endif
endif

ifneq "$(strip $(_AME150R))" "0"
    Cdefined += -D_AME150R=$(_AME150R)
endif

ifeq "$(strip $(_NE2000))" "1"
    Cdefined += -D_NE2000
endif

ifeq "$(strip $(_RTL8139))" "1"
    Cdefined += -D_RTL8139
endif

ifeq "$(strip $(_I8250))" "1"
    Cdefined += -D_I8250
endif

ifeq "$(strip $(_VPN))" "1"
    Cdefined += -D_VPN
endif

# PTR-TI-0039 2004.06.23
ifeq "$(strip $(_SSL))" "1"
    Cdefined += -D_SSL
endif

ifeq "$(strip $(_L2TP))" "1"
    ifneq "$(strip $(_VPN))" "1"
        $(error error! should also define _VPN.)
    endif
    Cdefined += -D_L2TP
endif

ifneq "$(strip $(_PPTP))" "0"
    ifneq "$(strip $(_VPN))" "1"
        $(error error! should also define _VPN.)
    endif
    ifneq "$(strip $(_DIAL))" "1"
        $(error error! should also define _DIAL.)
    endif
    ifneq "$(strip $(_PPP))" "1"
        $(error error! should also define _PPP.)
    endif

    ifeq "$(strip $(_PPTP))" "1"
   	    Cdefined += -D_PPTP
    endif
    ifeq "$(strip $(_PPTP))" "2"
   	    Cdefined += -D_PPTP -D_WAN_PPTP
    endif
endif

ifeq "$(strip $(_RADIUS))" "1"
    Cdefined += -D_RADIUS -DR_FLAG=$(R_FLAG)
endif

# MALONE-BACKUP-03
ifeq "$(strip $(_BACKUP))" "1"
    Cdefined += -D_BACKUP
endif

# Add by yclin 92/05/18
# _DIALUP=2 => Try secondary dialup when primary dialup is fail.
ifneq "$(strip $(_DIALUP))" "0"
    Cdefined += -D_DIALUP=$(_DIALUP)
endif

ifneq "$(strip $(_SYSLOG))" "0"
    Cdefined += -D_SYSLOG=$(_SYSLOG)
endif

ifeq "$(strip $(_NTP))" "1"
    Cdefined += -D_NTP
endif

ifeq "$(strip $(_ACCTON_NEW_UI))" "1"
    Cdefined += -D_ACCTON_NEW_UI
endif

ifeq "$(strip $(_T16550))" "1"
    Cdefined += -D_T16550
endif

ifeq "$(strip $(_WB940))" "1"
    Cdefined += -D_WB940
endif


ifeq "$(strip $(_SAR850))" "1"
    Cdefined += -D_SAR850
endif
ifeq "$(strip $(_SAR850))" "2"
    Cdefined += -D_SAR850 -D_OAMF4
endif
ifeq "$(strip $(_SAR850))" "3"
    Cdefined += -D_SAR850 -D_OAMF5
endif
ifeq "$(strip $(_SAR850))" "4"
    Cdefined += -D_SAR850 -D_OAMF4 -D_OAMF5
endif


ifeq "$(strip $(_ETH850))" "1"
    Cdefined += -D_ETH850
endif

ifeq "$(strip $(_SSMAC))" "1"
    Cdefined += -D_SSMAC
endif

ifeq "$(strip $(_GEN_MAC_0))" "1"
    Cdefined += -D_GEN_MAC_0
endif

ifeq "$(strip $(_GEN_MAC_1))" "1"
    Cdefined += -D_GEN_MAC_1
endif

ifeq "$(strip $(_GEN_SAR_0))" "1"
    Cdefined += -D_GEN_SAR_0
endif

ifeq "$(strip $(_SSSAR))" "1"
    Cdefined += -D_SSSAR
endif

ifeq "$(strip $(_SSUART))" "1"
    Cdefined += -D_SSUART
endif

ifeq "$(strip $(_CXEMAC))" "1"
    Cdefined += -D_CXEMAC
endif

ifeq "$(strip $(_IKE))" "1"
    Cdefined += -D_IKE
endif #_IPSEC

ifneq "$(strip $(_IPSEC))" "0"
    Cdefined += -D_IPSEC=$(_IPSEC)
endif #_IPSEC

ifeq "$(strip $(_CRYPTO))" "1"
    Cdefined += -D_CRYPTO
endif #_CRYPTO

ifeq "$(strip $(_HW_CRYPTO))" "1"
    Cdefined += -D_HW_CRYPTO
endif #_CRYPTO

ifeq "$(strip $(_DIAL))" "1"
    Cdefined += -D_DIAL
endif

ifeq "$(strip $(_BPARAMS))" "1"
    Cdefined += -D_BPARAMS
endif

ifeq "$(strip $(_PPP))" "1"
    Cdefined += -D_PPP
    ifeq "$(strip $(_BCP))" "1"
        ifneq "$(strip $(_BRIDGING))" "1"
            $(warning warning! It's better to define _BRIDGING.)
        endif
        Cdefined += -D_BCP
    endif
endif

ifeq "$(strip $(_MPPE))" "1"
    ifneq "$(strip $(_PPP))" "1"
        $(error error! should also define _PPP.)
    endif
    Cdefined += -D_MPPE -D_CCP
endif
ifeq "$(strip $(_PPPOE))" "1"
    ifneq "$(strip $(_PPP))" "1"
        $(error error! should also define _PPP.)
    endif
    Cdefined += -D_PPPOE

    ifeq "$(strip $(_PPPOE_PT))" "1"     # PTR-TI-0065 2004.08.06
    	Cdefined += -D_PPPOE_PASS_THROUGH
    endif
endif

ifeq "$(strip $(_BRIDGING))" "1"
    Cdefined += -D_BRIDGING
endif
ifeq "$(strip $(_BRIDGING))" "2"
    Cdefined += -D_BRIDGING -D_STP
endif

ifeq "$(strip $(_MCAST))" "1"
    Cdefined += -D_MCAST
endif

ifneq "$(strip $(_ROUTING))" "0"
    Cdefined += -D_ROUTING=$(_ROUTING)
ifeq "$(strip $(_RIP))" "1"
    Cdefined += -D_RIP
endif
endif

ifeq "$(strip $(_MCFORWARD))" "1"
    Cdefined += -D_MCFORWARD
endif

ifeq "$(strip $(_SNMP))" "1"
    Cdefined += -D_SNMP
endif

ifeq "$(strip $(_SNMP))" "0"
    ifeq "$(COMPILER)" "1"    # Borland C/C++ 3.x
        Cdefined += -i50
    endif
endif


ifeq "$(strip $(_MIB2))" "1"
    Cdefined += -D_MIB2
endif

ifeq "$(strip $(_MIB_NDC))" "1"
    Cdefined += -D_MIB_NDC
endif

ifeq "$(strip $(_MIB_RMON1))" "1"
    Cdefined += -D_MIB_RMON1
endif

ifeq "$(strip $(_MIB_ADSL))" "1"
    Cdefined += -D_MIB_ADSL
endif

ifeq "$(strip $(_MIB_HWLAN))" "1"
    Cdefined += -D_MIB_HWLAN
endif

ifeq "$(strip $(_MIB_802dot11))" "1"
    Cdefined += -D_MIB_802dot11
endif

ifeq "$(strip $(_MLPPP))" "1"
    Cdefined += -D_MLPPP
endif

ifneq "$(strip $(_DNS))" "0"
    Cdefined += -D_DNS=$(_DNS)
endif

ifeq "$(strip $(_DHCPD))" "1"
    Cdefined += -D_DHCPD
endif

#------------------------------------------------------------#
# 2004.06.09 Calvin Liang  // PTR-TI-0034
ifeq "$(strip $(_DHCP_CLT))" "1"
    Cdefined += -D_DHCP_CLT=$(_DHCP_CLT)
endif

ifeq "$(strip $(_DHCP_CLT))" "2"
    Cdefined += -D_DHCP_CLT=$(_DHCP_CLT)
endif
#------------------------------------------------------------#

ifeq "$(strip $(_NAT))" "1"
    Cdefined += -D_NAT
endif
ifeq "$(strip $(_NAT))" "2"
    Cdefined += -D_NAT -D_H323_NAT
endif
ifeq "$(strip $(_NAT))" "3"
    Cdefined += -D_NAT -D_H323_NAT -D_MSG_NAT
endif
ifeq "$(strip $(_NAT))" "4"
    Cdefined += -D_NAT -D_H323_NAT -D_MSG_NAT -D_ICQ_NAT
endif

ifeq "$(strip $(_NAT_MULTI))" "1"
    Cdefined += -D_CLONE_INTERFACE
endif

ifeq "$(strip $(_MSCHAP))" "1"
    Cdefined += -D_MSCHAP
endif

ifeq "$(strip $(_SWUP))" "1"
    Cdefined += -D_SWUP
endif

ifeq "$(strip $(_TESTAP))" "1"
    Cdefined += -D_TESTAP
endif

ifeq "$(strip $(_TELNETD))" "1"
    Cdefined += -D_TELNETD -DCTRACE=$(CTRACE)
endif

ifeq "$(strip $(_RS232D))" "1"
    Cdefined += -D_RS232D -DCTRACE=$(CTRACE)
endif

ifeq "$(strip $(_CONSOLE))" "1"
    Cdefined += -D_CONSOLE
endif

ifeq "$(strip $(_FTPD))" "1"  # PTR-TI-0056 2004.07.01
    Cdefined += -D_FTPD
endif

ifeq "$(strip $(_MAIL))" "1"
    Cdefined += -D_MAIL
endif

ifeq "$(strip $(_PF))" "1"
    Cdefined += -D_PFILTER -DPTRACE=$(PTRACE)
endif

ifeq "$(strip $(_CBAC))" "1"
    Cdefined += -D_CBAC -DATRACE=$(ATRACE)
endif
ifeq "$(strip $(_CBAC))" "2"
    Cdefined += -D_CBAC -DATRACE=$(ATRACE) -DCBAC_SP
endif
ifeq "$(strip $(_CBAC))" "3"
    Cdefined += -D_CBAC -DATRACE=$(ATRACE) -DCBAC_FR
endif
ifeq "$(strip $(_CBAC))" "4"
    Cdefined += -D_CBAC -DATRACE=$(ATRACE) -DCBAC_TCP -DCBAC_UDP
endif
ifeq "$(strip $(_CBAC))" "5"
    Cdefined += -D_CBAC -DATRACE=$(ATRACE) -DCBAC_SP -DCBAC_TCP -DCBAC_UDP
endif
ifeq "$(strip $(_CBAC))" "6"
    Cdefined += -D_CBAC -DATRACE=$(ATRACE) -DCBAC_TCP -DCBAC_UDP -DCBAC_DOS
endif
ifeq "$(strip $(_CBAC))" "10"
    Cdefined += -D_CBAC -DATRACE=$(ATRACE) -DCBAC_SP -DCBAC_FR -DCBAC_TCP -DCBAC_UDP -DCBAC_DOS -DCBAC_SCH -DCBAC_URL
endif
ifeq "$(strip $(_CBAC))" "11"
    Cdefined += -D_CBAC -DATRACE=$(ATRACE) -DCBAC_SP -DCBAC_FR -DCBAC_TCP -DCBAC_UDP -DCBAC_DOS -DCBAC_SCH -DCBAC_URL -DCBAC_CLASSIFY
endif
ifeq "$(strip $(_CBAC))" "12"
    Cdefined += -D_CBAC -DATRACE=$(ATRACE) -DCBAC_SP -DCBAC_FR -DCBAC_TCP -DCBAC_UDP -DCBAC_DOS -DCBAC_SCH -DCBAC_URL -DCBAC_FRAME
endif
ifeq "$(strip $(_CBAC))" "13"
    Cdefined += -D_CBAC -DATRACE=$(ATRACE) -DCBAC_SP -DCBAC_FR -DCBAC_TCP -DCBAC_UDP -DCBAC_DOS -DCBAC_SCH -DCBAC_URL -DCBAC_CLASSIFY -DCBAC_FRAME
endif

ifeq "$(strip $(_IPX))" "1"
    Cdefined += -D_IPX
endif

ifeq "$(strip $(_NBIOS))" "1"
    Cdefined += -D_NBIOS_FORWARD -DNBDEBUG=$(NBDEBUG)
endif
ifeq "$(strip $(_NBIOS))" "2"
    Cdefined += -D_NBIOS_FORWARD -D_NBNS -DNBDEBUG=$(NBDEBUG)
endif
ifeq "$(strip $(_NBIOS))" "3"
    Cdefined += -D_NBIOS_FORWARD -D_NBNS -D_NB_SHARE -DNBDEBUG=$(NBDEBUG)
endif
ifeq "$(strip $(_NBIOS))" "4" # PTR-TI-0056 2004.07.01
    Cdefined += -D_NBIOS_FORWARD -D_NBNS -D_NB_SHARE -D_NB_FILE -DNBDEBUG=$(NBDEBUG)
endif

ifeq "$(strip $(_RT_CLOCK))" "1"
    Cdefined += -D_RT_CLOCK
endif

ifeq "$(strip $(_HTTPD))" "1"
    Cdefined += -D_HTTPD -DHTRACE=$(HTRACE) -DSTCFG=3 -DMAX_REQ=$(MAX_REQ)
endif

ifeq "$(strip $(_CGI))" "1"
    Cdefined += -D_SSI
endif

ifeq "$(strip $(_CGI))" "2"
    Cdefined += -D_CGI
endif

ifeq "$(strip $(_CGI))" "3"
    Cdefined += -D_CGI -D_SSI
endif

ifeq "$(strip $(_SETIP))" "1"
    Cdefined += -D_SETIP
endif

# // PTR-TI-0080 2004.09.06
ifeq "$(strip $(_IPV6))" "1"
    Cdefined += -D_IPV6
endif

#QoS
ifeq "$(strip $(_QoS))" "1"
    Cdefined += -D_CLASSIFY
endif
ifeq "$(strip $(_QoS))" "2"
    Cdefined += -D_QM
endif
ifeq "$(strip $(_QoS))" "3"
    Cdefined += -D_QoS -D_CLASSIFY -D_QM
endif

ifeq "$(strip $(_ENGLISH))" "1"
    Cdefined += -D_ENGLISH
endif

ifeq "$(strip $(_GERMAN))" "1"
    Cdefined += -D_GERMAN
endif

ifeq "$(strip $(_JAPAN))" "1"
    Cdefined += -D_JAPAN
endif

ifeq "$(strip $(_LANEED))" "1"
    Cdefined += -D_LANEED
endif

ifeq "$(strip $(_KYOCERA))" "1"
    Cdefined += -D_KYOCERA
endif

ifeq "$(strip $(_OMRON))" "1"
    Cdefined += -D_OMRON
endif

ifeq "$(strip $(_3COM))" "1"
    Cdefined += -D_3COM
endif

ifeq "$(strip $(_FSYS))" "0"   # File System : MS-DOS
    Cdefined += -DDOS_FS
endif
ifeq "$(strip $(_FSYS))" "1"   # File System : RDCF
    Cdefined += -DRDCF_FS
endif
ifeq "$(strip $(_FSYS))" "2"   # File System : PFS
    Cdefined += -DPFS
endif
ifeq "$(strip $(_FSYS))" "3"   # File System : III-TSD-FFS
    Cdefined += -DTSDFFS -DSUPERTASK
endif
ifeq "$(strip $(_FSYS))" "4"   # File System : FAT/FAT32
    Cdefined += -DFATFS
endif

ifeq "$(strip $(_EVALUATION))" "1"
    Cdefined += -D_EVALUATION
endif

ifeq "$(strip $(_WATCHDOG))" "1"
    Cdefined += -D_WATCHDOG
endif

ifneq "$(strip $(_LPD))" "0"
    Cdefined += -D_LPD=$(_LPD)
endif

ifneq "$(strip $(_DDNS))" "0"
    Cdefined += -D_DDNS=$(_DDNS)
endif

ifneq "$(strip $(_WEB_SHOW_PING))" "0"
    Cdefined += -D_WEB_SHOW_PING=$(_WEB_SHOW_PING)
endif

# UPNP specific Definition:
# -D_UPNP_NO_DEBUG or -D_UPNP_DEBUG
# -DINCLUDE_DEVICE_APIS and/or -DINCLUDE_CLIENT_APIS

ifneq "$(strip $(_UPNP))" "0"
#   Cdefined += -D_UPNP -D_UPNPVER=$(_UPNP) -D_REENTRANT -DINCLUDE_DEVICE_APIS -D_UPNP_DEBUG -D_WINSOCK_H
    Cdefined += -D_UPNP -D_UPNPVER=$(_UPNP) -D_REENTRANT -DINCLUDE_DEVICE_APIS -D_UPNP_NO_DEBUG -D_WINSOCK_H
endif

Cdefined += -DTCPDEBUG=$(TCPDEBUG) -D_USE_GDMA
#Cdefined += -DTASKMEMALLOC=$(TASKMEMALLOC) -DVARSIZEMEMALLOC=$(VARSIZEMEMALLOC) -DNUM_OF_B0=$(NUM_B0) -DNUM_OF_B1=$(NUM_B1) -D_PROJECT=$(PROJECT)
Cdefined += -DTASKMEMALLOC=$(TASKMEMALLOC) -DVARSIZEMEMALLOC=$(VARSIZEMEMALLOC) -D_PROJECT=$(PROJECT)

ifneq "$(strip $(_VOIP))" "0"
	Cdefined += -D_VOIP -DSUPERTASK -DMAX_VOIP_PORT=$(_MAX_VOIP_PORT)
endif

ifeq "$(strip $(_VOICE_DRV))" "1"
	Cdefined += -DVOICEPUMP -DSUPERTASK -DARCADYAN_VOIP
endif

ifeq "$(strip $(_VOICE_DRV))" "2"
	Cdefined += -DVINETIC -DSUPERTASK -DARCADYAN_VOIP
endif

ifeq "$(strip $(_H323))" "1"
	Cdefined += -D_H323
endif

ifeq "$(strip $(_SIP))" "1"
	Cdefined += -D_ST_ -D_SIP=1
endif

ifeq "$(strip $(_ENCRYPT_CONFIG))" "1"
	Cdefined += -D_ENCRYPT_CONFIG
endif

#_SIP == 2 means ITRI-Arcadyan SIP module. needs defining VOICEPUMP, too, even _VOICE_DRV is 0.
ifeq "$(strip $(_SIP))" "2"
	Cdefined += -D_ST_ -D_SIP=2
	
ifeq "$(strip $(_VOICE_DRV))" "0"
	Cdefined += -DVOICEPUMP
endif
	
endif

ifneq "$(strip $(_BIGPOND))" "0"
    Cdefined += -D_BIGPOND
endif

ifneq "$(strip $(_XMODEM))" "0"
    Cdefined += -D_XMODEM
endif

ifneq "$(strip $(_DT))" "0"
    Cdefined += -D_DT
endif

ifeq "$(strip $(_UCP))" "1"
    Cdefined += -D_UCP
endif

ifneq "$(strip $(_DECT))" "0"
	Cdefined += -D_DECT=$(_DECT)
endif
