
// Name of File : UsbSysInit.c
// ====================================================================

#define __USB_SYS_INIT_C__

// ====================================================================

#ifdef _NEWLIB
	#include "string.h"
#endif
#include "EtcpipDbg.h" // 2002/10/25 B. S. Liaw
          // for deciding whether to compile
          //  Debug Version or Release Version
#include "etcpip.h"
#include "UsbCfg.h" // Config and Setting
#include "UsbDbg.h"
// #include "UsbLptIo.h"
// #include "UsbMacIo.h"
#include "UsbSysInit.h"

#ifdef _USB_SYSLOG
	#include "syslog.h"
	#include "logStr.h"
	#include "config.h"
	extern struct III_Config_t gSetting;
 #else
	// #error: Please Make Sure : Not _USB_SYSLOG !!
	//#warning: Not _USB_SYSLOG !!
#endif // _USB_SYSLOG


// ====================================================================

// for enable ISR
int usb_device_count = 0 ; // >= 1 : enable ISR

// for Web UI message 
char usb_info_str[128] = "No Device !! " ;

// #ifdef _USB_SYSLOG
//    extern char usbsyslog_buf[128];
// #endif // _SYSLOG

// ====================================================================

void UsbSysInitTask(void)
{
 int x ;
{
extern unsigned long get_data_segment(void);
extern void set_data_segment(unsigned long new_gp);
set_data_segment(get_data_segment());
}
while (1) {
dprintf("test 1\n");
iprintf("test 2\n");
dlytsk(cur_task, DLY_TICKS, 1000);
}
 /*
 #ifdef _USB_SYSLOG
    char usbsyslog_buf[100];
 #endif // _SYSLOG
 */
 
 #ifdef USB_BS_SYSCAL_ASSERT
	if (!(  mt_busy == 0
         )
	   ) {
		iprintf("[ASSERT][USB] UsbSysInitTask() : " ) ;
	    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
	    iprintf("[ASSERT][USB] Continue ..\n") ;
	   }
 #endif // USB_BS_ASSERT

 #ifdef USB_DBG_MEM_AREA_VERIFY_ON
	BackUpMemArea() ;
 #endif // USB_DBG_MEM_AREA_VERIFY_ON

 #ifdef USB_DBG_MEM_AREA_VERIFY_ON
	USB_DBG_AREA_MSG(iprintf("[USB AREA] UsbSysInitTask() : Verify Memory Area ..\n")) ;
		if (! VerifyMemArea() ) {
			iprintf("[USB] UsbSysInitTask(1) Verify Memory Area Error !\n") ;
	       }
 #endif // USB_DBG_MEM_AREA_VERIFY_ON

 for(x=0;x<128;x++) {
	usb_info_str[x] = 0x00 ;
   }
   
// iprintf("[USB] No Device !! \n");

 sprintf(usb_info_str, "No Device !! ");

 #ifdef _USB_SYSLOG
    //sprintf(usbsyslog_buf,"[USB] No Device !! ");
	#if (_SYSLOG==2)
		if (gSetting.syslog_ds.syslog_enable==1) 
	#endif // _SYSLOG==2
		   {
			#ifdef USB_SYS_LOG_NO_DEV
	    		//sprintf_SetSystemLog(USB_SYS_LOG_NO_DEV);
	    		sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, USB_SYS_LOG_NO_DEV);
			#else
	    		//sprintf_SetSystemLog("[USB] No Device !! ");
    			sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, "[USB] No Device !! ");
			#endif // USB_SYS_LOG_NO_DEV
		   }
 #endif // _USB_SYSLOG

 usb_device_count = 0 ; // >= 1 : enable ISR

 /*
 // 2003/09/19 B. S. Liaw , comment out for glob_localhc now NULL !!
 #if defined(USB_INT_SCHEDULING) || defined(USB_INT_ON_DEMAND)
	UsbDisableInt() ;
  #else
	#if defined(_S3C2510)
    	#error : SS2510 Need Define USB_INT_ON_DEMAND !!
    #endif
 #endif // USB_INT_ON_DEMAND
 */
 
 #ifdef USB_DBG_MEM_AREA_VERIFY_ON
	USB_DBG_AREA_MSG(iprintf("[USB AREA] UsbSysInitTask() : Verify Memory Area ..\n")) ;
		if (! VerifyMemArea() ) {
			iprintf("[USB] UsbSysInitTask(2) Verify Memory Area Error !\n") ;
	       }
 #endif // USB_DBG_MEM_AREA_VERIFY_ON
 
 USB_DBG_INIT(iprintf("[INIT] UsbSysInitTask() ====== call usb_init() ... \n"));
 usb_init() ;   // on core/usb.c
 USB_DBG_INIT(iprintf("[INIT] UsbSysInitTask() ====== after call usb_init() \n"));

 #ifdef USB_DBG_MEM_AREA_VERIFY_ON
	USB_DBG_AREA_MSG(iprintf("[USB AREA] UsbSysInitTask() : Verify Memory Area ..\n")) ;
		if (! VerifyMemArea() ) {
			iprintf("[USB] UsbSysInitTask(3) Verify Memory Area Error !\n") ;
	       }
 #endif // USB_DBG_MEM_AREA_VERIFY_ON



 USB_DBG_INIT(iprintf("[INIT] UsbSysInitTask() ====== call usb_hcd_init() \n"));
 usb_hcd_init() ; // on hcdx-init.c / ohci-pci.c / sota-init.c
 USB_DBG_INIT(iprintf("[INIT] UsbSysInitTask() ====== after call usb_hcd_init() \n"));

     
 #ifdef USB_DBG_MEM_AREA_VERIFY_ON
	USB_DBG_AREA_MSG(iprintf("[USB AREA] UsbSysInitTask() : Verify Memory Area ..\n")) ;
		if (! VerifyMemArea() ) {
			iprintf("[USB] UsbSysInitTask(4) Verify Memory Area Error !\n") ;
	       }
 #endif // USB_DBG_MEM_AREA_VERIFY_ON

 // #if !defined(_NB_SHARE) && (_LPD <= 0) && (_USB_MAC <= 0)
 //#if !defined(_NB_SHARE) && (_LPD <= 0)
/* 
	USB_DBG_INIT(iprintf("[USB INIT] UsbSysInitTask(1) ====== call usb_mouse_init() ... \n"));
    usb_mouse_init() ;
	USB_DBG_INIT(iprintf("[USB INIT] UsbSysInitTask(2) ====== after call usb_mouse_init() \n"));
 */             
    YIELD();
 //#endif // defined(_NBNS) || defined(_NB_SHARE)

 #ifdef USB_DBG_MEM_AREA_VERIFY_ON
	USB_DBG_AREA_MSG(iprintf("[USB AREA] UsbSysInitTask() : Verify Memory Area ..\n")) ;
		if (! VerifyMemArea() ) {
			iprintf("[USB] UsbSysInitTask(5) Verify Memory Area Error !\n") ;
	       }
 #endif // USB_DBG_MEM_AREA_VERIFY_ON

 #if (_USB_MAC >= 1)
	USB_DBG_INIT(iprintf("[USB INIT] UsbSysInitTask(3) ====== call usbmac_io_init() ... \n"));
	usbmac_io_init() ;
	USB_DBG_INIT(iprintf("[USB INIT] UsbSysInitTask(4) ====== after call usbmac_io_init() \n"));
    
    YIELD();
 #endif // _USB_MAC

 #ifdef USB_DBG_MEM_AREA_VERIFY_ON
	USB_DBG_AREA_MSG(iprintf("[USB AREA] UsbSysInitTask() : Verify Memory Area ..\n")) ;
		if (! VerifyMemArea() ) {
			iprintf("[USB] UsbSysInitTask(6) Verify Memory Area Error !\n") ;
	       }
 #endif // USB_DBG_MEM_AREA_VERIFY_ON

 /*
 #if (_USB_LPT >= 1)
	USB_DBG_INIT(iprintf("[USB INIT] UsbSysInitTask(5) ====== call usblp_init() ... \n"));
	usblp_init() ;
	USB_DBG_INIT(iprintf("[USB INIT] UsbSysInitTask(6) ====== after call usblp_init() \n"));
    
    YIELD();
 #endif // _USB_LPT
 */

 #if (_USB_MS >= 1)

	// USB Mass Storage Class
	USB_DBG_INIT(iprintf("[USB INIT] UsbSysInitTask(7) ====== call UsbMsInit() ... \n"));
	USB_DBG_INFO(iprintf("[USB INFO] UsbSysInitTask(7) ====== call UsbMsInit() ... \n"));
	UsbMsInit() ; // on storage/UsbMsInit.c
	USB_DBG_INIT(iprintf("[USB INIT] UsbSysInitTask(8) ====== after call UsbMsInit() \n"));
	USB_DBG_INFO(iprintf("[USB INFO] UsbSysInitTask(8) ====== after call UsbMsInit() \n"));
    // YIELD();

 #endif // _USB_MS
 
 #if (_USB_LPT >= 1)
	USB_DBG_INIT(iprintf("[USB INIT] UsbSysInitTask(9) ====== call usblp_init() ... \n"));
	usblp_init() ;
	USB_DBG_INIT(iprintf("[USB INIT] UsbSysInitTask(10) ====== after call usblp_init() \n"));
    
    YIELD();
 #endif // _USB_LPT
 

 #ifdef USB_DBG_MEM_AREA_VERIFY_ON
	USB_DBG_AREA_MSG(iprintf("[USB AREA] UsbSysInitTask() : Verify Memory Area ..\n")) ;
		if (! VerifyMemArea() ) {
			iprintf("[USB] UsbSysInitTask(7) Verify Memory Area Error !\n") ;
	       }
 #endif // USB_DBG_MEM_AREA_VERIFY_ON

 #ifdef USB_BS_SYSCAL_ASSERT
	if (!(  mt_busy == 0
         )
	   ) {
		iprintf("[ASSERT][USB] UsbSysInitTask() : " ) ;
	    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
	    iprintf("[ASSERT][USB] Continue ..\n") ;
	   }
 #endif // USB_BS_ASSERT
             
} // funciton UsbSysInitTask()

// ====================================================================

void UsbSysInit(void) {
 int status1 ;


 USB_DBG_FLOW(iprintf("[USB FLOW] UsbSysInit() Begin.. \n"));

 #ifdef INT_SCHEDULING
		status1 = runtsk(100, (void (fAR *)(void))UsbSysInitTask, 6000);
  #else
		status1 = runtsk(80, (void (fAR *)(void))UsbSysInitTask, 6000);
 #endif // INT_SCHEDULING

 if (status1 < SUCCESS ) {
	dprintf("RUNTASK UsbSysInitTask fails\n");
    // goto exi2;
   }
  else {
     dprintf("RUNTASK id=%d UsbSysInitTask ...\n", status1);
   }
   
 USB_DBG_FLOW(iprintf("[USB FLOW] UsbSysInit() End.\n"));
}

#ifdef _USB_SYSLOG
   /*
   // integer only printf, supports subset of printf for strings,
   // and integer, or long printing in hex/decimal
   
   void usbsyslog_printf(char *fmt, ...)
   {
	#ifdef _USB_SYSLOG
	    extern char usbsyslog_buf[128];
	#endif // _SYSLOG

    char pf_buf[MAXPFLEN];
    //int count;
    char *p;
    va_list args;
    char cc;

    if (debug_act != 0) {
        memset(pf_buf, 0, MAXPFLEN);
        va_start(args,fmt);
        //count = visprintf(pf_buf, fmt, args);
        visprintf(pf_buf, fmt, args);
        pf_buf[MAXPFLEN-1] = 0;     // give buffer overflow clue 
        p = pf_buf;
        if (debug_rt_disp) {
            BLOCK_PREEMPTION;
            while( *p ) {
#ifdef  __LOG
//              log_putchr(*p++);
#endif
#ifdef VISUALC
                SCRputchr(*p++);      // output to screen in protected mode 
#else
#if defined(_NETARM) || defined(_HNP) || defined(ADMtek) || defined(_ATHEROS)
#ifdef _ADM5120
				uart_putc(*p++);
#else
				putchr(*p++);
#endif
#elif defined(_WP3200)
				uart_putc(*p++);
#else
//              Nsputchr(*p++);	// output to COM2 
                Nputchr(*p++);
#endif
#endif
            }
            UNBLOCK_PREEMPTION;;
        }
        //return count;
    //} else {
        //return 0;
    }
   }
   */
#endif // _USB_SYSLOG


// ====================================================================

// End of File : UsbSysInit.c
