/*
 * message.c - synchronous message handling
 */
// #ifdef _ETCPIP
#define __KERNEL__

    #ifdef _NEWLIB
      #include "string.h"
    #endif
#include "EtcpipDbg.h" // 2002/10/25 B. S. Liaw
      // for deciding whether to compile
      //  Debug Version or Release Version
#include "etcpip.h"

#include "UsbDbg.h"

#include "PoList.h" // osport_list.h

#include "UsbCfg.h" // Config and Setting
#include "UsOsport.h" // "usb_osport.h"
#ifndef NO_TIMER
	#include "PoTimer.h" // osport_timer.h
#endif // ndef NO_TIMER

#ifndef NO_WAITQUEUE
	#include  "PoWait.h" // osport_wait.h
#endif // ndef NO_WAITQUEUE

//#include "irqs.h" // for nUSB_HOST  13 USB HOST Interrupt  0x D
//#include "isr.h" // for nUSB_HOST  13 USB HOST Interrupt  0x D
//#include "CfgIsr.h"
// #endif // _ETCPIP



#ifndef _ETCPIP
	#include <linux/pci.h>	/* for scatterlist macros */
#else
    #include "PoDevice.h" // osport_device.h
	#ifdef CONFIG_PCI
	    #include "UsbPoPci.h" // usb_osport_pci.h
    #endif	// CONFIG_PCI
#endif

#ifndef _ETCPIP
   #include <linux/usb.h>
 #else
   #include "usb.h"
#endif
#ifndef _ETCPIP
	#include <linux/module.h>
	#include <linux/slab.h>
	#include <linux/init.h>
	#include <linux/mm.h>
	#include <asm/byteorder.h>
#endif // ndef _ETCPIP



#include "UsbHcd.h"  // ../core/hcd.h , for usbcore internals

// 2003/10/23 B. S. Liaw , for urb_priv_t
/*
#if defined(USB_OHCI)
	#include "ohci.h"  // not usb-ohci.h
#elif defined(USB_SOTA) // Sota USB 1.1 Host
	#include "sota.h"
#endif
*/
#include "hcdx.h" // ohci.h not usb-ohci.h , sota.h

#ifdef USB_MEM_LIB
	#include "UsMemLib.h" // UsbMemLib.h
#endif // USB_MEM_LIB

#ifdef _USB_SYSLOG
	#include "syslog.h"
	#include "logStr.h"
	#include "config.h"
	extern struct III_Config_t gSetting;
 #else
	// #error: Please Make Sure : Not _USB_SYSLOG !!
	//#warning: Not _USB_SYSLOG !!
#endif // _SYSLOG



#ifndef _ETCPIP
	/*
	struct usb_api_data {
	 #ifndef NO_WAITQUEUE
		wait_queue_head_t wqh;
	 #endif // ndef NO_WAITQUEUE
	 int done;
	};
    */
#else
   	// unsigned int global_awd_done = 0 ;
   	int global_awd_done = 1 ;
	/*
	#ifndef USB_NO_ABC // use usb_api_blocking_completion()
	   unsigned int awd_done = 0 ;
   	#endif // ndef USB_NO_ABC
	*/
#endif // def _ETCPIP


/*-------------------------------------------------------------------*
 * completion handler for compatibility wrappers (sync control/bulk) *
 *-------------------------------------------------------------------*/


// ====================================================================

// #ifdef USB_NO_ABC // No usb_api_blocking_completion()
   void usb_urb_complete(struct urb *urb)
   {

	// USB_DBG_FLOW(iprintf(
	//    "[USB FLOW]  usb_api_blocking_completion() Begin ..\n")) ;
	USB_DBG_CALLBACK(iprintf("[USB CALLBACK] usb_urb_complete() Begin ..\n")) ;

	if (in_interrupt()) {
		USB_DBG_INIT(iprintf("[USB INIT] usb_urb_complete() Begin ..\n")) ;
		// USB_DBG_INFO(iprintf("[USB INFO] usb_urb_complete() Begin ..\n")) ;
	   }

	#ifdef USB_BS_ASSERT
		if ( !( (unsigned long) urb > (unsigned long) 0x010000L
    	      )
	       )
    	   {
	    	iprintf("[ASSERT][USB] usb_urb_complete() : " ) ;
    	    iprintf("Error : invalid urb %08XH !! \n",urb) ;
			iprintf("[ASSERT][USB] Continue .. \n" ) ;
		   }
	#endif

  USB_DBG_CALLBACK(iprintf(
	"[USB CALLBACK] usb_urb_complete() : urb->awd_done=%d \n", urb->awd_done )) ;
 /*
 USB_DBG_INIT(iprintf(
	"[USB INIT] usb_urb_complete() : urb->awd_done=%d \n", urb->awd_done )) ;
 */
 USB_DBG_URB_INFO(iprintf(
	"[USB URB_INFO] usb_urb_complete() : urb->awd_done=%d \n", urb->awd_done )) ;

 if(   (urb->awd_done == 0)
	&& (urb->awd_done_old == 0)
   ) {
	USB_DBG_CALLBACK(iprintf(
		"[USB CALLBACK] usb_urb_complete() : Not Do urb->awd_done !! \n" )) ;
	USB_DBG_INFO(iprintf(
		"[USB INFO] usb_urb_complete() : Not Do urb->awd_done !! \n" )) ;
	/*
	USB_DBG_INFO(iprintf(
		"[USB INFO] usb_urb_complete() : Not Do urb->awd_done !! \n" )) ;
	*/
	return ;
   }

	#ifdef USB_BS_ASSERT
		// 2003/7/14 B. S. Liaw
		if (!(     (urb->awd_done > 0)
                && (urb->awd_done_old > 0)
				&& (   (    urb->awd_done
                         == urb->awd_done_old
                       )
                    || (    urb->awd_done
                         == ~urb->awd_done_old
                       )
                   )
    	     )
	       )
		   {
			iprintf("[ASSERT][USB] usb_urb_complete() : " ) ;
    	    iprintf("Error : Invalid call seguence : %d %d !!\n", urb->awd_done, urb->awd_done_old) ;
	        iprintf("[ASSERT][USB] Continue ..\n") ;
    	   }
	#endif
    /*
	if (urb->awd_done > 0)
       {
		urb->awd_done = ~(urb->awd_done) ;
       }
    */
	urb->awd_done = ~(urb->awd_done_old) ;

 	 USB_DBG_CALLBACK(iprintf("[USB CALLBACK] usb_urb_complete() : Set Value : urb->awd_done=%d \n",
    	urb->awd_done
        )) ;
	if (in_interrupt()) {
		USB_DBG_INIT(iprintf("[USB INIT] usb_urb_complete() End.\n")) ;
		// USB_DBG_INFO(iprintf("[USB INFO] usb_urb_complete() End.\n")) ;
	   }
   } // functin usb_urb_complete()

   static void usb_null_callback(struct urb *urb)
   {
	USB_DBG_CALLBACK(iprintf("[USB CALLBACK] usb_null_callback() : 666 !!\n")) ;
   }

// #endif // USB_NO_ABC



// ====================================================================

#ifndef USB_NO_ABC

#ifndef _ETCPIP
/*
static void usb_api_blocking_completion(struct urb *urb, struct pt_regs *regs)
*/
#else
static void usb_api_blocking_completion(struct urb *urb)
#endif
{
 #ifndef _ETCPIP
  /*
  struct usb_api_data *awd = (struct usb_api_data *)urb->context;
                     // context : context for completion routine
  */
 #else
   int *awd_done = (unsigned int *)urb->context;
 #endif

 // USB_DBG_FLOW(iprintf(
 //    "[USB FLOW]  usb_api_blocking_completion() Begin ..\n")) ;
 USB_DBG_CALLBACK(iprintf(
          "[USB CALLBACK] usb_api_blocking_completion Begin ..\n")) ;
 #ifndef _ETCPIP
 	/*
	awd->done = 1; // context : context for completion routine
    */
  #else
	#ifdef USB_BS_ASSERT
		// 2003/7/14 B. S. Liaw
		if (!( (*awd_done) > 0
    	     )
	       )
		   {
			iprintf("[ASSERT][USB] usb_api_blocking_completion() : " ) ;
    	    iprintf("Error : Called More than once !!\n" ) ;
	        iprintf("[ASSERT][USB] Continue ..\n") ;
    	   }
	#endif

 	 USB_DBG_CALLBACK(iprintf(
		"[USB CALLBACK] usb_api_blocking_completion() : *awd_done=%d "
        "\n",
    	*awd_done
        )) ;

	*awd_done = ~(*awd_done) ;

 	 USB_DBG_CALLBACK(iprintf(
		"[USB CALLBACK] usb_api_blocking_completion() : Set Value : *awd_done=%d "
        "\n",
    	*awd_done
        )) ;
 #endif
 #ifndef _ETCPIP
 	/*
	wmb();
    */
 #endif // ndef _ETCPIP

 #ifndef NO_WAITQUEUE
 	/*
	wake_up(&awd->wqh);
    */
 #endif // ndef NO_WAITQUEUE
}
#endif // ndef USB_NO_ABC

// ====================================================================

// Starts urb and waits for completion or timeout
// This doNot Free urb
// not call usb_free_urb(urb) or usb_unlink_urb(urb)

int usb_start_wait_urb_nf(struct urb *urb, unsigned long timeout,
	// int need_longer_wait,
	int* actual_length)
{
 // 2003/5/7 B. S. Liaw : Donot Try to put this as local vaiable !!
 // unsigned int awd_done ;

 int status;
 // #ifdef _ETCPIP
	unsigned long int wait_timeout = 0 ;
 // #endif // ndef _ETCPIP
 #ifdef USB_NO_ISR_FREE
	struct usb_hcd		*hcd = urb->dev->bus->hcpriv_hcd;
 #endif // USB_NO_ISR_FREE
 int xxx ;
 // int yyy ;
 // unsigned long start_time = 0L;
 unsigned long start_time ;
 int	status_unlink;
 #ifdef USB_WAIT_BY_EVENT  // 2003/12/31 B. S. Liaw
	int i ;
 #endif // USB_WAIT_BY_EVENT
 #if _USB2 == 1	// VIA vt6212
 	int dev_idx;
 #endif


 // USB_DBG_INIT(iprintf(
 //    "[USB INIT] usb_start_wait_urb_nf() Begin ..\n"));
 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_start_wait_urb_nf() Begin ..\n"));


 start_time = 0L;

 #ifndef NO_WAITQUEUE
        #error : Please Make Sure : Not NO_WAITQUEUE
        init_waitqueue_head(&awd.wqh);
  #else
        // #error : Please Make Sure : NO_WAITQUEUE
 #endif // ndef NO_WAITQUEUE

 #ifdef USB_RES_SEMPHORE    // use MT_RES_USB semphore
	USB_DBG_CTLMSG(iprintf(
    	"[USB CTLMSG] usb_start_wait_urb_nf() : get USB Resource ..\n"
        ));
	//USB_DBG_INIT(iprintf(
    //	"[USB INIT] usb_start_wait_urb() : get USB Resource ..\n"
    //    ));
	for (;;)
	   {
		//USB_DBG_INIT(iprintf(
        //	"[USB INIT] usb_start_wait_urb() : get USB Resource ..\n"
        //    ));
	    if (getres(MT_RES_USB, 1000) == 0)
           {
            break ;
           }
          else
	       {
	        iprintf("[USB] usb_start_wait_urb_nf() : getres Fail !!") ;
	        continue ;
	       }
	   } // infinite for
 #endif


 wait_timeout  = 0 ;

 USB_DBG_URB(iprintf(
	"[USB URB] usb_start_wait_urb_nf() : before , wait_timeout =%d \n "
    , wait_timeout
	)) ;

 // 2003/3/25 B. S. Liaw
 urb->status = 0 ;

 #ifdef USB_WAIT_BY_EVENT  // 2003/12/31 B. S. Liaw
	// MT_EVT_USB is on kernel/local.h
    if (clrevt(MT_EVT_USB) != SUCCESS) {
		USB_DBG_INFO(iprintf(
			"[USB INFO] usb_start_wait_urb_nf() : Error : clrevt fail: Invalid MT_EVT_USB=%d\n",
			MT_EVT_USB
			)) ;
        dprintf("[USB] Error : clrevt fail: Invalid MT_EVT_USB %d\n",
				MT_EVT_USB);
	   }
 #endif // USB_WAIT_BY_EVENT

#if (_USB2 == 1)
 usb_hc_task_lock();
#endif	// defined (_USB2)
 status = usb_submit_urb(urb);

 /*
 iprintf("[USB] ---------------------------------------------\n") ;
 iprintf("[USB] usb_start_wait_urb() after usb_submit_urb() -\n") ;
 iprintf("[USB] ---------------------------------------------\n") ;
 */
 if (status) {
	// something went wrong
    USB_DBG_CTLMSG(iprintf(
        "[USB CTLMSG] usb_start_wait_urb_nf() usb_submit_urb Fail %d !!\n"
        ,status
        ));

	USB_DBG_FLOWTIMCRY(iprintf(
		"[USB FLOWTIMCRY] usb_start_wait_urb_nf() call usb_free_urb() "
        "..\n"
    	));

	// This Donot free urb
	// usb_free_urb(urb);
	/*
    #ifndef _ETCPIP
        set_current_state(TASK_RUNNING);
    #endif
	*/
	/*
	#ifndef NO_WAITQUEUE
		remove_wait_queue(&awd.wqh, &wait);
	#endif // ndef NO_WAITQUEUE
	*/
    USB_DBG_CTLMSG(iprintf(
        "[USB CTLMSG] usb_start_wait_urb_nf() End with Fail !!\n"));
    USB_DBG_INFO(iprintf(
		"[USB INFO] usb_start_wait_urb_nf(1) : usb_submit_urb Fail !!\n"));

#if (_USB2 == 1)
    usb_hc_task_unlock();
#endif	// defined (_USB2)
	return status;
   }

 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_start_wait_urb_nf() : wait ..\n"));
 USB_DBG_CTLMSG(iprintf(
    	"[USB CTLMSG] usb_start_wait_urb_nf() : wait .. wait_timeout =%d , global_awd_done=%d\n",
    	wait_timeout,global_awd_done));

 #ifdef USB_BS_SYSCAL_ASSERT
	if (!(  mt_busy == 0
       ) ) {
		iprintf("[ASSERT][USB] usb_start_wait_urb_nf() : " ) ;
	    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
	    iprintf("[ASSERT][USB] Continue ..\n") ;
	   }
 #endif // USB_BS_SYSCAL_ASSERT

 #ifdef USB_WAIT_BY_EVENT  // 2003/12/31 B. S. Liaw
	USB_DBG_INIT(iprintf("[USB INIT] usb_start_wait_urb_nf() *** task sleeping \n")) ;
	/*
	(void)wteset_dec(MT_EVT_USB, 0); // 0 : no timeout
	*/
	i=wteset_dec(MT_EVT_USB, timeout*CLOCKHZ);

	USB_DBG_INIT(iprintf("[USB INIT] usb_start_wait_urb_nf() *** task awakened \n")) ;

	// MT_EVT_USB is on kernel/local.h
    if (clrevt(MT_EVT_USB) != SUCCESS) {
		USB_DBG_INFO(iprintf(
			"[USB INFO] usb_start_wait_urb_nf() : Error : clrevt fail: Invalid MT_EVT_USB=%d\n",
			MT_EVT_USB
			)) ;
        dprintf("[USB] Error : clrevt fail: Invalid MT_EVT_USB %d\n",
				MT_EVT_USB);
	   }
	if (i==SUCCESS) {
		goto wait_end_ok ;
	   }
	  else {
		wait_timeout = timeout ; // force time out
		goto wait_end ;
	   }

 #endif // USB_WAIT_BY_EVENT

 // wait_timeout  = 0 ;

#if _USB2 == 1	// VIA vt6212
	dev_idx = ((struct usb_hcd *)(urb->dev->bus->hcpriv_hcd))->dev_idx_for_polling;
#endif
 // B. S. Liaw : for Turbo
 for  (xxx = 0 ; xxx < (2*uSEC_TIMEOUT_LOOP) ; xxx ++ ) {
	#ifdef SOTA_SOFT_ISR   // 2004/1/7 B. S. Liaw
		#ifndef USB_HC_WAIT_BY_EVENT
			sota_soft_isr() ;
		#endif // ndef USB_HC_WAIT_BY_EVENT
	#endif // SOTA_SOFT_ISR
	#ifdef TNV105_INTBUG  /* After running a period time, the system can't generate any hardware interrupts! Charles 20040414 */
		TNV105_InterruptPolling();
	#endif
	#if _USB2 == 1	// VIA vt6212
		usb_hc_polling_irq(dev_idx, urb);
	#endif
	if (urb->awd_done == ~urb->awd_done_old) {
    	goto wait_end ;
       }

	scdtsk();	// PTR-TI-0093  2004.11.02
	/*
 	#ifdef USB_INT_SCHEDULING
		#error : Please Donot Define USB_INT_SCHEDULING Now !!
	*/
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
			   ) ) {
				iprintf("[ASSERT][USB] usb_start_wait_urb_nf() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_SYSCAL_ASSERT
	/*
			dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
	#endif // USB_INT_SCHEDULING
	*/
   } // for xxx

 // ----------------------------------------------------------------

 start_time = get_sys_time()/CLOCKHZ;

 /*
 iprintf("[USB] usb_start_wait_urb() : wait_timeout =%d , global_awd_done=%d\n", wait_timeout,global_awd_done);
 */
 while (//    (wait_timeout < timeout)
		//	&&
		(urb->awd_done != ~urb->awd_done_old)
       )
   {
	/*
	for(xxx = 0 ; xxx < 100 ; xxx ++ ) {

		#ifdef SOTA_SOFT_ISR   // 2004/1/7 B. S. Liaw
			#ifndef USB_HC_WAIT_BY_EVENT
				sota_soft_isr() ;
			#endif // ndef USB_HC_WAIT_BY_EVENT
		#endif // SOTA_SOFT_ISR

		if (urb->awd_done == ~urb->awd_done_old)
       	    {
             goto wait_end ;
  	        }
	   } // for xxx

	#ifdef SOTA_SOFT_ISR   // 2004/1/7 B. S. Liaw
			#ifndef USB_HC_WAIT_BY_EVENT
				sota_soft_isr() ;
			#endif // ndef USB_HC_WAIT_BY_EVENT
	#endif // SOTA_SOFT_ISR
	if (urb->awd_done == ~urb->awd_done_old)
       {
        //  break ;
	    goto wait_end ;
       }
	*/
	xxx = 0;
	while (xxx < (2000*uSEC_TIMEOUT_LOOP)) {
		xxx ++;
		#ifdef SOTA_SOFT_ISR   // 2004/1/7 B. S. Liaw
			#ifndef USB_HC_WAIT_BY_EVENT
				sota_soft_isr() ;
			#endif // ndef USB_HC_WAIT_BY_EVENT
		#endif // SOTA_SOFT_ISR
   		#ifdef TNV105_INTBUG  /* After running a period time, the system can't generate any hardware interrupts! Charles 20040414 */
			TNV105_InterruptPolling();
		#endif
		#if _USB2 == 1	// VIA vt6212
			usb_hc_polling_irq(dev_idx, urb);
		#endif
		if (urb->awd_done == ~urb->awd_done_old)
		{
			goto wait_end;
		}
		if ( (get_sys_time()/CLOCKHZ) - start_time >= timeout) {
			wait_timeout = timeout ; // force time out
			goto wait_end;
		}
		dlytsk(cur_task, DLY_TICKS, 1);
	}

   } // while wait

 // ----------------------------
 wait_end:
 // ----------------------------

 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_start_wait_urb_nf() : after wait\n"));
 /*
 USB_DBG_INIT(iprintf(
    "[USB INIT] usb_start_wait_urb() : after wait , "
    "wait_timeout = %d \n",
     wait_timeout
    ));
 */

 USB_DBG_URB(iprintf(
    "[USB URB] usb_start_wait_urb_nf() : after wait , "
    "wait_timeout = %d \n",
     wait_timeout
    ));

 #ifdef USB_BS_ASSERT
	// 2003/4/28 B. S. Liaw
	// if (!( wait_timeout > 0
    if ( !( wait_timeout < timeout
          )
       )
	   {
		iprintf("[ASSERT][USB] usb_start_wait_urb_nf() : " ) ;
        iprintf("Error : Time Out : %d !!\n" , wait_timeout ) ;
        iprintf("[ASSERT][USB] Continue ..\n") ;
       }
 #endif


 #ifdef USB_DBG_ABORT
	// vvv for debug Prefetch/Data Abort Error !!

	#ifndef NO_TIMER
	   dprintf("[TEST] usb_start_wait_urb_nf(1) : jiffies = %08XH\n",jiffies) ;
	#endif // ndef NO_TIMER

   {
	unsigned long * __temp_ptr = 0 ;
	#if !defined(_ADM5120)
        dprintf(
                "[TEST] usb_start_wait_urb_nf(2) :  *000000000H = %08XH \n",
        * __temp_ptr
                );
    #endif
   }
   dprintf("[TEST] usb_start_wait_urb_nf(3) : GetTime() = %08XH\n",
                        GetTime()) ;
   if (!in_interrupt()) {
		dprintf("[TEST] usb_start_wait_urb_nf(4) : dlytsk()/YIELD() ..\n") ;
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_SYSCAL_ASSERT
		#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
				// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
				dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
         #else
            	YIELD();
        #endif
       }
      else
       {
       dprintf("[TEST] usb_start_wait_urb_nf(5) : in interrupt !!\n");
      }
	// ^^^ for debug Prefetch/Data Abort Error !!
 #endif

 // #ifndef USB_DBG_TEMP_DISABLE  // for debug Prefetch Error !!

 USB_DBG_CTLMSG(iprintf(
  	"[USB CTLMSG] usb_start_wait_urb_nf() : after , timeout =%d , global_awd_done=%d\n",
   	timeout,global_awd_done));

 #ifdef USB_NO_ISR_CALLBACK
	if (urb->awd_done == ~urb->awd_done_old) {
			if (urb->callback)
			   {
				USB_DBG_CALLBACK(iprintf("[USB CALLBACK] usb_start_wait_urb_nf() Call urb->callback() ...\n" )) ;

				urb->callback(urb);
			   }
			  else
			   {
				USB_DBG_CALLBACK(iprintf("[USB CALLBACK] usb_start_wait_urb_nf() : Null urb->callback() !! \n" )) ;
			   }
           }
 #endif // USB_NO_ISR_CALLBACK


 #ifdef USB_RES_SEMPHORE    // use MT_RES_USB semphore
	USB_DBG_CTLMSG(iprintf(
    	"[USB CTLMSG] usb_start_wait_urb_nf() : release USB Resource ..\n"
        ));
	//USB_DBG_INIT(iprintf(
    //	"[USB INIT] usb_start_wait_urb() : release USB Resource ..\n"
    //    ));
    relres(MT_RES_USB) ;
 #endif
 // if (    (wait_timeout<=0)
 if(    (wait_timeout >= timeout)
	 && (urb->awd_done != ~urb->awd_done_old)
   )
   {
	USB_DBG_INIT(iprintf(
		"[USB INIT] usb_start_wait_urb_nf() : Error : Time Out !!\n" )) ;
	/*
	iprintf("[USB] Error : Communication Time Out !!\n");

	#ifdef _USB_SYSLOG
	    sprintf(usbsyslog_buf,"[USB] Error : Communication Time Out !! ");
	    SetSystemLog(usbsyslog_buf);
	#endif // _SYSLOG
	*/
#if 0	// bnchen
	switch (((urb_priv_t *)(urb->hcpriv))->ed->type)
	   {
		case PIPE_CONTROL:
			iprintf("[USB] Error : Control Communication Time Out !!\n");

			#ifdef _USB_SYSLOG
			    //sprintf(usbsyslog_buf,
				//	"[USB] Error : Control Communication Time Out !! ");
							#if (_SYSLOG==2)
			if (gSetting.syslog_ds.syslog_enable==1)
			#endif // _SYSLOG==2
				{

				#ifdef USB_SYS_LOG_CTRL_TIMEOUT
					//sprintf_SetSystemLog(USB_SYS_LOG_CTRL_TIMEOUT);
					sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, USB_SYS_LOG_CTRL_TIMEOUT);
				#else
					//sprintf_SetSystemLog("[USB] Error : Control Communication Time Out !! ");
					sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, "[USB] Error : Control Communication Time Out !! ");
				#endif // USB_SYS_LOG_CTRL_TIMEOUT
				}
			#endif // _SYSLOG
			break ;

		case PIPE_BULK:
			iprintf("[USB] Error : Bulk Communication Time Out !!\n");

			#ifdef _USB_SYSLOG
			    //sprintf(usbsyslog_buf,
				//	"[USB] Error : Bulk Communication Time Out !! ");
							#if (_SYSLOG==2)
			if (gSetting.syslog_ds.syslog_enable==1)
			#endif // _SYSLOG==2
				{

				#ifdef USB_SYS_LOG_BULK_TIMEOUT
					//sprintf_SetSystemLog(USB_SYS_LOG_BULK_TIMEOUT);
					sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, USB_SYS_LOG_BULK_TIMEOUT);
				#else
					//sprintf_SetSystemLog("[USB] Error : Bulk Communication Time Out !! ");
					sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, "[USB] Error : Bulk Communication Time Out !! ");
				#endif // USB_SYS_LOG_BULK_TIMEOUT
				}
			#endif // _SYSLOG
			break ;

		case PIPE_INTERRUPT:
			iprintf("[USB] Error : Interrupt Communication Time Out !!\n");

			#ifdef _USB_SYSLOG
			    //sprintf(usbsyslog_buf,
				//	"[USB] Error : Interrupt Communication Time Out !! ");
							#if (_SYSLOG==2)
			if (gSetting.syslog_ds.syslog_enable==1)
			#endif // _SYSLOG==2
				{

				#ifdef USB_SYS_LOG_INTR_TIMEOUT
					//sprintf_SetSystemLog(USB_SYS_LOG_INTR_TIMEOUT);
					sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, USB_SYS_LOG_INTR_TIMEOUT);
				#else
					//sprintf_SetSystemLog("[USB] Error : Interrupt Communication Time Out !! ");
					sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, "[USB] Error : Interrupt Communication Time Out !! ");
				#endif // USB_SYS_LOG_INTR_TIMEOUT
				}
			#endif // _SYSLOG
			break ;
	   }
#endif	// bnchen
    /*
	#ifdef _ETCPIP
		// USB_DBG_INIT(iprintf("[USB INIT] get USB Resource ..\n"));
	    relres(MT_RES_USB) ;
	#endif
    */
	if (urb->status != -EINPROGRESS) {	/* No callback?!! */
		/*
         #ifndef _ETCPIP

			printk(KERN_ERR "usb: raced timeout, "
            	"pipe 0x%x status %d time left %d\n",
                urb->pipe, urb->status, timeout);

         #else
		*/
        iprintf("[USB] Error : raced timeout, pipe 0x%x status %d timeout %d\n",
				urb->pipe, urb->status, timeout);
		#ifdef _USB_SYSLOG
			//sprintf(usbsyslog_buf,
			//		"[USB] Error : raced timeout, status %d timeout %d ",
             //               urb->status, timeout);
						#if (_SYSLOG==2)
			if (gSetting.syslog_ds.syslog_enable==1)
			#endif // _SYSLOG==2
				{

#ifdef USB_SYS_LOG_REACT_TIMEOUT
				//sprintf_SetSystemLog(USB_SYS_LOG_REACT_TIMEOUT, urb->status, timeout);
				sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, USB_SYS_LOG_REACT_TIMEOUT, urb->status, timeout);
#else
				//sprintf_SetSystemLog("[USB] Error : raced timeout, status %d timeout %d ", urb->status, timeout);
				sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, "[USB] Error : raced timeout, status %d timeout %d ", urb->status, timeout);
#endif // USB_SYS_LOG_REACT_TIMEOUT
			}
		#endif // _SYSLOG
		/*
        #endif
		*/

		/* 2003/10/23 B. S. Liaw , Change to -ETIMEDOUT
		 status = urb->status;
		*/
		status = -ETIMEDOUT ;

	   }
      else
       {
		iprintf("[USB] Error : timeout %d !! \n", timeout);
		#ifdef _USB_SYSLOG
		    //sprintf(usbsyslog_buf,"[USB] Error : Control/Bulk timeout !! ");
						#if (_SYSLOG==2)
			if (gSetting.syslog_ds.syslog_enable==1)
			#endif // _SYSLOG==2
				{

#ifdef USB_SYS_LOG_ERR_TIMEOUT
				//sprintf_SetSystemLog(USB_SYS_LOG_ERR_TIMEOUT);
				sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, USB_SYS_LOG_ERR_TIMEOUT);
#else
				//sprintf_SetSystemLog("[USB] Error : timeout !! ");
				sprintf_SetSystemLog(LOG_TYPE_HW_USB_CORE, "[USB] Error : timeout !! ");
#endif // USB_SYS_LOG_ERR_TIMEOUT
			}
		#endif // _SYSLOG

		if ( urb->status != -EINPROGRESS)
           {
			// This Donot free urb
            // dprintf("[USB] usb_start_wait_urb() Call usb_unlink_urb() ...\n") ;
		    // usb_unlink_urb(urb);  // remove urb safely
           }
		// status = -ETIMEDOUT;
		// dprintf("[USB] usb_start_wait_urb() : status = %d -ETIMEDOUT\n",
        //         status );
		status = urb->status;
	   }

	#ifndef USB_NO_ISR_UNLINK
		if (urb->dev != hcd->self.root_hub) {
			// 2003/11/04 B. S. Liaw BugFix
			USB_DBG_INIT(iprintf(
				"[USB INIT] usb_start_wait_urb_nf() : usb_unlink_urb() ..\n"));
			// USB_DBG_INFO(iprintf("[USB INFO] usb_start_wait_urb_nf() : usb_unlink_urb() ..\n"));
			status_unlink = usb_unlink_urb(urb);
			if (status_unlink && status_unlink != -EINPROGRESS) {
				USB_DBG_INFO(iprintf(
				"[USB INFO] usb_start_wait_urb_nf(2) : usb_unlink_urb fail : %d !!\n", status_unlink));
			   }
		   }
	#endif // ndef USB_NO_ISR_UNLINK

   }
  else
   {
	// ----------------------------
	wait_end_ok:
	// ----------------------------
	status = urb->status;
   }

 // dprintf("[USB] usb_start_wait_urb() : status = %d \n",
 //        status ) ;

 // #ifndef USB_DBG_TEMP_DISABLE  // for debug Prefetch Error !!
 if (actual_length)
    {
     USB_DBG_CTLMSG(iprintf(
        "[USB CTLMSG] usb_start_wait_urb_nf() &(urb->actual_length) "
        "= %08XH\n",
        &(urb->actual_length)
        ));
	 *actual_length = urb->actual_length;

	#ifdef USB_DBG_CTLMSG_ON
	    USB_DBG_MEM(iprintf(
	        "[USB MEM] usb_start_wait_urb_nf() actual_length = %08XH\n",
	        actual_length));
	#endif // USB_DBG_CTLMSG_ON

     USB_DBG_CTLMSG(iprintf(
        "[USB CTLMSG] usb_start_wait_urb_nf() *actual_length = %d\n",
        *actual_length));
    }

 // #else
 //   status = -1 ;
 //#endif // ndef USB_DBG_TEMP_DISABLE for debug Prefetch Error !!

 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_start_wait_urb_nf() : status = %d \n",
    status));

 #ifdef USB_DBG_ABORT
	// vvv for debug Prefetch/Data Abort Error !!
	#ifndef NO_TIMER
	   dprintf("[TEST] usb_start_wait_urb_nf(6) 2 : jiffies = %08XH\n",jiffies) ;
	#endif // ndef NO_TIMER
   {
	unsigned long * __temp_ptr = 0 ;
	#if !defined(_ADM5120)
	dprintf(
		"[TEST] usb_start_wait_urb_nf(7) :  *000000000H = %08XH \n",
        * __temp_ptr
		);
    #endif
    }
   dprintf("[TEST] usb_start_wait_urb_nf(8) : GetTime() = %08XH\n",
   			GetTime()) ;
   if(!in_interrupt())
     {
	  dprintf("[TEST] usb_start_wait_urb_nf(9) : dlytsk()/YIELD() ..\n") ;
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
			#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
				// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
				dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
             #else
            	YIELD();
            #endif
     }
    else
     {
      dprintf("[TEST] usb_start_wait_urb_nf(10) : in interrupt !!\n");
     }
	// ^^^ for debug Prefetch/Data Abort Error !!
 #endif

 #ifdef USB_NO_ISR_FREE

	if (urb->dev != hcd->self.root_hub)
	// if (urb->dev != ((struct usb_hcd*)urb->dev->bus->hcpriv)->self.root_hub)
	   {

		#ifdef USB_BS_ASSERT
		if (!(  urb
    	   ) ) {
			iprintf("[ASSERT][USB] usb_start_wait_urb_nf() : " ) ;
		    iprintf("Error : !urb !!\n" ) ;
	        iprintf("[ASSERT][USB] Continue ..\n") ;
		   }

		if (!(  urb->dev
    	   ) ) {
			iprintf("[ASSERT][USB] usb_start_wait_urb_nf() : " ) ;
		    iprintf("Error : !urb->dev !!\n" ) ;
	        iprintf("[ASSERT][USB] Continue ..\n") ;
		   }

		if (!(  (urb->dev->state >= USB_STATE_DEFAULT)
    	   ) ) {
			iprintf("[ASSERT][USB] usb_start_wait_urb_nf() : " ) ;
		    iprintf("Error : urb->dev->state=%d !!\n",urb->dev->state ) ;
        	iprintf("[ASSERT][USB] Continue ..\n") ;
		   }

		if (!(  urb->dev->bus
    	   ) ) {
			iprintf("[ASSERT][USB] usb_start_wait_urb_nf() : " ) ;
		    iprintf("Error : !urb->dev->bus !!\n" ) ;
    	    iprintf("[ASSERT][USB] Continue ..\n") ;
		   }

		if (!(  urb->dev->bus->op
	       ) ) {
			iprintf("[ASSERT][USB] usb_start_wait_urb_nf() : " ) ;
	    	iprintf("Error : !urb->dev->bus->op !!\n" ) ;
	        iprintf("[ASSERT][USB] Continue ..\n") ;
		   }
		#endif // USB_BS_ASSERT

		#ifdef USB_NO_ISR_UNLINK
			// 2003/9/12 B. S. Liaw BugFix
			USB_DBG_INIT(iprintf("[USB INIT] usb_start_wait_urb_nf() : usb_unlink_urb() ..\n"));
			// USB_DBG_INFO(iprintf("[USB INFO] usb_start_wait_urb_nf() : usb_unlink_urb() ..\n"));
			status_unlink = usb_unlink_urb(urb);
			if (status_unlink && status_unlink != -EINPROGRESS) {
				USB_DBG_INFO(iprintf(
					"[USB INFO] usb_start_wait_urb_nf(3) : usb_unlink_urb fail : %d !!\n", status_unlink));
			   }
		#endif // OHCI_ED_SKEP_FIX

		USB_DBG_FLOW(iprintf(
			"[USB FLOW] usb_start_wait_urb_nf() Call hcd->driver->"
	        "urb_free_priv() ...\n"
	    	));
		USB_DBG_FLOWTIMCRY(iprintf(
			"[USB FLOWTIMCRY] usb_start_wait_urb_nf() Call hcd->driver->"
	        "urb_free_priv() ...\n"
    		));

		//USB_DBG_FLOW(iprintf(
		// "[USB FLOW] rh_call_control() call urb_free_priv() ... \n" )) ;

		// urb_free_priv(ohci, urb->hcpriv);
		// ((struct usb_hcd*)urb->dev->bus->hcpriv)->driver->
	    //   urb_free_priv((struct usb_hcd*)urb->dev->bus->hcpriv,
	    //  urb->hcpriv);
		hcd->driver->urb_free_priv(hcd, urb->hcpriv);
		// hcd->driver->urb_free_priv(hcd, urb);
		USB_DBG_URB(iprintf(
			"[USB URB] usb_start_wait_urb_nf() : Set Vaue : urb->hcpriv = 0 ..\n"
	    	));
		urb->hcpriv = NULL;
	   }
 #endif // USB_NO_ISR_FREE

 USB_DBG_FLOWTIMCRY(iprintf(
	"[USB FLOWTIMCRY] usb_start_wait_urb_nf() call usb_free_urb() ..\n"
    ));
 // This Donot free urb
 // usb_free_urb(urb);

 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_start_wait_urb_nf() End.\n"));
#if (_USB2 == 1)
 usb_hc_task_unlock();
#endif	// defined (_USB2)
 return status;
} // function usb_start_wait_urb_nf()

// ====================================================================

/*
// Starts urb and waits for completion or timeout
#ifndef _ETCPIP
        static
#endif // ndef _ETCPIP
int usb_start_wait_urb(struct urb *urb, long int timeout,int* actual_length)
{
 #ifndef NO_WAITQUEUE
        #ifndef _ETCPIP
        DECLARE_WAITQUEUE (wait, current);
     #else
        DECLARE_WAITQUEUE (wait,0);
    #endif
 #endif // ndef NO_WAITQUEUE
 #ifndef _ETCPIP

	// struct usb_api_data awd;

  #else
    // 2003/5/7 B. S. Liaw : Donot Try to put this as local vaiable !!
    // unsigned int awd_done ;
 #endif // ndef _ETCPIP

 int status;
 #ifdef _ETCPIP
   // int pre_timeout ;
   long int wait_timeout ;
 #endif // ndef _ETCPIP
 #ifdef USB_NO_ISR_FREE
	struct usb_hcd		*hcd = urb->dev->bus->hcpriv_hcd;
 #endif // USB_NO_ISR_FREE


 // USB_DBG_INIT(iprintf(
 //    "[USB INIT] usb_start_wait_urb() Begin ..\n"));
 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_start_wait_urb() Begin ..\n"));

 #ifndef _ETCPIP

	// awd.done = 0;

  #else
	// global_awd_done ++ ;
 #endif

 #ifndef NO_WAITQUEUE
        #error : Please Make Sure : Not NO_WAITQUEUE
        init_waitqueue_head(&awd.wqh);
  #else
        // #error : Please Make Sure : NO_WAITQUEUE
 #endif // ndef NO_WAITQUEUE

 #ifdef USB_RES_SEMPHORE    // use MT_RES_USB semphore
	USB_DBG_CTLMSG(iprintf(
    	"[USB CTLMSG] usb_start_wait_urb() : get USB Resource ..\n"
        ));
	//USB_DBG_INIT(iprintf(
    //	"[USB INIT] usb_start_wait_urb() : get USB Resource ..\n"
    //    ));
	for (;;)
	   {
		//USB_DBG_INIT(iprintf(
        //	"[USB INIT] usb_start_wait_urb() : get USB Resource ..\n"
        //    ));
	    if (getres(MT_RES_USB, 1000) == 0)
           {
            break ;
           }
          else
	       {
	        iprintf("[USB] usb_start_wait_urb() : getres Fail !!") ;
	        continue ;
	       }
	   } // infinite for
 #endif

 #ifdef USB_NO_ABC // No usb_api_blocking_completion()

	BLOCK_PREEMPTION;
	global_awd_done ++ ;
    if ((global_awd_done > 10000) || (global_awd_done <0))
       {
        global_awd_done = 0 ;
       }
    urb->awd_done_old = global_awd_done ;
    urb->awd_done = global_awd_done ;
    UNBLOCK_PREEMPTION;

 // #ifndef _ETCPIP
	//awd.done = 0;

  #else
	global_awd_done ++ ;
    if ((global_awd_done > 10000) || (global_awd_done <0))
       {
        global_awd_done = 0 ;
       }
    awd_done = global_awd_done ;
 #endif

 #ifndef _ETCPIP
	set_current_state(TASK_UNINTERRUPTIBLE);
  #else
    // BLOCK_PREEMPTION;
 #endif // ndef _ETCPIP

 #ifndef NO_WAITQUEUE
	add_wait_queue(&awd.wqh, &wait);
 #endif // ndef NO_WAITQUEUE

 wait_timeout  = timeout ;

 //USB_DBG_INIT(iprintf(
 //   "[USB INIT] usb_start_wait_urb() : wait_timeout =%d , "
 //   "global_awd_done=%d\n",
 //   wait_timeout,global_awd_done
 //   )) ;

 USB_DBG_URB(iprintf(
    "[USB URB] usb_start_wait_urb() : wait_timeout =%d , "
    "global_awd_done=%d\n",
    wait_timeout,global_awd_done
    )) ;

 //USB_DBG_INIT(iprintf(
 //   "[USB INIT] usb_start_wait_urb() : ~global_awd_done=%d\n",
 //   ~global_awd_done
 //	));


 USB_DBG_URB(iprintf(
    "[USB URB] usb_start_wait_urb() : ~global_awd_done=%d\n",
    ~global_awd_done
	));

 // 2003/3/25 B. S. Liaw
 urb->status = 0 ;

 #ifdef USB_NO_ABC // No usb_api_blocking_completion()

 //#ifndef _ETCPIP
 //	urb->context = &awd; // context : context for completion routine

  #else
    urb->context = (void *) &awd_done ;
 #endif // ndef _ETCPIP

 #ifndef _ETCPIP

	//status = usb_submit_urb(urb, GFP_ATOMIC);

  #else
	status = usb_submit_urb(urb);
 #endif

 //iprintf("[USB] ---------------------------------------------\n") ;
 //iprintf("[USB] usb_start_wait_urb() after usb_submit_urb() -\n") ;
 //iprintf("[USB] ---------------------------------------------\n") ;

 if (status)
   {
	// something went wrong
    USB_DBG_CTLMSG(iprintf(
        "[USB CTLMSG] usb_start_wait_urb() usb_submit_urb Fail %d !!\n"
        ,status
        ));

	USB_DBG_FLOWTIMCRY(iprintf(
		"[USB FLOWTIMCRY] usb_start_wait_urb() call usb_free_urb() "
        "..\n"
    	));

	usb_free_urb(urb);

    #ifndef _ETCPIP

        //set_current_state(TASK_RUNNING);

      #else
        // UNBLOCK_PREEMPTION;
    #endif

	#ifndef NO_WAITQUEUE
		remove_wait_queue(&awd.wqh, &wait);
	#endif // ndef NO_WAITQUEUE
    USB_DBG_CTLMSG(iprintf(
        "[USB CTLMSG] usb_start_wait_urb() End with Fail !!\n"));
    USB_DBG_INFO(iprintf(
        "[USB INFO] usb_start_wait_urb() End with Fail !!\n"));

	return status;
   }

 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_start_wait_urb() : wait ..\n"));

 #ifndef _ETCPIP
	USB_DBG_CTLMSG(iprintf(
    	"[USB CTLMSG] usb_start_wait_urb() : timeout =%d , awd.done=%d\n",
    	timeout,awd.done));
 #else
	USB_DBG_CTLMSG(iprintf(
    	"[USB CTLMSG] usb_start_wait_urb() : wait_timeout =%d , global_awd_done=%d\n",
    	wait_timeout,global_awd_done));

	//iprintf(
    //	"[USB] usb_start_wait_urb() : wait_timeout =%d , global_awd_done=%d\n",
    //	wait_timeout,global_awd_done);

 #endif

 #ifdef USB_CRITICAL_SECTION
	BLOCK_PREEMPTION;
 #endif // USB_CRITICAL_SECTION


 //#ifdef _ETCPIP
 //	BLOCK_PREEMPTION;
 //   pre_timeout =  USB_PRE_TIMEOUT ;
 //	while (pre_timeout && (awd_done != ~global_awd_done) )
 //	   {
 //   	udelay(1) ;
 //       pre_timeout -- ;
 //	   }
 //	UNBLOCK_PREEMPTION;
 //#endif // _ETCPIP


 wait_timeout  = timeout ;

 //iprintf(
 //   	"[USB] usb_start_wait_urb() : wait_timeout =%d , global_awd_done=%d\n",
 //   	wait_timeout,global_awd_done);


 #ifdef USB_NO_ABC // No usb_api_blocking_completion()
 	while (    (wait_timeout > 0)
		 && (urb->awd_done != ~urb->awd_done_old)
          )

 //#ifndef _ETCPIP

	// while (timeout && !awd.done)

 #else
	while (    (wait_timeout > 0)
            && (awd_done != ~global_awd_done) )
 #endif
   {
    #ifndef _ETCPIP

    	//#ifndef NO_TIMER
        //        timeout = usb_schedule_timeout(timeout);
     	//#else
       	//	#error : Please Make Sure : NO_TIMER
    	//#endif // ndef NO_TIMER

     #else
		if(in_interrupt())
	      {
			// udelay(5000) ;
	    	udelay(1) ;
	      }
	     else
	      {
	        // dprintf("[USB] You call udelay , please replace by wait_ms !!\n") ;
			// dlytsk(cur_task, DLY_TICKS, 1 ) ;
	    	udelay(1) ;
	      }
        wait_timeout -- ;
    #endif

    #ifndef _ETCPIP
		set_current_state(TASK_UNINTERRUPTIBLE);
		rmb();
     #else
        // UNBLOCK_PREEMPTION;
    #endif
	}


 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_start_wait_urb() : after wait\n"));

 //USB_DBG_INIT(iprintf(
 //   "[USB INIT] usb_start_wait_urb() : after wait , "
 //   "wait_timeout = %d \n",
 //    wait_timeout
 //   ));


 USB_DBG_URB(iprintf(
    "[USB URB] usb_start_wait_urb() : after wait , "
    "wait_timeout = %d \n",
     wait_timeout
    ));

 #ifdef USB_BS_ASSERT
	// 2003/4/28 B. S. Liaw
	if (!( wait_timeout > 0
         )
       )
	   {
		iprintf("[ASSERT][USB] usb_start_wait_urb() : " ) ;
        iprintf("Error : Time Out !!\n" ) ;
        iprintf("[ASSERT][USB] Continue ..\n") ;
       }
 #endif

 #ifdef RH_INT_BY_POLL

	//hub_in_submit = 0 ;

	//USB_DBG_ROOTHUB(iprintf("[USB ROOTHUB] usb_start_wait_urb(POLL) : Set Value : hub_in_submit=%d \n", hub_in_submit )) ;

 #endif //RH_INT_BY_POLL

 #ifdef USB_CRITICAL_SECTION
	UNBLOCK_PREEMPTION;
 #endif // USB_CRITICAL_SECTION

 #ifndef _ETCPIP
	set_current_state(TASK_RUNNING);
   #else
     // UNBLOCK_PREEMPTION;
	   #endif // ndef _ETCPIP

 #ifndef NO_WAITQUEUE
	remove_wait_queue(&awd.wqh, &wait);
 #endif // ndef NO_WAITQUEUE

 #ifdef USB_DBG_ABORT
   // vvv for debug Prefetch/Data Abort Error !!

	#ifndef NO_TIMER
	   dprintf("[TEST] usb_start_wait_urb() 1 : jiffies = %08XH\n",jiffies) ;
	#endif // ndef NO_TIMER

   {
        unsigned long * __temp_ptr = 0 ;
	#if !defined(_ADM5120)
        dprintf(
                "[TEST] usb_start_wait_urb() :  *000000000H = %08XH \n",
        * __temp_ptr
                );
    #endif
   }
   dprintf("[TEST] usb_start_wait_urb() : GetTime() = %08XH\n",
                        GetTime()) ;
   if(!in_interrupt())
     {
          dprintf("[TEST] usb_start_wait_urb() : dlytsk()/YIELD() ..\n") ;
			#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
				// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
				dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
             #else
            	YIELD();
            #endif
     }
    else
     {
      dprintf("[TEST] usb_start_wait_urb() : in interrupt !!\n");
     }
   // ^^^ for debug Prefetch/Data Abort Error !!
 #endif

 // #ifndef USB_DBG_TEMP_DISABLE  // for debug Prefetch Error !!

 #ifndef _ETCPIP

	//USB_DBG_CTLMSG(iprintf(
    //	"[USB CTLMSG] usb_start_wait_urb() : timeout =%d , awd.done=%d\n",
    //	timeout,awd.done));

 #else
	USB_DBG_CTLMSG(iprintf(
    	"[USB CTLMSG] usb_start_wait_urb() : timeout =%d , global_awd_done=%d\n",
    	timeout,global_awd_done));
 #endif

 #ifdef USB_RES_SEMPHORE    // use MT_RES_USB semphore
	USB_DBG_CTLMSG(iprintf(
    	"[USB CTLMSG] usb_start_wait_urb() : release USB Resource ..\n"
        ));
	//USB_DBG_INIT(iprintf(
    //	"[USB INIT] usb_start_wait_urb() : release USB Resource ..\n"
    //    ));
    relres(MT_RES_USB) ;
 #endif

 #ifdef USB_NO_ABC // No usb_api_blocking_completion()
	if (    (wait_timeout<=0)
		 && (urb->awd_done != ~urb->awd_done_old)
       )

 //#ifndef _ETCPIP
 //	if (!timeout && !awd.done)

 #else
	if (    (wait_timeout<=0)
         && (awd_done != ~global_awd_done)
       )
 #endif
   {
    dprintf("[USB] usb_start_wait_urb() : Time Out !!\n");

	//#ifdef _ETCPIP
	//	// USB_DBG_INIT(iprintf("[USB INIT] get USB Resource ..\n"));
	//    relres(MT_RES_USB) ;
	//#endif

	 if (urb->status != -EINPROGRESS)
        {	// No callback?!!
         #ifndef _ETCPIP
                          printk(KERN_ERR "usb: raced timeout, "
                            "pipe 0x%x status %d time left %d\n",
                            urb->pipe, urb->status, timeout);
         #else
                          dprintf("[USB] Error : raced timeout, "
                            "pipe 0x%x status %d time left %d\n",
                            urb->pipe, urb->status, timeout);
         #endif
		 status = urb->status;
	    }
       else
        {
         #ifndef _ETCPIP
			   printk("usb_control/bulk_msg: timeout\n");
         #else
			   dprintf("[USB] Error : usb_control/bulk_msg: timeout\n");
         #endif

         if ( urb->status != -EINPROGRESS)
            {
             dprintf("[USB] usb_start_wait_urb() Call usb_unlink_urb() ...\n") ;
		     usb_unlink_urb(urb);  // remove urb safely
            }
		    // status = -ETIMEDOUT;
		    // dprintf("[USB] usb_start_wait_urb() : status = %d -ETIMEDOUT\n",
            //         status );
			status = urb->status;
		}
		}
	 else
	 {

		//	warn("usb_control/bulk_msg: timeout");
		//	usb_unlink_urb(urb);  // remove urb safely
		//	status = -ETIMEDOUT;

	 status = urb->status;
  		}

 // dprintf("[USB] usb_start_wait_urb() : status = %d \n",
 //        status ) ;

 // #ifndef USB_DBG_TEMP_DISABLE  // for debug Prefetch Error !!
	if (actual_length)
    {
     USB_DBG_CTLMSG(iprintf(
        "[USB CTLMSG] usb_start_wait_urb() &(urb->actual_length) "
        "= %08XH\n",
        &(urb->actual_length)
        ));
	 *actual_length = urb->actual_length;

	#ifdef USB_DBG_CTLMSG_ON
	    USB_DBG_MEM(iprintf(
	        "[USB MEM] usb_start_wait_urb() actual_length = %08XH\n",
	        actual_length));
	#endif // USB_DBG_CTLMSG_ON

     USB_DBG_CTLMSG(iprintf(
        "[USB CTLMSG] usb_start_wait_urb() *actual_length = %d\n",
        *actual_length));
    }

 // #else
 //   status = -1 ;
 //#endif // ndef USB_DBG_TEMP_DISABLE for debug Prefetch Error !!

 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_start_wait_urb() : status = %d \n",
    status));

 #ifdef USB_DBG_ABORT
   // vvv for debug Prefetch/Data Abort Error !!
	#ifndef NO_TIMER
	   dprintf("[TEST] usb_start_wait_urb() 2 : jiffies = %08XH\n",jiffies) ;
	#endif // ndef NO_TIMER
   {
	unsigned long * __temp_ptr = 0 ;
	#if !defined(_ADM5120)
	dprintf(
		"[TEST] usb_start_wait_urb() :  *000000000H = %08XH \n",
        * __temp_ptr
		);
    #endif
    }
   dprintf("[TEST] usb_start_wait_urb() : GetTime() = %08XH\n",
   			GetTime()) ;
   if(!in_interrupt())
     {
	  dprintf("[TEST] usb_start_wait_urb() : dlytsk()/YIELD() ..\n") ;
			#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
				// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
				dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
             #else
            	YIELD();
            #endif
     }
    else
     {
      dprintf("[TEST] usb_start_wait_urb() : in interrupt !!\n");
     }
   // ^^^ for debug Prefetch/Data Abort Error !!
 #endif

 //#ifdef _ETCPIP
 //	dprintf("[USB] usb_start_wait_urb() : OHCI_INTR_WDH Enable\n") ;
 //	writel (OHCI_INTR_WDH, &regs->intrenable); // 02H
 //#endif // _ETCPIP

 #ifdef USB_NO_ISR_FREE

	if (urb->dev != hcd->self.root_hub)
	// if (urb->dev != ((struct usb_hcd*)urb->dev->bus->hcpriv)->self.root_hub)
	   {
		USB_DBG_FLOW(iprintf(
			"[USB FLOW] usb_start_wait_urb() Call hcd->driver->"
	        "urb_free_priv() ...\n"
	    	));
		USB_DBG_FLOWTIMCRY(iprintf(
			"[USB FLOWTIMCRY] usb_start_wait_urb() Call hcd->driver->"
	        "urb_free_priv() ...\n"
    		));

	 	//USB_DBG_FLOW(iprintf(
	    // "[USB FLOW] rh_call_control() call urb_free_priv() ... \n" )) ;

	 	// urb_free_priv(ohci, urb->hcpriv);
		// ((struct usb_hcd*)urb->dev->bus->hcpriv)->driver->
        //   urb_free_priv((struct usb_hcd*)urb->dev->bus->hcpriv,
        //  urb->hcpriv);
		hcd->driver->urb_free_priv(hcd, urb->hcpriv);
		// hcd->driver->urb_free_priv(hcd, urb);
		USB_DBG_URB(iprintf(
			"[USB URB] usb_start_wait_urb() : Set Vaue : urb->hcpriv = 0 ..\n"
	    	));
		urb->hcpriv = NULL;
	   }
 #endif // USB_NO_ISR_FREE

 USB_DBG_FLOWTIMCRY(iprintf(
	"[USB FLOWTIMCRY] usb_start_wait_urb() call usb_free_urb() ..\n"
    ));
 usb_free_urb(urb);

 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_start_wait_urb() End.\n"));
 return status;
} // function usb_start_wait_urb()
*/


/*-------------------------------------------------------------------*
 *                         COMPATIBILITY STUFF                       *
 *-------------------------------------------------------------------*/

/*-------------------------------------------------------------------*/
// returns status (negative) or length (positive)
int usb_internal_control_msg(struct usb_device *usb_dev, unsigned int pipe,
			    struct usb_ctrlrequest *cmd,  void *data,
                int len, unsigned long timeout)
{
 struct urb *urb;
 int retv;
 int length = 0 ;


 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_internal_control_msg() Begin ..\n"));

 #ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
       ) ) {
		iprintf("[ASSERT][USB] usb_internal_control_msg() : " ) ;
	    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
	    iprintf("[ASSERT][USB] Continue ..\n") ;
	   }
 #endif // USB_BS_SYSCAL_ASSERT

 #ifdef USB_DBG_ABORT
   // vvv for debug Prefetch Error !!
   dprintf("[TEST] GetTime() = %08XH\n",GetTime()) ;
			#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
				// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
				dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
             #else
            	YIELD();
            #endif
   // ^^^ for debug Prefetch
 #endif // USB_DBG_ABORT

 // #ifndef USB_DBG_TEMP_DISABLE  // for debug Prefetch Error !!
 // BLOCK_PREEMPTION;

 #ifndef _ETCPIP
	urb = usb_alloc_urb(0, GFP_NOIO);
  #else
	urb = usb_alloc_urb(0);
 #endif

 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] urb = %08XH \n",urb));

 if (!urb)
    {
     // UNBLOCK_PREEMPTION;
     USB_DBG_CTLMSG(iprintf(
        "[USB CTLMSG] usb_internal_control_msg() End with Fail -ENOMEM.\n"));
		return -ENOMEM;
    }

 usb_fill_control_urb(urb, usb_dev, pipe, (unsigned char*)cmd,
 		data, len,
		// #ifdef USB_NO_ABC // No usb_api_blocking_completion()
        	usb_null_callback
        // #else
		//	usb_api_blocking_completion
        //#endif
        , 0);

 #ifdef USB_BS_ASSERT
    if  ( !( length == 0
        )  )
        {
         iprintf("[ASSERT][USB] usb_internal_control_msg() : " ) ;
         iprintf("Error : length Not 0 !!\n" ) ;
         iprintf("[ASSERT][USB] Continue ....\n") ;
        }
 #endif // USB_BS_ASSERT

 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_internal_control_msg() length value = %d\n",
    length));

 // #ifndef USB_DBG_TEMP_DISABLE  // for debug Prefetch Error !!
 // retv = usb_start_wait_urb(urb, timeout, &length);
 // This Donot free urb
 /*
 #ifdef USB_WAIT_BY_EVENT  // 2003/12/31 B. S. Liaw
	retv = usb_start_wait_urb_nf(urb, timeout, 1 , &length);
  #else
 */
	retv = usb_start_wait_urb_nf( urb, timeout, // 0 ,
								  &length);
 /*
 #endif
 */

 /*
 dprintf("[USB] usb_internal_control_msg() Call usb_unlink_urb() ...\n") ;
 usb_unlink_urb(urb);  // remove urb safely
 */
 // so, now free urb
 USB_DBG_URB(iprintf("[USB URB] usb_internal_control_msg() Call usb_free_urb() ...\n")) ;
 usb_free_urb(urb);

 /*
 iprintf("[USB] ---------------------------------------------\n") ;
 iprintf("[USB] usb_internal_control_msg() after usb_start_wait_urb() -\n") ;
 iprintf("[USB] ---------------------------------------------\n") ;
 */
 // UNBLOCK_PREEMPTION;

 // #else
 //   retv = -1 ;
 // #endif // ndef USB_DBG_TEMP_DISABLE for debug Prefetch Error !!

 if (retv < 0)
   {
	USB_DBG_CTLMSG(iprintf("[USB CTLMSG] usb_internal_control_msg() : retv = %d \n" , retv )) ;
    USB_DBG_CTLMSG(iprintf("[USB CTLMSG] usb_internal_control_msg() End with Fail.\n"));
	return retv;
   }
  else
   {
	USB_DBG_CTLMSG(iprintf("[USB CTLMSG] usb_internal_control_msg() : length = %d \n" , length )) ;
    USB_DBG_CTLMSG(iprintf(
        "[USB CTLMSG] usb_internal_control_msg() End , length =%d \n",
        length));
	return length;
   }
}

/**
 *	usb_control_msg - Builds a control urb, sends it off and waits for completion
 *	@dev: pointer to the usb device to send the message to
 *	@pipe: endpoint "pipe" to send the message to
 *	@request: USB message request value
 *	@requesttype: USB message request type value
 *	@value: USB message value
 *	@index: USB message index value
 *	@data: pointer to the data to send
 *	@size: length in bytes of the data to send
 *	@timeout: time in jiffies to wait for the message to complete before
 *		timing out (if 0 the wait is forever)
 *	Context: !in_interrupt ()
 *
 *	This function sends a simple control message to a specified endpoint
 *	and waits for the message to complete, or timeout.
 *
 *	If successful, it returns the number of bytes transferred, otherwise a negative error number.
 *
 *	Don't use this function from within an interrupt context, like a
 *	bottom half handler.  If you need an asynchronous message, or need to send
 *	a message from within interrupt context, use usb_submit_urb()
 *      If a thread in your driver uses this call, make sure your disconnect()
 *      method can wait for it to complete.  Since you don't have a handle on
 *      the URB used, you can't cancel the request.
 */
int usb_control_msg(struct usb_device *dev, unsigned int pipe,
		__u8 request, __u8 requesttype,
		__u16 value, __u16 index, void *data, __u16 size,
        unsigned long timeout)
{
	struct usb_ctrlrequest *dr ;

 int ret;


 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] usb_control_msg() Begin ..\n"));

 #ifdef USB_BS_SYSCAL_ASSERT
	if (!(  mt_busy == 0
       ) ) {
		iprintf("[ASSERT][USB] usb_control_msg() : " ) ;
    	iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
		iprintf("[ASSERT][USB] Continue ..\n") ;
       }
 #endif // USB_BS_ASSERT

 #ifdef USB_NO_VMM // no vitrtul memory management
	#ifdef USB_BS_ASSERT
		if (data)
           {
		if ( !(USB_IS_UN_CACHED(data)) ) {
				iprintf("[ASSERT][USB] usb_control_msg() : " ) ;
    		    iprintf("Error : Not Un-Cached !!\n" ) ;
			    iprintf("[ASSERT][USB] data addr = %08XH \n", data ) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
           } // if data
	#endif // USB_BS_ASSERT
 #endif // USB_NO_VMM

 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] (pipe) pipe = %08XH \n",pipe)) ;

 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] (pipe) usb_pipedevice(pipe) = %d \n",
    usb_pipedevice(pipe)
    )) ;

 #ifndef _ETCPIP
 	/*
	if (!dr)
		return -ENOMEM;
    */
  #else
	USB_DBG_MEM(iprintf(
		"[USB MEM] usb_control_msg(1): alloc dr .. \n"
    	));
	// dr = NonCache_contigmalloc(sizeof(devrequest)) ;

    // B. S. Liaw : alloc_mem is on mt_??/USFSup1.c
    //              But now on ap/upnp/upnpport.c
    //              void *alloc_mem(int size)
    //              this will fill all 0s

	/*
    dr = (struct usb_ctrlrequest*)
		#ifdef USB_DBG_MEM_C_ON
			UsbAllocMemC(USB_MEM_C_S,sizeof(struct usb_ctrlrequest)
            				) ;
         #else
          	UsbAllocMemC(USB_MEM_C_S) ;
        #endif
	*/
    // 2003/6/30 B. S. Liaw : dr Need uncached
    dr = (struct usb_ctrlrequest*) UsbAllocMemU(USB_MEM_U_S
				#ifdef USB_DBG_MEM_U_ON
                       , sizeof(struct usb_ctrlrequest)
                #endif
                      );

	#ifdef USB_DBG_CTLMSG_ON
    	USB_DBG_MEM(iprintf(
        	"[USB MEM] usb_control_msg(2) : dr = %08XH \n",
       				dr ));
	#endif // USB_DBG_CTLMSG_ON


    if ( dr == NULL ) {
    	USB_DBG_INFO(iprintf(
        	"[USB INFO] usb_control_msg() : Error : couldn't allocate dr \n"
            )) ;
		dprintf("[USB] Error : Out of Memory \n");
		return -ENOMEM;
	   }
 #endif

 #ifdef USB_DBG_ABORT
   // vvv for debug Prefetch/Data Abort Error !!

	#ifndef NO_TIMER
	   dprintf("[TEST] usb_control_msg() 1 : jiffies = %08XH\n",jiffies) ;
	#endif // ndef NO_TIMER

   {
	unsigned long * __temp_ptr = 0 ;

	#if !defined(_ADM5120)
	dprintf(
		"[TEST] usb_control_msg() :  *000000000H = %08XH \n",
        * __temp_ptr
		);
    #endif
   }
   dprintf("[TEST] usb_control_msg() : GetTime() = %08XH\n",
   			GetTime()) ;
   if(!in_interrupt())
     {
	  dprintf("[TEST] usb_control_msg() : dlytsk/YIELD() ..\n") ;
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
		#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
			// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
			dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
         #else
           	YIELD();
        #endif
     }
    else
     {
      dprintf("[TEST] in interrupt !!\n");
     }
   // ^^^ for debug Prefetch/Data Abort Error !!
 #endif

 dr->bRequestType= requesttype;
 dr->bRequest = request;
 dr->wValue = cpu_to_le16p(&value);
 dr->wIndex = cpu_to_le16p(&index);
 dr->wLength = cpu_to_le16p(&size);

 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] usb_control_msg \n"));

 #ifdef USB_DBG_ABORT
   // vvv for debug Prefetch/Data Abort Error !!

	#ifndef NO_TIMER
	   dprintf("[TEST] usb_control_msg() 2 : jiffies = %08XH\n",jiffies) ;
	#endif // ndef NO_TIMER

   {
	unsigned long * __temp_ptr = 0 ;

	#if !defined(_ADM5120)
		dprintf(
			"[TEST] usb_control_msg() :  *000000000H = %08XH \n",
	        * __temp_ptr
			);
    #endif
   }
   dprintf("[TEST] usb_control_msg() : GetTime() = %08XH\n",
   			GetTime()) ;
   if(!in_interrupt())
     {
	  dprintf("[TEST] usb_control_msg() : dlytsk/YIELD() ..\n") ;
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
		#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
			// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
			dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
         #else
           	YIELD();
        #endif
     }
    else
     {
      dprintf("[TEST] in interrupt !!\n");
     }
   // ^^^ for debug Prefetch/Data Abort Error !!
 #endif


 // #ifndef USB_DBG_TEMP_DISABLE  // for debug Prefetch Error !!
	ret = usb_internal_control_msg(dev, pipe, dr, data, size, timeout);
 //#else
 //  ret = -1 ;
 //#endif // ndef USB_DBG_TEMP_DISABLE for debug Prefetch Error !!

 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] usb_control_msg() : ret = %d \n" , ret )) ;

 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] usb_control_msg() : free dr \n"));

 USB_DBG_MEM(iprintf(
	"[USB MEM] usb_control_msg(3) : free dr .. \n"
    ));

 #ifndef USB_MEM_LIB
 	kfree (dr);
 /*
 #elif defined USB_DBG_MEM_C_ON
    UsbFreeMemC(USB_MEM_C_S,(unsigned char *)dr,
    			 sizeof(struct usb_ctrlrequest)) ;
 #else
    UsbFreeMemC(USB_MEM_C_S,(unsigned char *)dr) ;
 #endif
 */
 #elif defined(USB_DBG_MEM_U_ON)
    // 2003/6/30 B. S. Liaw : dr Need uncached
	UsbFreeMemU(USB_MEM_U_S,(unsigned char *)dr ,
                       sizeof(struct usb_ctrlrequest)
                      );
 #else
    UsbFreeMemU(USB_MEM_U_S,(unsigned char *)dr);
 #endif

 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] usb_control_msg() End. \n"));
 return ret;
}


/**
 *	usb_bulk_msg - Builds a bulk urb, sends it off and waits for completion
 *	@usb_dev: pointer to the usb device to send the message to
 *	@pipe: endpoint "pipe" to send the message to
 *	@data: pointer to the data to send
 *	@len: length in bytes of the data to send
 *	@actual_length: pointer to a location to put the actual length transferred in bytes
 *	@timeout: time in jiffies to wait for the message to complete before
 *		timing out (if 0 the wait is forever)
 *	Context: !in_interrupt ()
 *
 *	This function sends a simple bulk message to a specified endpoint
 *	and waits for the message to complete, or timeout.
 *
 *	If successful, it returns 0, otherwise a negative error number.
 *	The number of actual bytes transferred will be stored in the
 *	actual_length paramater.
 *
 *	Don't use this function from within an interrupt context, like a
 *	bottom half handler.  If you need an asynchronous message, or need to
 *	send a message from within interrupt context, use usb_submit_urb()
 *      If a thread in your driver uses this call, make sure your disconnect()
 *      method can wait for it to complete.  Since you don't have a handle on
 *      the URB used, you can't cancel the request.
 */
#ifndef _ETCPIP
/*
int usb_bulk_msg(struct usb_device *usb_dev, unsigned int pipe,
			void *data, int len, int *actual_length, int timeout)
{
	int retv;
	struct urb *urb;

	if (len < 0)
       {
		return -EINVAL;
       }

	USB_DBG_CTLMSG(iprintf(
    	"[USB CTLMSG] usb_bulk_msg() actual_length = %08XH\n",
    	actual_length));

	// 2003/4/4 B. S. Liaw comment out
	// BLOCK_PREEMPTION;
 #ifndef _ETCPIP
	urb=usb_alloc_urb(0, GFP_KERNEL);
  #else
	urb=usb_alloc_urb(0);
 #endif
	if (!urb)
       {
		// 2003/4/4 B. S. Liaw comment out
   		//  UNBLOCK_PREEMPTION;
		return -ENOMEM;
       }


	USB_DBG_URBBULK(iprintf(
   		"[USB URBBULK] usb_bulk_msg() : FILL_BULK_URB ..\n"
   		));
	usb_fill_bulk_urb(urb, usb_dev, pipe, data, len,
		    usb_api_blocking_completion, 0);


 //	return usb_start_wait_urb(urb,timeout,actual_length);

	retv =   usb_start_wait_urb(urb,timeout,actual_length);

	// 2003/4/4 B. S. Liaw comment out
	// UNBLOCK_PREEMPTION;

	return retv ;
   }
*/
#endif // ndef _ETCPIP

/*-------------------------------------------------------------------*/

static void sg_clean (struct usb_sg_request *io)
{
 if (io->urbs)
   {
	while (io->entries--)
       {
		USB_DBG_FLOWTIMCRY(iprintf(
			"[USB FLOWTIMCRY] sg_clean() call usb_free_urb() ..\n"
    		));
		usb_free_urb (io->urbs [io->entries]);
   	   }
		kfree (io->urbs);
		io->urbs = 0;
	}
	if (io->dev->dev.dma_mask != 0)
       {
		#ifndef NO_SCATTER_LIST
		usb_buffer_unmap_sg (io->dev, io->pipe, io->sg, io->nents);
        #else
		// usb_buffer_unmap_sg (io->dev, io->pipe, io->nents);
        #endif
       }
	io->dev = 0;
}

/*
#ifndef _ETCPIP
	static void sg_complete (struct urb *urb, struct pt_regs *regs)
#else
	static void sg_complete (struct urb *urb)
#endif
{
 struct usb_sg_request	*io = (struct usb_sg_request *) urb->context;
 unsigned long		flags;

 #ifndef NO_SPINLOCK
	spin_lock_irqsave (&io->lock, flags);
 #endif // ndef NO_SPINLOCK

 // In 2.5 we require hcds' endpoint queues not to progress after fault
 // * reports, until the completion callback (this!) returns.  That lets
 //	 * device driver code (like this routine) unlink queued urbs first,
 //	 * if it needs to, since the HC won't work on them at all.  So it's
 //	 * not possible for page N+1 to overwrite page N, and so on.
 //	 *
 //	 * That's only for "hard" faults; "soft" faults (unlinks) sometimes
 //	 * complete before the HCD can get requests away from hardware,
 //	 * though never during cleanup after a hard fault.

 if (io->status
			&& (io->status != -ECONNRESET
				|| urb->status != -ECONNRESET)
			&& urb->actual_length)
   {
	#ifdef USB_DBGSTRING_ON
		dev_err (io->dev->bus->controller,
			"dev %s ep%d%s scatterlist error %d/%d\n",
			io->dev->devpath,
			usb_pipeendpoint (urb->pipe),
			usb_pipein (urb->pipe) ? "in" : "out",
			urb->status, io->status);
     #else
		dev_err (io->dev->bus->controller,
			"ep%d%s scatterlist error %d/%d\n",
			usb_pipeendpoint (urb->pipe),
			usb_pipein (urb->pipe) ? "in" : "out",
			urb->status, io->status);
    #endif
	// BUG ();
   }

 if (urb->status && urb->status != -ECONNRESET)
   {
	int		i, found, status;

	io->status = urb->status;

	// the previous urbs, and this one, completed already.
	//	 * unlink the later ones so they won't rx/tx bad data,
	//	 *
	//	 * FIXME don't bother unlinking urbs that haven't yet been
	//	 * submitted; those non-error cases shouldn't be syslogged

		for (i = 0, found = 0; i < io->entries; i++) {
			if (found) {
				status = usb_unlink_urb (io->urbs [i]);
				if (status && status != -EINPROGRESS)
					err ("sg_complete, unlink --> %d",
							status);
			} else if (urb == io->urbs [i])
				found = 1;
		}
	}

	// on the last completion, signal usb_sg_wait()
	io->bytes += urb->actual_length;
	io->count--;
	if (!io->count)
    {
 #ifndef _ETCPIP
		complete (&io->complete);
 #endif // ndef _ETCPIP
    }

 #ifndef NO_SPINLOCK
	spin_unlock_irqrestore (&io->lock, flags);
 #endif // ndef NO_SPINLOCK
}
*/

/**
 * usb_sg_init - initializes scatterlist-based bulk/interrupt I/O request
 * @io: request block being initialized.  until usb_sg_wait() returns,
 *	treat this as a pointer to an opaque block of memory,
 * @dev: the usb device that will send or receive the data
 * @pipe: endpoint "pipe" used to transfer the data
 * @period: polling rate for interrupt endpoints, in frames or
 * 	(for high speed endpoints) microframes; ignored for bulk
 * @sg: scatterlist entries
 * @nents: how many entries in the scatterlist
 * @length: how many bytes to send from the scatterlist, or zero to
 * 	send every byte identified in the list.
 * @mem_flags: SLAB_* flags affecting memory allocations in this call
 *
 * Returns zero for success, else a negative errno value.  This initializes a
 * scatter/gather request, allocating resources such as I/O mappings and urb
 * memory (except maybe memory used by USB controller drivers).
 *
 * The request must be issued using usb_sg_wait(), which waits for the I/O to
 * complete (or to be canceled) and then cleans up all resources allocated by
 * usb_sg_init().
 *
 * The request may be canceled with usb_sg_cancel(), either before or after
 * usb_sg_wait() is called.
 */
/*
#ifndef NO_SCATTER_LIST

int usb_sg_init(struct usb_sg_request *io, struct usb_device *dev,
	unsigned		pipe,
	unsigned		period,
	// struct scatterlist is on include/asm-xxx/scatterlist.h
	struct scatterlist	*sg,
	int			nents,
	size_t			length,
	int			mem_flags
)
{
 int			i;
 int			urb_flags;
 int			dma;

 if (!io || !dev
	#ifndef NO_SCATTER_LIST
     || !sg
	#endif // ndef NO_SCATTER_LIST
	|| usb_pipecontrol (pipe)
	|| usb_pipeisoc (pipe)
	|| nents <= 0)
	return -EINVAL;

 #ifndef NO_SPINLOCK
	spin_lock_init (&io->lock);
 #endif // ndef NO_SPINLOCK

 io->dev = dev;
 io->pipe = pipe;

 #ifndef NO_SCATTER_LIST
	io->sg = sg;
 #endif // ndef NO_SCATTER_LIST

 io->nents = nents;

 // not all host controllers use DMA (like the mainstream pci ones);
 // they can use PIO (sl811) or be software over another transport.

 dma = (dev->dev.dma_mask != 0);
 if (dma)
   {
	#ifndef NO_SCATTER_LIST
		io->entries = usb_buffer_map_sg (dev, pipe, sg, nents);
	#endif // ndef NO_SCATTER_LIST
   }
  else
   {
	io->entries = nents;
   }

 // initialize all the urbs we'll use
 if (io->entries <= 0)
		return io->entries;

 io->count = 0;

 #ifndef _ETCPIP

	// io->urbs = kmalloc (io->entries * sizeof *io->urbs, mem_flags);

  #else
	// dr = NonCache_contigmalloc(sizeof(devrequest)) ;

    // B. S. Liaw : alloc_mem is on mt_??/USFSup1.c
    //              But now on ap/upnp/upnpport.c
    //              void *alloc_mem(int size)
    //              this will fill all 0s

    // BLOCK_PREEMPTION;

    io->urbs = (struct urb **)
		#ifdef USB_DBG_MEM_C_ON
			UsbAllocMemC(USB_MEM_C_L,io->entries * sizeof *io->urbs) ;
         #else

          UsbAllocMemC(USB_MEM_C_L) ;
        #endif

    // UNBLOCK_PREEMPTION;

    USB_DBG_MEM(iprintf(
		"[USB MEM] usb_sg_init() : io->urbs = %08XH \n",
       	io->urbs ));


    if ( io->urbs == NULL )
       {
		USB_DBG_INIT(iprintf("[USB INIT] usb_sg_init() : Error : couldn't allocate io->urbs memory \n"));
		dprintf("[USB] Error : couldn't allocate io->urbs memory \n");
	   }
 #endif

 if (!io->urbs)
		goto nomem;

 urb_flags = URB_ASYNC_UNLINK | URB_NO_DMA_MAP | URB_NO_INTERRUPT;
 if (usb_pipein (pipe))
		urb_flags |= URB_SHORT_NOT_OK;

 for (i = 0; i < io->entries; i++, io->count = i)
   {
	unsigned		len;

	#ifndef _ETCPIP

		// io->urbs [i] = usb_alloc_urb (0, mem_flags);

     #else
		io->urbs [i] = usb_alloc_urb (0);
    #endif
	if (!io->urbs [i])
       {
		io->entries = i;
		goto nomem;
	   }

	io->urbs [i]->dev = dev;
	io->urbs [i]->pipe = pipe;
	io->urbs [i]->interval = period;
	io->urbs [i]->transfer_flags = urb_flags;

	io->urbs [i]->callback = sg_complete;
	io->urbs [i]->context = io;
	io->urbs [i]->status = -EINPROGRESS;
	io->urbs [i]->actual_length = 0;

	if (dma)
       {
		// hc may use _only_ transfer_dma
		#ifndef NO_SCATTER_LIST
			io->urbs [i]->transfer_dma = sg_dma_address (sg + i);
        #else
        #endif

		#ifndef NO_SCATTER_LIST
			len = sg_dma_len (sg + i);
        #else
        #endif
	   }
      else
       {
		// hc may use _only_ transfer_buffer
		#ifndef NO_SCATTER_LIST
			// struct page is on include/linux/mm.h
			io->urbs [i]->transfer_buffer =
				page_address (sg [i].page) + sg [i].offset;
			len = sg [i].length;
        #else
        #endif
	   }

	if (length)
       {
		len = min_t (unsigned, len, length);
		length -= len;
		if (length == 0)
				io->entries = i + 1;
		}
	io->urbs [i]->transfer_buffer_length = len;
   }
 io->urbs [--i]->transfer_flags &= ~URB_NO_INTERRUPT;

 // transaction state
 io->status = 0;
 io->bytes = 0;
 #ifndef _ETCPIP

	// init_completion (&io->complete);

 #endif // ndef _ETCPIP

 return 0;

 // ---------------------------
 nomem:
 // ---------------------------

 sg_clean (io);
 return -ENOMEM;
}
#endif // ndef NO_SCATTER_LIST
*/

/**
 * usb_sg_wait - synchronously execute scatter/gather request
 * @io: request block handle, as initialized with usb_sg_init().
 * 	some fields become accessible when this call returns.
 * Context: !in_interrupt ()
 *
 * This function blocks until the specified I/O operation completes.  It
 * leverages the grouping of the related I/O requests to get good transfer
 * rates, by queueing the requests.  At higher speeds, such queuing can
 * significantly improve USB throughput.
 *
 * There are three kinds of completion for this function.
 * (1) success, where io->status is zero.  The number of io->bytes
 *     transferred is as requested.
 * (2) error, where io->status is a negative errno value.  The number
 *     of io->bytes transferred before the error is usually less
 *     than requested, and can be nonzero.
 * (3) cancelation, a type of error with status -ECONNRESET that
 *     is initiated by usb_sg_cancel().
 *
 * When this function returns, all memory allocated through usb_sg_init() or
 * this call will have been freed.  The request block parameter may still be
 * passed to usb_sg_cancel(), or it may be freed.  It could also be
 * reinitialized and then reused.
 *
 * Data Transfer Rates:
 *
 * Bulk transfers are valid for full or high speed endpoints.
 * The best full speed data rate is 19 packets of 64 bytes each
 * per frame, or 1216 bytes per millisecond.
 * The best high speed data rate is 13 packets of 512 bytes each
 * per microframe, or 52 KBytes per millisecond.
 *
 * The reason to use interrupt transfers through this API would most likely
 * be to reserve high speed bandwidth, where up to 24 KBytes per millisecond
 * could be transferred.  That capability is less useful for low or full
 * speed interrupt endpoints, which allow at most one packet per millisecond,
 * of at most 8 or 64 bytes (respectively).
 */
void usb_sg_wait (struct usb_sg_request *io)
{
	int		i;
	unsigned long	flags;

	/* queue the urbs.  */
 #ifndef NO_SPINLOCK
	spin_lock_irqsave (&io->lock, flags);
 #endif // ndef NO_SPINLOCK
	for (i = 0; i < io->entries && !io->status; i++) {
		int	retval;

     #ifndef _ETCPIP
		retval = usb_submit_urb (io->urbs [i], SLAB_ATOMIC);
	#else
		retval = usb_submit_urb (io->urbs [i]);
    #endif
		/* after we submit, let completions or cancelations fire;
		 * we handshake using io->status.
		 */
 #ifndef NO_SPINLOCK
		spin_unlock_irqrestore (&io->lock, flags);
 #endif // ndef NO_SPINLOCK
		switch (retval) {
			/* maybe we retrying will recover */
		case -ENXIO:	// hc didn't queue this one
		case -EAGAIN:
		case -ENOMEM:
			retval = 0;
			i--;
			// FIXME:  should it usb_sg_cancel() on INTERRUPT?
 #ifndef _ETCPIP
			yield ();
 #endif // ndef _ETCPIP
			break;

			/* no error? continue immediately.
			 *
			 * NOTE: to work better with UHCI (4K I/O buffer may
			 * need 3K of TDs) it may be good to limit how many
			 * URBs are queued at once; N milliseconds?
			 */
		case 0:
 #ifndef _ETCPIP
			cpu_relax ();
 #endif // ndef _ETCPIP
			break;

			/* fail any uncompleted urbs */
		default:
			io->urbs [i]->status = retval;
			dbg ("usb_sg_msg, submit --> %d", retval);
			usb_sg_cancel (io);
		}
 #ifndef NO_SPINLOCK
		spin_lock_irqsave (&io->lock, flags);
 #endif // ndef NO_SPINLOCK
		if (retval && io->status == -ECONNRESET)
			io->status = retval;
	}
 #ifndef NO_SPINLOCK
	spin_unlock_irqrestore (&io->lock, flags);
 #endif // ndef NO_SPINLOCK

	/* OK, yes, this could be packaged as non-blocking.
	 * So could the submit loop above ... but it's easier to
	 * solve neither problem than to solve both!
	 */
 /*
 #ifndef _ETCPIP
    // wait_for_completion() is in <linux/completion.h>
	wait_for_completion (&io->complete);
 #endif // ndef _ETCPIP
 */
 sg_clean (io);
}

/**
 * usb_sg_cancel - stop scatter/gather i/o issued by usb_sg_wait()
 * @io: request block, initialized with usb_sg_init()
 *
 * This stops a request after it has been started by usb_sg_wait().
 * It can also prevents one initialized by usb_sg_init() from starting,
 * so that call just frees resources allocated to the request.
 */
void usb_sg_cancel (struct usb_sg_request *io)
{
	unsigned long	flags;

 #ifndef NO_SPINLOCK
	spin_lock_irqsave (&io->lock, flags);
 #endif // ndef NO_SPINLOCK

	/* shut everything down, if it didn't already */
	if (!io->status) {
		int	i;

		io->status = -ECONNRESET;
		for (i = 0; i < io->entries; i++) {
			int	retval;

			if (!io->urbs [i]->dev)
				continue;
			retval = usb_unlink_urb (io->urbs [i]);
			if (retval && retval != -EINPROGRESS)
				warn ("usb_sg_cancel, unlink --> %d", retval);
			// FIXME don't warn on "not yet submitted" error
		}
	}
 #ifndef NO_SPINLOCK
	spin_unlock_irqrestore (&io->lock, flags);
 #endif // ndef NO_SPINLOCK
}

/*-------------------------------------------------------------------*/

/**
 * usb_get_descriptor - issues a generic GET_DESCRIPTOR request
 * @dev: the device whose descriptor is being retrieved
 * @type: the descriptor type (USB_DT_*)
 * @index: the number of the descriptor
 * @buf: where to put the descriptor
 * @size: how big is "buf"?
 * Context: !in_interrupt ()
 *
 * Gets a USB descriptor.  Convenience functions exist to simplify
 * getting some types of descriptors.  Use
 * usb_get_device_descriptor() for USB_DT_DEVICE,
 * and usb_get_string() or usb_string() for USB_DT_STRING.
 * Configuration descriptors (USB_DT_CONFIG) are part of the device
 * structure, at least for the current configuration.
 * In addition to a number of USB-standard descriptors, some
 * devices also use class-specific or vendor-specific descriptors.
 *
 * This call is synchronous, and may not be used in an interrupt context.
 *
 * Returns the number of bytes received on success, or else the status code
 * returned by the underlying usb_control_msg() call.
 */
int usb_get_descriptor(struct usb_device *dev, unsigned char type, unsigned char index, void *buf, int size)
{
 int i = 5;
 int result;

 USB_DBG_FLOW(iprintf("[USB FLOW] usb_get_descriptor() Begin ..\n"));

 #ifdef USB_NO_VMM // no vitrtul memory management
	#ifdef USB_BS_ASSERT
		/*
		#if defined(_S3C2510)
			if (!(  (unsigned long)buf
                  > ((unsigned long)0x00800000L)
    		     )
	    	   )
		#elif defined(_ADM5120)
			if (!(  ((unsigned long)buf & (unsigned long)0x20000000L)
    	          ==((unsigned long)0x20000000L)
    		     )
		       )
		#endif
			   {
		*/
		if ( !(USB_IS_UN_CACHED(buf)) ) {
				iprintf("[ASSERT][USB] usb_get_descriptor() : " ) ;
    		    iprintf("Error : Not Un-Cached !!\n" ) ;
			    iprintf("[ASSERT][USB] buf addr = %08XH \n", buf ) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
	#endif // USB_BS_ASSERT
 #endif // USB_NO_VMM

 memset(buf,0,size);	// Make sure we parse really received data

 while (i--)
   {
	USB_DBG_PIPE(iprintf(
    	"[USB PIPE] usb_get_descriptor() : usb_rcvctrlpipe(dev, 0) = "
        "%08XH \n",
    	usb_rcvctrlpipe(dev, 0))) ;
	USB_DBG_PIPE(iprintf(
    	"[USB PIPE] usb_get_descriptor() : rcvctl PIPE device number "
        "= %d \n",
    	usb_pipedevice(usb_rcvctrlpipe(dev, 0))
	    )) ;
	/* retries if the returned length was 0; flakey device */
	if ((result = usb_control_msg(dev, usb_rcvctrlpipe(dev, 0),
				    USB_REQ_GET_DESCRIPTOR, USB_DIR_IN,
				    (type << 8) + index, 0, buf, size,
		#ifndef _ETCPIP
				    HZ * USB_CTRL_GET_TIMEOUT
         #else
				    USB_CTRL_GET_TIMEOUT
        #endif
                    )
        ) > 0
				|| result == -EPIPE)
       {
			break;
       }
	#ifdef USB_DBG_ABORT
      // vvv for debug Prefetch Error !!
      dprintf("[TEST] GetTime() = %08XH\n",GetTime()) ;
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
			#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
				// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
				dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
             #else
            	YIELD();
            #endif
      // ^^^ for debug Prefetch
	#endif
   } // while
 USB_DBG_FLOW(iprintf("[USB FLOW] usb_get_descriptor() End.\n"));
 return result;
}

/**
 * usb_get_string - gets a string descriptor
 * @dev: the device whose string descriptor is being retrieved
 * @langid: code for language chosen (from string descriptor zero)
 * @index: the number of the descriptor
 * @buf: where to put the string
 * @size: how big is "buf"?
 * Context: !in_interrupt ()
 *
 * Retrieves a string, encoded using UTF-16LE (Unicode, 16 bits per character,
 * in little-endian byte order).
 * The usb_string() function will often be a convenient way to turn
 * these strings into kernel-printable form.
 *
 * Strings may be referenced in device, configuration, interface, or other
 * descriptors, and could also be used in vendor-specific ways.
 *
 * This call is synchronous, and may not be used in an interrupt context.
 *
 * Returns the number of bytes received on success, or else the status code
 * returned by the underlying usb_control_msg() call.
 */
int usb_get_string(struct usb_device *dev, unsigned short langid,
		unsigned char index, void *buf, int size)
{
 #ifdef USB_NO_VMM // no vitrtul memory management
	#ifdef USB_BS_ASSERT
		/*
		#if defined(_S3C2510)
			if (!(  (unsigned long)buf
                  > ((unsigned long)0x00800000L)
    		     )
	    	   )
		#elif defined(_ADM5120)
			if (!(  ((unsigned long)buf & (unsigned long)0x20000000L)
    	          ==((unsigned long)0x20000000L)
    		     )
		       )
		#endif
			   {
		*/
		if ( !(USB_IS_UN_CACHED(buf)) ) {
				iprintf("[ASSERT][USB] usb_get_string() : " ) ;
    		    iprintf("Error : Not Un-Cached !!\n" ) ;
			    iprintf("[ASSERT][USB] buf addr = %08XH \n", buf ) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
	#endif // USB_BS_ASSERT
 #endif // USB_NO_VMM

 USB_DBG_PIPE(iprintf(
    "[USB PIPE] usb_get_string() : usb_rcvctrlpipe(dev, 0) = %08XH \n",
    usb_rcvctrlpipe(dev, 0))) ;
 USB_DBG_PIPE(iprintf(
    "[USB PIPE] usb_get_string() : usb_pipedevice(usb_rcvctrlpipe(dev, 0)) = %d \n",
    usb_pipedevice(usb_rcvctrlpipe(dev, 0))
    )) ;

	return usb_control_msg(dev, usb_rcvctrlpipe(dev, 0),
		USB_REQ_GET_DESCRIPTOR, USB_DIR_IN,
		(USB_DT_STRING << 8) + index, langid, buf, size,
		#ifndef _ETCPIP
			HZ * USB_CTRL_GET_TIMEOUT
        #else
			USB_CTRL_GET_TIMEOUT
        #endif
        );
}

/**
 * usb_get_device_descriptor - (re)reads the device descriptor
 * @dev: the device whose device descriptor is being updated
 * Context: !in_interrupt ()
 *
 * Updates the copy of the device descriptor stored in the device structure,
 * which dedicates space for this purpose.  Note that several fields are
 * converted to the host CPU's byte order:  the USB version (bcdUSB), and
 * vendors product and version fields (idVendor, idProduct, and bcdDevice).
 * That lets device drivers compare against non-byteswapped constants.
 *
 * There's normally no need to use this call, although some devices
 * will change their descriptors after events like updating firmware.
 *
 * This call is synchronous, and may not be used in an interrupt context.
 *
 * Returns the number of bytes received on success, or else the status code
 * returned by the underlying usb_control_msg() call.
 */
int usb_get_device_descriptor(struct usb_device *usbdev)
{
 int ret = usb_get_descriptor(usbdev, USB_DT_DEVICE, 0, &usbdev->descriptor,
				     sizeof(usbdev->descriptor));
 if (ret >= 0) {
		le16_to_cpus(&usbdev->descriptor.bcdUSB);
		le16_to_cpus(&usbdev->descriptor.idVendor);
		le16_to_cpus(&usbdev->descriptor.idProduct);
		le16_to_cpus(&usbdev->descriptor.bcdDevice);
	}
 return ret;
}

/**
 * usb_get_status - issues a GET_STATUS call
 * @dev: the device whose status is being checked
 * @type: USB_RECIP_*; for device, interface, or endpoint
 * @target: zero (for device), else interface or endpoint number
 * @data: pointer to two bytes of bitmap data
 * Context: !in_interrupt ()
 *
 * Returns device, interface, or endpoint status.  Normally only of
 * interest to see if the device is self powered, or has enabled the
 * remote wakeup facility; or whether a bulk or interrupt endpoint
 * is halted ("stalled").
 *
 * Bits in these status bitmaps are set using the SET_FEATURE request,
 * and cleared using the CLEAR_FEATURE request.  The usb_clear_halt()
 * function should be used to clear halt ("stall") status.
 *
 * This call is synchronous, and may not be used in an interrupt context.
 *
 * Returns the number of bytes received on success, or else the status code
 * returned by the underlying usb_control_msg() call.
 */
int usb_get_status(struct usb_device *dev, int type, int target,
			void *data)
{
 USB_DBG_PIPE(iprintf(
    "[USB PIPE] usb_get_status() : usb_rcvctrlpipe(dev, 0) = %08XH \n",
    usb_rcvctrlpipe(dev, 0))) ;
 USB_DBG_PIPE(iprintf(
    "[USB PIPE] usb_get_status() : usb_pipedevice(usb_rcvctrlpipe"
    "(dev,0)) = %d \n",
    usb_pipedevice(usb_rcvctrlpipe(dev, 0))
    )) ;

 #ifdef USB_NO_VMM // no vitrtul memory management
	#ifdef USB_BS_ASSERT
		/*
		#if defined(_S3C2510)
			if (!(  (unsigned long) data
                  > ((unsigned long)0x00800000L)
    		     )
	    	   )
		#elif defined(_ADM5120)
			if (!(  (  (unsigned long)data
					 & (unsigned long)0x20000000L)
    	          ==((unsigned long)0x20000000L)
    		     )
		       )
		#endif
			   {
		*/
		if ( !(USB_IS_UN_CACHED(data)) ) {
				iprintf("[ASSERT][USB] usb_get_status() : " ) ;
    		    iprintf("Error : Not Un-Cached !!\n" ) ;
			    iprintf("[ASSERT][USB] data addr = %08XH \n", data ) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
	#endif // USB_BS_ASSERT
 #endif // USB_NO_VMM

 return usb_control_msg(dev, usb_rcvctrlpipe(dev, 0),
		USB_REQ_GET_STATUS, USB_DIR_IN | type, 0, target, data, 2,
		#ifndef _ETCPIP
			HZ * USB_CTRL_GET_TIMEOUT
        #else
			USB_CTRL_GET_TIMEOUT
        #endif
        );
}


// hub-only!! ... and only exported for reset/reinit path.
// otherwise used internally, when setting up a config
void usb_set_maxpacket(struct usb_device *dev)
{
	int i, b;

	for (i=0; i<dev->actconfig->desc.bNumInterfaces; i++) {
		struct usb_interface *ifp = dev->actconfig->interface + i;
		struct usb_host_interface *as = ifp->altsetting + ifp->act_altsetting;
		struct usb_host_endpoint *ep = as->endpoint;
		int e;

		for (e=0; e<as->desc.bNumEndpoints; e++) {
			struct usb_endpoint_descriptor	*d;
			d = &ep [e].desc;
			b = d->bEndpointAddress & USB_ENDPOINT_NUMBER_MASK;
			if ((d->bmAttributes & USB_ENDPOINT_XFERTYPE_MASK) ==
				USB_ENDPOINT_XFER_CONTROL) {	/* Control => bidirectional */
				dev->epmaxpacketout[b] = d->wMaxPacketSize;
				dev->epmaxpacketin [b] = d->wMaxPacketSize;
				}
			else if (usb_endpoint_out(d->bEndpointAddress)) {
				if (d->wMaxPacketSize > dev->epmaxpacketout[b])
					dev->epmaxpacketout[b] = d->wMaxPacketSize;
			}
			else {
				if (d->wMaxPacketSize > dev->epmaxpacketin [b])
					dev->epmaxpacketin [b] = d->wMaxPacketSize;
			}
		}
	}
}

/**
 * usb_clear_halt - tells device to clear endpoint halt/stall condition
 * @dev: device whose endpoint is halted
 * @pipe: endpoint "pipe" being cleared
 * Context: !in_interrupt ()
 *
 * This is used to clear halt conditions for bulk and interrupt endpoints,
 * as reported by URB completion status.  Endpoints that are halted are
 * sometimes referred to as being "stalled".  Such endpoints are unable
 * to transmit or receive data until the halt status is cleared.  Any URBs
 * queued for such an endpoint should normally be unlinked by the driver
 * before clearing the halt condition, as described in sections 5.7.5
 * and 5.8.5 of the USB 2.0 spec.
 *
 * Note that control and isochronous endpoints don't halt, although control
 * endpoints report "protocol stall" (for unsupported requests) using the
 * same status code used to report a true stall.
 *
 * This call is synchronous, and may not be used in an interrupt context.
 *
 * Returns zero on success, or else the status code returned by the
 * underlying usb_control_msg() call.
 * endp: endpoint number in bits 0-3;
 *	direction flag in bit 7 (1 = IN, 0 = OUT)
 */
int usb_clear_halt(struct usb_device *dev, int pipe)
{
 int result;
 int endp = usb_pipeendpoint(pipe);


 USB_DBG_PIPE(iprintf(
    "[USB PIPE] usb_sndctrlpipe(dev, 0) = %08XH \n",
    usb_sndctrlpipe(dev, 0))) ;
 USB_DBG_PIPE(iprintf(
    "[USB PIPE] usb_pipedevice(usb_sndctrlpipe(dev, 0)) = %d \n",
    usb_pipedevice(usb_sndctrlpipe(dev, 0))
    )) ;

 if (usb_pipein (pipe))
		endp |= USB_DIR_IN;

	/* we don't care if it wasn't halted first. in fact some devices
	 * (like some ibmcam model 1 units) seem to expect hosts to make
	 * this request for iso endpoints, which can't halt!
	 */
	result = usb_control_msg(dev, usb_sndctrlpipe(dev, 0),
		USB_REQ_CLEAR_FEATURE, USB_RECIP_ENDPOINT, 0, endp, NULL, 0,
		#ifndef _ETCPIP
		HZ * USB_CTRL_SET_TIMEOUT
        #else
			USB_CTRL_SET_TIMEOUT
        #endif
        );

	/* don't un-halt or force to DATA0 except on success */
	if (result < 0)
		return result;

	/* NOTE:  seems like Microsoft and Apple don't bother verifying
	 * the clear "took", so some devices could lock up if you check...
	 * such as the Hagiwara FlashGate DUAL.  So we won't bother.
	 *
	 * NOTE:  make sure the logic here doesn't diverge much from
	 * the copy in usb-storage, for as long as we need two copies.
	 */

	/* toggle was reset by the clear, then ep was reactivated */
	usb_settoggle(dev, usb_pipeendpoint(pipe), usb_pipeout(pipe), 0);
	usb_endpoint_running(dev, usb_pipeendpoint(pipe), usb_pipeout(pipe));

	return 0;
}

/**
 * usb_set_interface - Makes a particular alternate setting be current
 * @dev: the device whose interface is being updated
 * @interface: the interface being updated
 * @alternate: the setting being chosen.
 * Context: !in_interrupt ()
 *
 * This is used to enable data transfers on interfaces that may not
 * be enabled by default.  Not all devices support such configurability.
 * Only the driver bound to an interface may change its setting.
 *
 * Within any given configuration, each interface may have several
 * alternative settings.  These are often used to control levels of
 * bandwidth consumption.  For example, the default setting for a high
 * speed interrupt endpoint may not send more than 64 bytes per microframe,
 * while interrupt transfers of up to 3KBytes per microframe are legal.
 * Also, isochronous endpoints may never be part of an
 * interface's default setting.  To access such bandwidth, alternate
 * interface settings must be made current.
 *
 * Note that in the Linux USB subsystem, bandwidth associated with
 * an endpoint in a given alternate setting is not reserved until an URB
 * is submitted that needs that bandwidth.  Some other operating systems
 * allocate bandwidth early, when a configuration is chosen.
 *
 * This call is synchronous, and may not be used in an interrupt context.
 * Also, drivers must not change altsettings while urbs are scheduled for
 * endpoints in that interface; all such urbs must first be completed
 * (perhaps forced by unlinking).
 *
 * Returns zero on success, or else the status code returned by the
 * underlying usb_control_msg() call.
 */
int usb_set_interface(struct usb_device *dev, int interface, int alternate)
{
	struct usb_interface *iface;
	struct usb_host_interface *iface_as;
	int i, ret;

	iface = usb_ifnum_to_if(dev, interface);
	if (!iface) {
		warn("selecting invalid interface %d", interface);
		return -EINVAL;
	}

 USB_DBG_PIPE(iprintf(
    "[USB PIPE] usb_sndctrlpipe(dev, 0) = %08XH \n",
    usb_sndctrlpipe(dev, 0))) ;
 USB_DBG_PIPE(iprintf(
    "[USB PIPE] usb_pipedevice(usb_sndctrlpipe(dev, 0)) = %d \n",
    usb_pipedevice(usb_sndctrlpipe(dev, 0))
    )) ;

	/* 9.4.10 says devices don't need this, if the interface
	   only has one alternate setting */
	if (iface->num_altsetting == 1) {
		dbg("ignoring set_interface for dev %d, iface %d, alt %d",
			dev->devnum, interface, alternate);
		return 0;
	}

	if (alternate < 0 || alternate >= iface->num_altsetting)
		return -EINVAL;

	if ((ret = usb_control_msg(dev, usb_sndctrlpipe(dev, 0),
				   USB_REQ_SET_INTERFACE, USB_RECIP_INTERFACE,
				   iface->altsetting[alternate]
				   	.desc.bAlternateSetting,
				   interface, NULL, 0, HZ * 5)) < 0)
		return ret;

	/* FIXME drivers shouldn't need to replicate/bugfix the logic here
	 * when they implement async or easily-killable versions of this or
	 * other "should-be-internal" functions (like clear_halt).
	 * should hcd+usbcore postprocess control requests?
	 */

	/* prevent submissions using previous endpoint settings */
	iface_as = iface->altsetting + iface->act_altsetting;
	for (i = 0; i < iface_as->desc.bNumEndpoints; i++) {
		u8	ep = iface_as->endpoint [i].desc.bEndpointAddress;
		int	out = !(ep & USB_DIR_IN);

		ep &= USB_ENDPOINT_NUMBER_MASK;
		(out ? dev->epmaxpacketout : dev->epmaxpacketin ) [ep] = 0;
		// FIXME want hcd hook here, "no such endpoint"
	}
	iface->act_altsetting = alternate;

	/* 9.1.1.5: reset toggles for all endpoints affected by this iface-as
	 *
	 * Note:
	 * Despite EP0 is always present in all interfaces/AS, the list of
	 * endpoints from the descriptor does not contain EP0. Due to its
	 * omnipresence one might expect EP0 being considered "affected" by
	 * any SetInterface request and hence assume toggles need to be reset.
	 * However, EP0 toggles are re-synced for every individual transfer
	 * during the SETUP stage - hence EP0 toggles are "don't care" here.
	 * (Likewise, EP0 never "halts" on well designed devices.)
	 */

	iface_as = &iface->altsetting[alternate];
	for (i = 0; i < iface_as->desc.bNumEndpoints; i++) {
		u8	ep = iface_as->endpoint[i].desc.bEndpointAddress;
		int	out = !(ep & USB_DIR_IN);

		ep &= USB_ENDPOINT_NUMBER_MASK;
		usb_settoggle (dev, ep, out, 0);
		(out ? dev->epmaxpacketout : dev->epmaxpacketin) [ep]
			= iface_as->endpoint [i].desc.wMaxPacketSize;
	}

	return 0;
}

/**
 * usb_set_configuration - Makes a particular device setting be current
 * @dev: the device whose configuration is being updated
 * @configuration: the configuration being chosen.
 * Context: !in_interrupt ()
 *
 * This is used to enable non-default device modes.  Not all devices
 * support this kind of configurability.  By default, configuration
 * zero is selected after enumeration; many devices only have a single
 * configuration.
 *
 * USB devices may support one or more configurations, which affect
 * power consumption and the functionality available.  For example,
 * the default configuration is limited to using 100mA of bus power,
 * so that when certain device functionality requires more power,
 * and the device is bus powered, that functionality will be in some
 * non-default device configuration.  Other device modes may also be
 * reflected as configuration options, such as whether two ISDN
 * channels are presented as independent 64Kb/s interfaces or as one
 * bonded 128Kb/s interface.
 *
 * Note that USB has an additional level of device configurability,
 * associated with interfaces.  That configurability is accessed using
 * usb_set_interface().
 *
 * This call is synchronous, and may not be used in an interrupt context.
 *
 * Returns zero on success, or else the status code returned by the
 * underlying usb_control_msg() call.
 */
int usb_set_configuration(struct usb_device *dev, int configuration)
{
	int i, ret;
	struct usb_host_config *cp = NULL;

	for (i=0; i<dev->descriptor.bNumConfigurations; i++) {
		if (dev->config[i].desc.bConfigurationValue == configuration) {
			cp = &dev->config[i];
			break;
		}
	}
	if ((!cp && configuration != 0) || (cp && configuration == 0)) {
	dprintf("[USB] selecting invalid configuration %d !!\n",
           configuration);
		warn("selecting invalid configuration %d", configuration);
		return -EINVAL;
	}

 USB_DBG_PIPE(iprintf(
    "[USB PIPE] usb_set_configuration() : usb_sndctrlpipe(dev, 0) "
    "= %08XH \n",
    usb_sndctrlpipe(dev, 0))) ;
 USB_DBG_PIPE(iprintf(
    "[USB PIPE] usb_set_configuration() : usb_pipedevice("
    "usb_sndctrlpipe(dev, 0)) = %d \n",
    usb_pipedevice(usb_sndctrlpipe(dev, 0))
    )) ;

	/* if it's already configured, clear out old state first. */
	if (dev->state != USB_STATE_ADDRESS) {
		/* FIXME unbind drivers from all "old" interfaces.
		 * handshake with hcd to reset cached hc endpoint state.
		 */
	}
/*
	if ((ret = usb_control_msg(dev, usb_sndctrlpipe(dev, 0),
			USB_REQ_SET_CONFIGURATION, 0, configuration, 0,
			NULL, 0, HZ * USB_CTRL_SET_TIMEOUT)) < 0)
*/
	ret = usb_control_msg(dev, usb_sndctrlpipe(dev, 0),
			USB_REQ_SET_CONFIGURATION, 0, configuration, 0,
			NULL, 0,
		#ifndef _ETCPIP
            HZ * USB_CTRL_SET_TIMEOUT
        #else
            USB_CTRL_SET_TIMEOUT
        #endif
            ) ;

 #ifndef TIMEOUT_LOOSER_CHECK
    if( ret < 0 )
  #else
	if ( (ret < 0) && (ret != -EINPROGRESS) )
 #endif
   {
    dprintf("[USB] FixMe : Not to set dev->actconfig !!\n") ;
	return ret;
   }
	if (configuration)
		dev->state = USB_STATE_CONFIGURED;
	else
		dev->state = USB_STATE_ADDRESS;

 USB_DBG_MEM(iprintf(
     "[USB MEM] usb_set_configuration() : &(dev->actconfig)"
     " = %08XH \n",
     &(dev->actconfig)
     ));

	dev->actconfig = cp;

 USB_DBG_MEM(iprintf(
     "[USB MEM] usb_set_configuration() : Set Value : dev->actconfig"
     " = %08XH \n",
     dev->actconfig
     ));

 USB_DBG_INIT(iprintf(
     "[USB INIT] usb_set_configuration() : Set Value : dev->actconfig"
     " = %08XH \n",
     dev->actconfig
     ));

	/* reset more hc/hcd endpoint state */
	dev->toggle[0] = 0;
	dev->toggle[1] = 0;
	usb_set_maxpacket(dev);

	return 0;
}


/**
 * usb_string - returns ISO 8859-1 version of a string descriptor
 * @dev: the device whose string descriptor is being retrieved
 * @index: the number of the descriptor
 * @buf: where to put the string
 * @size: how big is "buf"?
 * Context: !in_interrupt ()
 *
 * This converts the UTF-16LE encoded strings returned by devices, from
 * usb_get_string_descriptor(), to null-terminated ISO-8859-1 encoded ones
 * that are more usable in most kernel contexts.  Note that all characters
 * in the chosen descriptor that can't be encoded using ISO-8859-1
 * are converted to the question mark ("?") character, and this function
 * chooses strings in the first language supported by the device.
 *
 * The ASCII (or, redundantly, "US-ASCII") character set is the seven-bit
 * subset of ISO 8859-1. ISO-8859-1 is the eight-bit subset of Unicode,
 * and is appropriate for use many uses of English and several other
 * Western European languages.  (But it doesn't include the "Euro" symbol.)
 *
 * This call is synchronous, and may not be used in an interrupt context.
 *
 * Returns length of the string (>= 0) or usb_control_msg status (< 0).
 */
#ifdef USB_DBGSTRING_ON
	int usb_string(struct usb_device *dev, int index, char *buf,
    				size_t size)
 #else
	int usb_string(struct usb_device *dev, int index)
#endif
{
 unsigned char *tbuf;
 int err, len;
 unsigned int u, idx;


 USB_DBG_FLOW(iprintf("[USB FLOW] usb_string() Begin ..\n"));

 #ifdef USB_DBGSTRING_ON
	if (size <= 0 || !buf || !index)
		return -EINVAL;

	buf[0] = 0;
 #endif // USB_DBGSTRING_ON
 /*
 #ifndef _ETCPIP
	//tbuf = kmalloc(256, GFP_KERNEL);		// 20021007 remarked by drsohn
	tbuf = kmalloc(256, GFP_KERNEL|GFP_DMA);	// 20021007 modified by drsohn
	if (!tbuf)
		return -ENOMEM;
  #else
 */
	/*
	#ifndef USB_MEM_LIB
	  	tbuf = (unsigned char *)
			NonCache_contigmalloc(256) ;
		// NonCache_contigmalloc() cannot be free now !!
     #else
	*/
     	// alloc_mem(256) ;
		USB_DBG_MEM_U(iprintf(
		    "[USB MEM_U] usb_string() Call UsbAllocMemU ..\n"
            ));
	  	tbuf = (unsigned char *) UsbAllocMemU(USB_MEM_U_M
					#ifdef USB_DBG_MEM_U_ON
						,256
			        #endif
					);
	/*
    #endif
	*/
    USB_DBG_MEM(iprintf(
       "[USB MEM] tbuf = %08XH \n",tbuf));
    if ( tbuf == NULL ) {
		dprintf("[USB] Error : Out of memory\n");
        USB_DBG_INIT(iprintf("[USB INIT] usb_string() : Error !!\n"));
		return -ENOMEM;
	   }
 /*
 #endif
 */
	/* get langid for strings if it's not yet known */
 if (!dev->have_langid)
   {
	err = usb_get_string(dev, 0, 0, tbuf, 4);
	#ifndef TIMEOUT_LOOSER_CHECK
	 if (err < 0)
	 #else
     if ( (err < 0) && (err != -EINPROGRESS) )
	#endif
        {
		 dprintf("[USB] error getting string descriptor 0 (error=%d)\n",
                 err);
         USB_DBG_INIT(iprintf("[USB INIT] usb_string() : Error !!\n"));
			goto errout;
		}
     else if (tbuf[0] < 4)
        {
			err("string descriptor 0 too short");
			err = -EINVAL;
        USB_DBG_INIT(iprintf("[USB INIT] usb_string() : Error !!\n"));
			goto errout;
		}
     else
       {
		dev->have_langid = -1;
		dev->string_langid = tbuf[2] | (tbuf[3]<< 8);
				/* always use the first langid listed */
		USB_DBG_INIT(iprintf("[USB INIT] device number %d default language ID 0x%x \n",
			dev->devnum, dev->string_langid
            ));
	   }
	}

	/*
  * Just ask for a maximum length string and then take the length
	 * that was returned.
	 */

	err = usb_get_string(dev, dev->string_langid, index, tbuf, 2);
	if(err<2)
		goto errout;
	len=tbuf[0];

	err = usb_get_string(dev, dev->string_langid, index, tbuf, len);
 #ifndef TIMEOUT_LOOSER_CHECK
	if (err < 0)
  #else
	if ( (err < 0) && (err != -EINPROGRESS) )
 #endif
    {
     USB_DBG_INIT(iprintf("[USB INIT] usb_string() : Error !!\n"));
		goto errout;
    }

 #ifdef USB_DBGSTRING_ON
	size--;		/* leave room for trailing NULL char in output buffer */
 #endif // USB_DBGSTRING_ON

 USB_DBG_INIT(iprintf( "[USB INIT] tbuf = "));
 // USB_DBG_INFO(iprintf( "[USB INFO] tbuf = "));

 for (idx = 0, u = 2; u < err; u += 2)
   {
	#ifdef USB_DBGSTRING_ON
		if (idx >= size)
			break;
	#endif // USB_DBGSTRING_ON
	USB_DBG_INIT(iprintf("%02X ",tbuf[u]));
	// USB_DBG_INFO(iprintf("%02XH ",tbuf[u]));
	// USB_DBG_INFO(iprintf("%02X ",tbuf[u]));
	USB_DBG_INIT(iprintf("%02X ",tbuf[u+1]));
	// USB_DBG_INFO(iprintf("%02XH ",tbuf[u+1]));
	// USB_DBG_INFO(iprintf("%02X ",tbuf[u+1]));

	#ifdef USB_DBGSTRING_ON
		if (tbuf[u+1])			/* high byte */
           {
			buf[idx++] = '?';  /* non-ASCII character */
           }
		 else
           {
			buf[idx++] = tbuf[u];
           }
	#endif // USB_DBGSTRING_ON
   }

 USB_DBG_INIT(iprintf(" \n"));
 // USB_DBG_INFO(iprintf(" \n"));

 #ifdef USB_DBGSTRING_ON
	buf[idx] = 0;
 #endif // USB_DBGSTRING_ON

 err = idx;

 // ===========
 errout:
 // ===========
 /*
 #ifndef _ETCPIP
	kfree (tbuf);
  #else
 */
    /*
	// NonCache_contigmalloc() cannot be free now !!
	*/
    UsbFreeMemU(USB_MEM_U_M, tbuf
			#if defined(USB_DBG_MEM_U_ON)
				,256
			#endif
			) ;
 /*
 #endif
 */

 USB_DBG_FLOW(iprintf("[USB FLOW] usb_string() End.\n"));
 return err;
}

#ifndef _ETCPIP
	/*
	// synchronous request completion model
	EXPORT_SYMBOL(usb_control_msg);
	EXPORT_SYMBOL(usb_bulk_msg);

	EXPORT_SYMBOL(usb_sg_init);
	EXPORT_SYMBOL(usb_sg_cancel);
	EXPORT_SYMBOL(usb_sg_wait);

	// synchronous control message convenience routines
	EXPORT_SYMBOL(usb_get_descriptor);
	EXPORT_SYMBOL(usb_get_device_descriptor);
	EXPORT_SYMBOL(usb_get_status);
	EXPORT_SYMBOL(usb_get_string);
	EXPORT_SYMBOL(usb_string);
	EXPORT_SYMBOL(usb_clear_halt);
	EXPORT_SYMBOL(usb_set_configuration);
	EXPORT_SYMBOL(usb_set_interface);
    */
#endif // ndef _ETCPIP

