 
// #ifdef _ETCPIP
#define __KERNEL__
#ifdef _NEWLIB
     #include "sys_type.h"
#endif
#ifdef _NEWLIB
          #include "string.h"
#endif
#include "EtcpipDbg.h" // 2002/10/25 B. S. Liaw
          // for deciding whether to compile
          //  Debug Version or Release Version
#include "etcpip.h"
#include "UsbDbg.h"
   
#include "PoList.h" // osport_list.h
   
#include "UsbCfg.h" // Config and Setting
#include "UsOsport.h" // "usb_osport.h"
#ifndef NO_TIMER
		#include "PoTimer.h" // osport_timer.h
#endif // ndef NO_TIMER
#ifndef NO_WAITQUEUE
		#include  "PoWait.h" // osport_wait.h
#endif // ndef NO_WAITQUEUE
#include "UsMemLib.h"
// #endif // _ETCPIP

/*
#include <linux/config.h>
#include <linux/module.h>
#include <linux/string.h>
#include <linux/bitops.h>
#include <linux/slab.h>
#include <linux/init.h>
*/


#ifdef CONFIG_USB_DEBUG
	#define DEBUG
#else
	#undef DEBUG
#endif
#ifndef _ETCPIP
	#include <linux/usb.h>
 #else
   #include "usb.h"
#endif

#include "UsbHcd.h"  // ../core/hcd.h

#include "UsbSysInit.h"

/* ------------------------------------------------------------------------------------- 
 * New USB Core Functions
 * -------------------------------------------------------------------------------------*/

/**
 * usb_alloc_urb - creates a new urb for a USB driver to use
 * @iso_packets: number of iso packets for this urb
 * @mem_flags: the type of memory to allocate, see kmalloc() for a list of
 *	valid options for this.
 *
 * Creates an urb for the USB driver to use, initializes a few internal
 * structures, incrementes the usage counter, and returns a pointer to it.
 *
 * If no memory is available, NULL is returned.
 *
 * If the driver want to use this urb for interrupt, control, or bulk
 * endpoints, pass '0' as the number of iso packets.
 *
 * The driver must call usb_free_urb() when it is finished with the urb.
 */
#ifndef _ETCPIP
	struct urb *usb_alloc_urb(int iso_packets, int mem_flags)
#else
	struct urb *usb_alloc_urb(int iso_packets)
#endif
{
 struct urb *urb;

 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_alloc_urb() Begin ..\n"));


 USB_DBG_CTLMSG(iprintf(
	"[USB CTLMSG] usb_alloc_urb(): alloc urb .. \n"
    ));
 #ifndef _ETCPIP
    #error : Please Make Sure : Not _ETCPIP
	urb = (struct urb *)kmalloc(sizeof(struct urb) + 
		iso_packets * sizeof(struct usb_iso_packet_descriptor),
		mem_flags);
	if (!urb) {
		err("alloc_urb: kmalloc failed");
		return NULL;
	}
  #else
    /*
	urb = (urb_t *) NonCache_contigmalloc(sizeof(urb_t) + 
                 iso_packets * sizeof(iso_packet_descriptor_t)) ;
    */
    
    // B. S. Liaw : alloc_mem is on mt_??/USFSup1.c
    //              But now on ap/upnp/upnpport.c
    //              void *alloc_mem(int size) 
    //              this will fill all 0s

    // BLOCK_PREEMPTION;

    urb = (struct urb *) UsbAllocMemC(USB_MEM_C_S
				#ifdef USB_DBG_MEM_C_ON
					, sizeof(struct urb ) + 
                     iso_packets * sizeof(struct  
                     		usb_iso_packet_descriptor) // size : 84
		        #endif
           		) ;
                 
    // UNBLOCK_PREEMPTION;
    
	#ifdef USB_DBG_CTLMSG_ON
    	USB_DBG_MEM(iprintf("[USB MEM] urb = %08XH \n",
       		urb ));
	#endif // USB_DBG_CTLMSG_ON

    if ( urb == NULL ) {
		USB_DBG_INIT(iprintf(
        	"[USB INIT] couldn't allocate urb memory \n"));
        dprintf("[USB] Error : Out of Memory \n");
		return NULL;
	   }
 #endif

 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] urb = %08XH \n",urb));

 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] sizeof(*urb) = %d \n",
    sizeof(*urb) ));
    
 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] total allocate size = %d \n",
    sizeof(struct urb) + iso_packets * 
    sizeof(struct usb_iso_packet_descriptor)
    )) ;
    
 #ifndef _ETCPIP
	memset(urb, 0, sizeof(*urb));
 #endif
 #ifndef _ETCPIP
	urb->count = (atomic_t)ATOMIC_INIT(1);
 #endif
 
 #ifndef NO_SPINLOCK
	spin_lock_init(&urb->lock);
 #endif // ndef NO_SPINLOCK


 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_alloc_urb() End.\n"));
    
 return urb;
}

/**
 * usb_free_urb - frees the memory used by a urb when all users of it 
		are finished
 * @urb: pointer to the urb to free
 *
 * Must be called when a user of a urb is finished with it.  When the 
 		last user
 * of the urb calls this function, the memory of the urb is freed.
 *
 * Note: The transfer buffer associated with the urb is not freed, that 
 		"must be
 * done elsewhere.
 */
void usb_free_urb(struct urb *urb)
{
 USB_DBG_FLOW(iprintf(
	"[USB FLOW] usb_free_urb() Begin ..\n"
    ));
 USB_DBG_FLOWTIMCRY(iprintf(
	"[USB FLOWTIMCRY] usb_free_urb() Begin ..\n"
    ));
 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_free_urb() Begin.\n"));
    
 #ifdef USB_DBG_ABORT   
	// vvv for debug Prefetch/Data Abort Error !!
   
	#ifndef NO_TIMER
	    dprintf("[TEST] usb_free_urb() : jiffies = %08XH\n",jiffies) ;
	#endif // ndef NO_TIMER
   
    {
     unsigned long * __temp_ptr = 0 ;
    
	 #if !defined(_ADM5120)
        dprintf("[TEST] usb_free_urb() :  *000000000H = %08XH \n",
		        * __temp_ptr
                );
     #endif
    }
    dprintf("[TEST] usb_free_urb() : GetTime() = %08XH\n",
                        GetTime()) ;
	if(!in_interrupt())
       {
		dprintf("[TEST] usb_free_urb() : dlytsk()/YIELD() ..\n") ;
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
		dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
       }
      else
       {
        dprintf("[TEST] usb_free_urb() : in interrupt !!\n");
       }
   // ^^^ for debug Prefetch/Data Abort Error !!  
 #endif
 
 if (urb)
   {
    #ifndef _ETCPIP
    // FixMe : 2003/7/5 B. S. Liaw : is urb is shareable ??
	if (atomic_dec_and_test(&urb->count))
    #endif
	   {
     	USB_DBG_CTLMSG(iprintf(
        	"[USB CTLMSG] usb_free_urb() free urb ..\n"));
     	#ifndef _ETCPIP
            /*
			kfree(urb);
            */
      	#else
            /*
			USB_DBG_INIT(iprintf(
				"[USB INIT] usb_free_urb() free ..\n"
		    	));
            */
			USB_DBG_MEM(iprintf(
				"[USB MEM] usb_free_urb() free ..\n"
		    	));
			USB_DBG_FLOWTIMCRY(iprintf(
				"[USB FLOWTIMCRY] usb_free_urb() free ..\n"
		    	));
                
			#ifdef USB_DBG_MEM_C_ON
				UsbFreeMemC(USB_MEM_C_S,(unsigned char *)urb,sizeof(*urb));
		 	#else
    	    	// BLOCK_PREEMPTION;
	        	// void free(void *ptr) on ap/upnp/upnpport.c
	        	UsbFreeMemC(USB_MEM_C_S,(unsigned char *)urb);
    	    	// UNBLOCK_PREEMPTION;
        	#endif
     	#endif
       }
    }
 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_free_urb() End.\n"));
 USB_DBG_FLOWTIMCRY(iprintf(
	"[USB FLOWTIMCRY] usb_free_urb() End.\n"
    ));
 USB_DBG_FLOW(iprintf(
	"[USB FLOW] usb_free_urb() End.\n"
    ));
}

/**
 * usb_get_urb - increments the reference count of the urb
 * @urb: pointer to the urb to modify
 *
 * This must be  called whenever a urb is transferred from a device driver to a
 * host controller driver.  This allows proper reference counting to happen
 * for urbs.
 *
 * A pointer to the urb with the incremented reference counter is returned.
 */
struct urb * usb_get_urb(struct urb *urb)
{
	if (urb) {
		atomic_inc(&urb->count);
		return urb;
	} else
		return NULL;
}
		
		
/*-------------------------------------------------------------------*/

/**
 * usb_submit_urb - issue an asynchronous transfer request for an endpoint
 * @urb: pointer to the urb describing the request
 * @mem_flags: the type of memory to allocate, see kmalloc() for a list
 *	of valid options for this.
 *
 * This submits a transfer request, and transfers control of the URB
 * describing that request to the USB subsystem.  Request completion will
 * be indicated later, asynchronously, by calling the completion handler.
 * The three types of completion are success, error, and unlink
 * (also called "request cancellation").
 * URBs may be submitted in interrupt context.
 *
 * The caller must have correctly initialized the URB before submitting
 * it.  Functions such as usb_fill_bulk_urb() and usb_fill_control_urb() are
 * available to ensure that most fields are correctly initialized, for
 * the particular kind of transfer, although they will not initialize
 * any transfer flags.
 *
 * Successful submissions return 0; otherwise this routine returns a
 * negative error number.  If the submission is successful, the complete()
 * callback from the urb will be called exactly once, when the USB core and
 * host controller driver are finished with the urb.  When the completion
 * function is called, control of the URB is returned to the device
 * driver which issued the request.  The completion handler may then
 * immediately free or reuse that URB.
 *
 * For control endpoints, the synchronous usb_control_msg() call is
 * often used (in non-interrupt context) instead of this call.
 * That is often used through convenience wrappers, for the requests
 * that are standardized in the USB 2.0 specification.  For bulk
 * endpoints, a synchronous usb_bulk_msg() call is available.
 *
 * Request Queuing:
 *
 * URBs may be submitted to endpoints before previous ones complete, to
 * minimize the impact of interrupt latencies and system overhead on data
 * throughput.  This is required for continuous isochronous data streams,
 * and may also be required for some kinds of interrupt transfers. Such
 * queueing also maximizes bandwidth utilization by letting USB controllers
 * start work on later requests before driver software has finished the
 * completion processing for earlier requests.
 *
 * Bulk and Isochronous URBs may always be queued.  At this writing, all
 * mainstream host controller drivers support queueing for control and
 * interrupt transfer requests.
 *
 * Reserved Bandwidth Transfers:
 *
 * Periodic transfers (interrupt or isochronous) are performed repeatedly,
 * using the interval specified in the urb.  Submitting the first urb to
 * the endpoint reserves the bandwidth necessary to make those transfers.
 * If the USB subsystem can't allocate sufficient bandwidth to perform
 * the periodic request, submitting such a periodic request should fail.
 *
 * Device drivers must explicitly request that repetition, by ensuring that
 * some URB is always on the endpoint's queue (except possibly for short
 * periods during completion callacks).  When there is no longer an urb
 * queued, the endpoint's bandwidth reservation is canceled.  This means
 * drivers can use their completion handlers to ensure they keep bandwidth
 * they need, by reinitializing and resubmitting the just-completed urb
 * until the driver longer needs that periodic bandwidth.
 *
 * Memory Flags:
 *
 * The general rules for how to decide which mem_flags to use
 * are the same as for kmalloc.  There are four
 * different possible values; GFP_KERNEL, GFP_NOFS, GFP_NOIO and
 * GFP_ATOMIC.
 *
 * GFP_NOFS is not ever used, as it has not been implemented yet.
 *
 * GFP_ATOMIC is used when
 *   (a) you are inside a completion handler, an interrupt, bottom half,
 *       tasklet or timer, or
 *   (b) you are holding a spinlock or rwlock (does not apply to
 *       semaphores), or
 *   (c) current->state != TASK_RUNNING, this is the case only after
 *       you've changed it.
 * 
 * GFP_NOIO is used in the block io path and error handling of storage
 * devices.
 *
 * All other situations use GFP_KERNEL.
 *
 * Some more specific rules for mem_flags can be inferred, such as
 *  (1) start_xmit, timeout, and receive methods of network drivers must
 *      use GFP_ATOMIC (they are called with a spinlock held);
 *  (2) queuecommand methods of scsi drivers must use GFP_ATOMIC (also
 *      called with a spinlock held);
 *  (3) If you use a kernel thread with a network driver you must use
 *      GFP_NOIO, unless (b) or (c) apply;
 *  (4) after you have done a down() you can use GFP_KERNEL, unless (b) or (c)
 *      apply or your are in a storage driver's block io path;
 *  (5) USB probe and disconnect can use GFP_KERNEL unless (b) or (c) apply; and
 *  (6) changing firmware on a running storage or net device uses
 *      GFP_NOIO, unless b) or c) apply
 *
 */
#ifndef _ETCPIP
	/*
	int usb_submit_urb(struct urb *urb, int mem_flags)
    */
#else
	int usb_submit_urb(struct urb *urb)
#endif
{
 int			pipe, temp, max;
 struct usb_device	*dev;
 struct usb_operations	*op;
 int			is_out;
 int ret_val ;

 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] usb_submit_urb() Begin.\n"));
 USB_DBG_CTLMSG(iprintf("[USB CTLMSG] usb_submit_urb() urb = %08XH ..\n", urb ));
    
 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_submit_urb() &(urb->hcpriv) = %08XH urb->hcpriv=%08XH\n",
    &(urb->hcpriv) , urb->hcpriv
    ));
 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_submit_urb() &(urb->callback) = %08XH urb->callback=%08XH\n",
    &(urb->callback) , urb->callback
    ));
    
 #ifdef USB_BS_ASSERT
	if (!urb) /* just to be sure */ 
	   {
		iprintf("[ASSERT][USB] usb_submit_urb(1) : " ) ;
    	iprintf("Error : urb value wrong : %08XH !!\n", urb ) ;
	    iprintf("[ASSERT][USB] Continue .. \n") ;
	   }		
	if (!urb->dev || !urb->dev->bus)
	   {
		iprintf("[ASSERT][USB] usb_submit_urb(2) : " ) ;
    	iprintf("Error : urb->dev or urb->dev->bus value wrong !!\n") ;
	    iprintf("[ASSERT][USB] Continue .. \n") ;
	   }		
	
	if (urb->hcpriv)			/* urb already in use */
       {
		iprintf("[ASSERT][USB] usb_submit_urb(3) : " ) ;
    	iprintf("Error : urb value wrong , urb already in use !!\n" ) ;
	    iprintf("[ASSERT][USB] Continue .. \n") ;
	   }
 #endif // def USB_BS_ASSERT

 #ifdef USB_NO_ABC // No usb_api_blocking_completion()
	BLOCK_PREEMPTION;
	global_awd_done ++ ;
    if ((global_awd_done > 10000) || (global_awd_done <1))
       {
   	    global_awd_done = 1 ;
       }
    urb->awd_done_old = global_awd_done ;
    urb->awd_done = global_awd_done ;
    UNBLOCK_PREEMPTION;
    
	USB_DBG_URB(iprintf(
    	"[USB URB] usb_submit_urb() : before , global_awd_done=%d \n"
    	, global_awd_done
	    )) ;
	USB_DBG_URB(iprintf(
    	"[USB URB] usb_submit_urb() : before , ~global_awd_done=%d \n",
	    ~global_awd_done
		));
 #endif // USB_NO_ABC

 if (!urb || urb->hcpriv || !urb->callback)
   {
	USB_DBG_CTLMSG(iprintf("[USB CTLMSG] usb_submit_urb() End 1 with -EINVAL.\n"));
	USB_DBG_INFO(iprintf("[USB INFO] usb_submit_urb() End 1 with -EINVAL.\n"));
	return -EINVAL;
   }

 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_submit_urb() &(urb->dev)=%08XH urb->dev=%08XH\n",
    &(urb->dev) , urb->dev
    ));
    
 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_submit_urb() &(urb->dev->state)=%08XH urb->dev->state=%08XH\n",
    &(urb->dev->state) , urb->dev->state
    ));
    
 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_submit_urb() &(urb->dev->bus)=%08XH urb->dev->bus=%08XH\n",
    &(urb->dev->bus) , urb->dev->bus
    ));
        
 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_submit_urb() &(urb->dev->devnum)=%08XH urb->dev->devnum=%08XH\n",
    &(urb->dev->devnum) , urb->dev->devnum
    ));
    
 if (!(dev = urb->dev) ||
	    (dev->state < USB_STATE_DEFAULT) ||
	    (!dev->bus) || (dev->devnum <= 0))
   {
	USB_DBG_INFO(iprintf("[USB INFO] usb_submit_urb() End 2 with -ENODEV.\n"));
	return -ENODEV;
   }
        
 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_submit_urb() &(urb->dev->bus->op) = %08XH urb->dev->bus->op=%08XH\n",
    &(urb->dev->bus->op) , urb->dev->bus->op
    ));
    
 USB_DBG_CTLMSG(iprintf(
    "[USB CTLMSG] usb_submit_urb() "
    "&(urb->dev->bus->op->submit_urb)=%08XH "
    "urb->dev->bus->op->submit_urb=%08XH\n",
    &(urb->dev->bus->op->submit_urb) , urb->dev->bus->op->submit_urb
    ));
    
 if (!(op = dev->bus->op) || !op->submit_urb)
   {
	USB_DBG_INFO(iprintf("[USB INFO] usb_submit_urb() End 3 with -ENODEV.\n"));
	return -ENODEV;
   }

 urb->status = -EINPROGRESS;
 urb->actual_length = 0;
 urb->bandwidth = 0;

 /* Lots of sanity checks, so HCDs can rely on clean data
  * and don't need to duplicate tests
  */
 pipe = urb->pipe;
 temp = usb_pipetype (pipe);
 is_out = usb_pipeout (pipe);

 if (!usb_pipecontrol (pipe) && dev->state < USB_STATE_CONFIGURED)
   {
	USB_DBG_INFO(iprintf("[USB INFO] usb_submit_urb() End 4 with -ENODEV.\n"));
	return -ENODEV;
   }

	/* (actually HCDs may need to duplicate this, endpoint might yet
	 * stall due to queued bulk/intr transactions that complete after
	 * we check)
	 */
 if (usb_endpoint_halted (dev, usb_pipeendpoint (pipe), is_out))
   {
	USB_DBG_INFO(iprintf("[USB INFO] usb_submit_urb() End 5 with -EPIPE.\n"));
	return -EPIPE;
   }

	/* FIXME there should be a sharable lock protecting us against
	 * config/altsetting changes and disconnects, kicking in here.
	 * (here == before maxpacket, and eventually endpoint type,
	 * checks get made.)
	 */

 max = usb_maxpacket (dev, pipe, is_out);
 
 USB_DBG_CTLMSG(iprintf(
	"[USB CTLMSG] usb_submit_urb() : max = %d \n",max));
    
 if (max <= 0)
   {
	#ifdef USB_DBGSTRING_ON
		dbg ("%s: bogus endpoint %d-%s on usb-%s-%s (bad maxpacket %d)",
			__FUNCTION__,
			usb_pipeendpoint (pipe), is_out ? "OUT" : "IN",
			dev->bus->bus_name, dev->devpath,
			max);
     #else
		dprintf("[USB] %s: bogus endpoint %d-%s on usb (bad maxpacket %d) \n",
			__FUNCTION__,
			usb_pipeendpoint (pipe), is_out ? "OUT" : "IN",
			max);
    #endif
    
	USB_DBG_INFO(iprintf("[USB INFO] usb_submit_urb() End 6 with -EMSGSIZE.\n"));
	return -EMSGSIZE;
   }

 /* periodic transfers limit size per frame/uframe,
  * but drivers only control those sizes for ISO.
  * while we're checking, initialize return status.
  */
  
 if (temp == PIPE_ISOCHRONOUS)
   {
	int	n, len;

	USB_DBG_CTLMSG(iprintf(
		"[USB CTLMSG] usb_submit_urb() : PIPE_ISOCHRONOUS \n"));
        
	/* "high bandwidth" mode, 1-3 packets/uframe? */
		if (dev->speed == USB_SPEED_HIGH) {
			int	mult = 1 + ((max >> 11) & 0x03);
			max &= 0x03ff;
			max *= mult;
		}

		if (urb->number_of_packets <= 0)
           {		    
			return -EINVAL;
	dprintf(
    	"[USB] usb_submit_urb() End 2 with -EINVAL.\n");
           }
		for (n = 0; n < urb->number_of_packets; n++) {
			len = urb->iso_frame_desc [n].length;
			if (len < 0 || len > max) 
				return -EMSGSIZE;
			urb->iso_frame_desc [n].status = -EXDEV;
			urb->iso_frame_desc [n].actual_length = 0;
		}
   }

 /* the I/O buffer must be mapped/unmapped, except when length=0 */
 USB_DBG_CTLMSG(iprintf(
	"[USB CTLMSG] usb_submit_urb() : urb->transfer_buffer_length = "
    "%d \n",
    urb->transfer_buffer_length
    ));
 if (urb->transfer_buffer_length < 0)
   {
	USB_DBG_INFO(iprintf("[USB INFO] usb_submit_urb() End 7 with -EMSGSIZE.\n"));
	return -EMSGSIZE;
   }

 #ifdef DEBUG
   /* stuff that drivers shouldn't do, but which shouldn't
    * cause problems in HCDs if they get it wrong.
    */
   {
	unsigned int	orig_flags = urb->transfer_flags;
	unsigned int	allowed;

	/* enforce simple/standard policy */
	allowed = URB_ASYNC_UNLINK;	// affects later unlinks
	allowed |= URB_NO_DMA_MAP;
	allowed |= URB_NO_INTERRUPT;
	switch (temp) {
	case PIPE_BULK:
		if (is_out)
			allowed |= URB_ZERO_PACKET;
		/* FALLTHROUGH */
	case PIPE_CONTROL:
		allowed |= URB_NO_FSBR;	/* only affects UHCI */
		/* FALLTHROUGH */
	default:			/* all non-iso endpoints */
		if (!is_out)
			allowed |= URB_SHORT_NOT_OK;
		break;
	case PIPE_ISOCHRONOUS:
		allowed |= URB_ISO_ASAP;
		break;
	}
	urb->transfer_flags &= allowed;

	/* fail if submitter gave bogus flags */
	if (urb->transfer_flags != orig_flags)
       {
		err ("BOGUS urb flags, %x --> %x",
			orig_flags, urb->transfer_flags);
            
		USB_DBG_CTLMSG(iprintf(
    		"[USB CTLMSG] usb_submit_urb() End 8 with -EINVAL.\n"));
	dprintf(
    	"[USB] usb_submit_urb() End 8 with -EINVAL.\n");
		return -EINVAL;
	   }
   }
 #endif

 /*
	 * Force periodic transfer intervals to be legal values that are
	 * a power of two (so HCDs don't need to).
	 *
	 * FIXME want bus->{intr,iso}_sched_horizon values here.  Each HC
	 * supports different values... this uses EHCI/UHCI defaults (and
	 * EHCI can use smaller non-default values).
	 */
 switch (temp)
   {
	case PIPE_ISOCHRONOUS:
	case PIPE_INTERRUPT:
		/* too small? */
		if (urb->interval <= 0)
           {
			USB_DBG_CTLMSG(iprintf(
    			"[USB CTLMSG] usb_submit_urb() End 9 with -EINVAL.\n"
                ));
	dprintf(
    	"[USB] usb_submit_urb() End 9 with -EINVAL.\n");
			return -EINVAL;
           }
		/* too big? */
		switch (dev->speed) {
		case USB_SPEED_HIGH:	/* units are microframes */
			// NOTE usb handles 2^15
			if (urb->interval > (1024 * 8))
				urb->interval = 1024 * 8;
			temp = 1024 * 8;
			break;
		case USB_SPEED_FULL:	/* units are frames/msec */
		case USB_SPEED_LOW:
			if (temp == PIPE_INTERRUPT) {
				if (urb->interval > 255)
                {
	dprintf(
    	"[USB] usb_submit_urb() End 10 with -EINVAL.\n");
					return -EINVAL;
                }
				// NOTE ohci only handles up to 32
				temp = 128;
			} else {
				if (urb->interval > 1024)
					urb->interval = 1024;
				// NOTE usb and ohci handle up to 2^15
				temp = 1024;
			}
			break;
		default:
			USB_DBG_CTLMSG(iprintf(
    			"[USB] usb_submit_urb() End with -EINVAL. (USB speed=x%x[x%08x])\n", dev->speed, dev));
	dprintf(
    	"[USB] usb_submit_urb() End with -EINVAL. (USB speed=x%x[x%08x])\n", dev->speed, dev);
			return -EINVAL;
		}
		/* power of two? */
		while (temp > urb->interval)
			temp >>= 1;
		urb->interval = temp;
	}

 USB_DBG_CTLMSG(iprintf(
	"[USB CTLMSG] usb_submit_urb() Call op->submit_urb() ..\n"
    ));
 #ifndef _ETCPIP
	ret_val = op->submit_urb (urb, mem_flags);
  #else
	ret_val = op->submit_urb (urb);
 #endif
 /*
 iprintf("[USB] --------------------------------------------- \n") ;
 iprintf("[USB] after op->submit_urb() ---------------------- \n") ;
 iprintf("[USB] --------------------------------------------- \n") ;
 */
 
 USB_DBG_CTLMSG(iprintf(
	"[USB CTLMSG] usb_submit_urb() End 11 \n"
    ));
 return ret_val ;
}

#ifdef USB_NO_ISR_CALLBACK
void urb_task(struct urb *urb)
{
 #ifdef TNV105_INTBUG  /* Charles 20040423 */
	extern void TNV105_InterruptPolling(void);
 #endif	
 unsigned int next_step ;
 int ret;
 #ifdef USB_NO_ISR_UNLINK
 	int status_unlink;
 #endif
 struct usb_hcd *hcd;
    
 USB_DBG_FLOW(iprintf("[USB FLOW] urb_task() Begin ..\n"));
        
 if (!urb)
 {
	dprintf("[USB] urb_task() : Error : Null urb !!\n");
        goto task_end_err ;
 }
 
 hcd = urb->dev->bus->hcpriv_hcd;

 for (;;) 
 {
	for (;;) 
    	{
		#ifdef USB_DBG_MEM_AREA_VERIFY_ON
			USB_DBG_AREA_MSG(iprintf("[USB AREA] urb_task() : Verify Memory Area ..\n")) ;
			if (! VerifyMemArea() ) {
				iprintf("[USB] urb_task() Verify Memory Area Error !\n") ;
	       		}
		#endif // USB_DBG_MEM_AREA_VERIFY_ON
            
		#ifdef TNV105_INTBUG  /* Charles 20040423 */
			TNV105_InterruptPolling();
		#endif
		BLOCK_PREEMPTION;
		next_step = urb->next_step ;
		UNBLOCK_PREEMPTION;

	        if (next_step & NEXT_STEP_KILL)
		{
			next_step |= NEXT_STEP_FREE ;
			goto step_free ;
		}

		#ifdef USB_NO_ABC // No usb_api_blocking_completion()
			if (urb->awd_done == ~urb->awd_done_old)
		#else
	    		if (awd_done == ~global_awd_done) )
		#endif
		{
                	BLOCK_PREEMPTION;
			next_step = urb->next_step ;
			UNBLOCK_PREEMPTION;
		        if (next_step & NEXT_STEP_KILL)
			{
				next_step |= NEXT_STEP_FREE ;
				goto step_free ;
			}
                   
			if (urb->callback)
			{
				USB_DBG_CALLBACK(iprintf("[USB CALLBACK] urb_task() : Call urb->callback() ...\n" )) ;
				urb->callback(urb);
			}
			else
			{
				USB_DBG_CALLBACK(iprintf("[USB CALLBACK] urb_task() : Null urb->callback() !! \n" )) ;
			}
                   
			#ifdef USB_BS_SYSCAL_ASSERT
				if (!(  mt_busy == 0 ))
			   	{
					iprintf("[ASSERT][USB] urb_task() : " ) ;
    		    			iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    		iprintf("[ASSERT][USB] Continue ..\n") ;
    		   		}
			#endif // USB_BS_ASSERT

			#ifdef USB_NO_ISR_UNLINK
			// 2003/9/12 B. S. Liaw BugFix
				status_unlink = usb_unlink_urb(urb);
				if (status_unlink && status_unlink != -EINPROGRESS)
				{
					USB_DBG_INFO(iprintf("[USB INFO] urb_task() : usb_unlink_urb fail : %d !!\n", status_unlink));
				}
				
				if (  urb->hcpriv != 0 )  /* Charles 20040427 */
        	       		{
					hcd->driver->urb_free_priv(hcd, urb->hcpriv);
					urb->hcpriv = NULL;
				}
			#endif

			dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
                	break ; // to next submit
		} // if complete
               
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0 ))
			{
				iprintf("[ASSERT][USB] urb_task() : " ) ;
    		    		iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
				iprintf("[ASSERT][USB] Continue ..\n") ;
    		   	}
		#endif // USB_BS_ASSERT

		dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK);
	} // for wait complete

	if (next_step & NEXT_STEP_PAUSE)
	{
		USB_DBG_INIT(iprintf("[USB INIT] urb_task() : wait for next step [%08XH] .. \n", urb)) ;
		BLOCK_PREEMPTION;
		urb->next_step |= NEXT_STEP_WC ;
		UNBLOCK_PREEMPTION;

		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0 ))
			{
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    		iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
				iprintf("[ASSERT][USB] Continue ..\n") ;
    		   	}
		#endif // USB_BS_ASSERT
		dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK);          
		while( ! (next_step & NEXT_STEP_CONTI) )
		{
			#ifdef USB_BS_SYSCAL_ASSERT
				if (!(  mt_busy == 0 ))
			   	{
					iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    			iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    		iprintf("[ASSERT][USB] Continue ..\n") ;
    		   		}
			#endif // USB_BS_ASSERT
			dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
			BLOCK_PREEMPTION;
			next_step = urb->next_step ;
			UNBLOCK_PREEMPTION;

		        if (next_step & NEXT_STEP_KILL)
			{
				next_step |= NEXT_STEP_FREE ;
				goto step_free ;
            	   	}
		}
		BLOCK_PREEMPTION;
		urb->next_step &= ~NEXT_STEP_CONTI ;
		urb->next_step &= ~NEXT_STEP_WC ;
		UNBLOCK_PREEMPTION;
		USB_DBG_INIT(iprintf("[USB INIT] urb_task() : wait ok. \n" )) ;
	}

	if (next_step & NEXT_STEP_KILL)
    		next_step |= NEXT_STEP_FREE ;

        // --------------------
        step_free:   
        // --------------------
        
	if (next_step & NEXT_STEP_FREE)
        {
		#if 1  /* Charles 20040423 */        	
			#ifdef TNV105_INTBUG
				TNV105_InterruptPolling();
			#endif
			usb_unlink_urb(urb);
        	#endif
        	
/*		hcd = urb->dev->bus->hcpriv_hcd; *//* Charles 20040427 */
		if (urb->hcpriv)
		{
			USB_DBG_INIT(iprintf("[USB INIT] urb_task(2) : free priv .. \n" )) ;
			USB_DBG_FLOW(iprintf( "[USB FLOW] urb_task() Call hcd->driver->urb_free_priv() ...\n" ));
			hcd->driver->urb_free_priv(hcd, urb->hcpriv);
			USB_DBG_URB(iprintf("[USB URB] urb_task() : Set Vaue : urb->hcpriv = 0 ..\n" ));
			urb->hcpriv = NULL;
		}
               
		if (next_step & NEXT_STEP_KILL)
			break;
	}
           
        if (next_step & NEXT_STEP_SUBMIT)
        {
		USB_DBG_INIT(iprintf("[USB INIT] urb_task() : usb_submit_urb() .. \n" )) ;
		ret = usb_submit_urb(urb);
            	if (ret)
		{
			USB_DBG_INIT(iprintf("[USB INIT] urb_task() : usb_submit_urb failed (%d) !!\n", ret )) ;
		}
        }
 } // infinite for
       
// ---------------
task_end:
// ---------------
// ---------------
task_end_err:
// ---------------
    
 BLOCK_PREEMPTION;
 urb->next_step = NEXT_STEP_NONE ;
 UNBLOCK_PREEMPTION;    
 dprintf("[USB] urb_task killed \n") ;
 USB_DBG_FLOW(iprintf("[USB FLOW] urb_task() End.\n"));
} // function urb_task()
#endif // USB_NO_ISR_CALLBACK


/*-------------------------------------------------------------------*/

/**
 * usb_unlink_urb - abort/cancel a transfer request for an endpoint
 * @urb: pointer to urb describing a previously submitted request
 *
 * This routine cancels an in-progress request.  The requests's
 * completion handler will be called with a status code indicating
 * that the request has been canceled, and that control of the URB
 * has been returned to that device driver.
 *
 * When the URB_ASYNC_UNLINK transfer flag for the URB is clear, this
 * request is synchronous.  Success is indicated by returning zero,
 * at which time the urb will have been unlinked,
 * and the completion function will see status -ENOENT.  Failure is
 * indicated by any other return value.  This mode may not be used
 * when unlinking an urb from an interrupt context, such as a bottom
 * half or a completion handler,
 *
 * When the URB_ASYNC_UNLINK transfer flag for the URB is set, this
 * request is asynchronous.  Success is indicated by returning -EINPROGRESS,
 * at which time the urb will normally not have been unlinked,
 * and the completion function will see status -ECONNRESET.  Failure is
 * indicated by any other return value.
 */
int usb_unlink_urb(struct urb *urb)
{
 /* FIXME
  * We should not care about the state here, but the host controllers
  * die a horrible death if we unlink a urb for a device that has been
  * physically removed.
  */

 #ifdef USB_BS_ASSERT
	if (!(  urb
       ) ) {
		iprintf("[ASSERT][USB] usb_unlink_urb(1) : " ) ;
	    iprintf("Error : !urb !!\n" ) ;
        iprintf("[ASSERT][USB] Continue ..\n") ;
	   }
 #endif // USB_BS_ASSERT

 #ifdef USB_BS_ASSERT
	if (!(  urb->dev
       ) ) {
		iprintf("[ASSERT][USB] usb_unlink_urb(2) : " ) ;
	    iprintf("Error : !urb->dev !!\n" ) ;
        iprintf("[ASSERT][USB] Continue ..\n") ;
	   }
 #endif // USB_BS_ASSERT

 #ifndef USB_NO_ISR_UNLINK
	#ifdef USB_BS_ASSERT
	if (!(  (urb->dev->state >= USB_STATE_DEFAULT) 
       ) ) {
		iprintf("[ASSERT][USB] usb_unlink_urb(3) : " ) ;
	    iprintf("Error : urb->dev->state=%d !!\n",urb->dev->state ) ;
        iprintf("[ASSERT][USB] Continue ..\n") ;
	   }
	#endif // USB_BS_ASSERT
 #endif // ndef USB_NO_ISR_UNLINK

 #ifdef USB_BS_ASSERT
	if (!(  urb->dev->bus
       ) ) {
		iprintf("[ASSERT][USB] usb_unlink_urb(4) : " ) ;
	    iprintf("Error : !urb->dev->bus !!\n" ) ;
        iprintf("[ASSERT][USB] Continue ..\n") ;
	   }

	if (!(  urb->dev->bus->op
       ) ) {
		iprintf("[ASSERT][USB] usb_unlink_urb(5) : " ) ;
	    iprintf("Error : !urb->dev->bus->op !!\n" ) ;
        iprintf("[ASSERT][USB] Continue ..\n") ;
	   }
 #endif // USB_BS_ASSERT

 if (urb && urb->dev &&
	/*
	#ifndef USB_NO_ISR_UNLINK
	    (urb->dev->state >= USB_STATE_DEFAULT) &&
	#endif // ndef USB_NO_ISR_UNLINK
	*/
	 urb->dev->bus && urb->dev->bus->op
   )
   {
	// USB_DBG_INFO(iprintf("[USB INFO] usb_unlink_urb() : bus->op->unlink_urb() .. \n"));
	USB_DBG_INIT(iprintf("[USB INIT] usb_unlink_urb() : bus->op->unlink_urb() .. \n"));
		return urb->dev->bus->op->unlink_urb(urb);
   }
  else
   {
	USB_DBG_INFO(iprintf("[USB INFO] usb_unlink_urb() : Not Call bus->op->unlink_urb !!\n"));
	return -ENODEV; // -19
   }
}

// asynchronous request completion model
#ifndef _ETCPIP
	/*
	EXPORT_SYMBOL(usb_alloc_urb);
	EXPORT_SYMBOL(usb_free_urb);
	EXPORT_SYMBOL(usb_get_urb);
	EXPORT_SYMBOL(usb_submit_urb);
	EXPORT_SYMBOL(usb_unlink_urb);
    */
#endif // ndef _ETCPIP

