

// Name of file : UsbLpt.h
// ====================================================================

/********************************************************************/
/*       Printer Hardware Layer driver Header for USB               */
/*------------------------------------------------------------------*/
/*      Copyright (C) 2003 BRNT			                    */
/*------------------------------------------------------------------*/
/*      Modified, programmed by B. S. Liaw                          */
/*                                                                  */
/*      Description : 2003/4/3 first edited for SS2510 USB          */
/*                             (from w83877.h)                      */
/********************************************************************/

// EPSON C41
//       SCAN2500
// HP DeskJet 840C
// Canon S200SPx

#ifndef __USB_LPT_H__
#define __USB_LPT_H__

// ====================================================================

/* 2003/7/5 B. S. Liaw , Move to UsbLptDbg.h

#define EPSON_LPT_DIAG      // 2003/4/14 B. S. Liaw

// #define LPT_DIAG_NOT_PRINT  // 2003/6/9 B. S. Liaw
// #define LPT_DIAG_LOOP		// 2003/6/12 B. S. Liaw , for infinite test
*/


// #define NEW_EPSON_LPT   // 2003/4/14 B. S. Liaw , This is important !!
				// at least EPSON STYLUS C41UX Need this
                // Now Prt_Open() Has Cover this !!
                // So , Donot Define now !!

// ====================================================================

#define NO_PRT_WRITE_BYTE

// ====================================================================

//U8 Prt_Init(void);    //Init. & check the port connection
//void Prt_Open(void);  //Send Cmd. to the printer for kick off signal
//U8 Prt_Buf_Write(U8 *, U32, U32 *);   //Send data to the Super I/O data port, hardware
//void Prt_Close(void);
//
// In the following, only 4 functions can be called:
//
// if( Prt_Init() )
// {
//      Prt_Open();
//      ...
//      .
//      Prt_Buf_Write(buf, length, &byte_sent);
//      .
//      Prt_Buf_Write(buf, length, &byte_sent);
//      ...
//      Prt_Close();
// }
//Then, the printer can print out.

// These three functions shown previously, Prt_Open(), Prt_Buf_Write(),
//                                  Prt_Close(), are formed as a group.
// I.e., during a printing session,
//     Prt_Open() must be executed first, (called once)
//     then Prt_Buf_Write(), can be called many times to send user data
//                           out to the printer
//                              finally, call Prt_Close() to close this printing session
 // ===================================================================

#define D_Fail  0
#define D_OK    1

#define D_False 0
#define D_True  1

#define D_ESC   0x1b



// ====================================================================

/*
#define	D_Prt_Wait_TimeOut	0x2000000
	// for Compaq IJ600, the max. waiting time is around 0x20000
                        //HP LaserJet 5L, the max. waiting time is around 0x238364
                        //but the average communication time is faster than Compaq IJ600
                        
#define D_Prt_wait_TimeOut_ms 950       // we must set this timeout smaller than printer busy recover time (hardware behavior)
                                        // to detect printer is really in busy state
                                        // Ref. HP DJ500  1000 ~ 1020 ms.,  Epson stylus480 1000 ~ 1010 ms.
                                        //      HP Laser 5L     very big,   Compaq IJ600          very big
*/
// ====================================================================


// ====================================================================

extern int volatile usblp_plug_out ; // 1 : the USB Cable Plug Out 
extern int volatile usb_lpt_ok ;     // 1 : Driver Init Ok

// ====================================================================

/******** The following are SPP/EPP Commands *********/
/**********************************************************************
Name: U8 Prt_Init(void)
Purpose: Init. & check the port connection
Input: none
Output: 1: everything is O.K.; otherwise, return 0
Note:
**********************************************************************/

unsigned char Prt_Init(void);  //Init. & check the port connection


/**********************************************************************
Name:void Prt_Open( void)
Purpose: Send Cmd. to the printer for kick off signal
Input: Set or clear Auto feed function
Output: none
Note:
**********************************************************************/

 void Prt_Open(void);    //Send Cmd. to the printer for kick off signal

/**********************************************************************
Name:void Prt_Buf_Write(U8 *LV_Ptr, U32 LV_Legth, U32 *byte_sent)
Purpose: Send data to the Super I/O data port, hardware
Input: data pointer & length
Output: D_OK: everything is O.K.;
        D_False: timeout has been reached.
Note: If there is any error during sending to the printer,
      number of byte sent will be reported to (*byte_sent).
**********************************************************************/

unsigned char Prt_Buf_Write(unsigned char *LV_Ptr, unsigned long LV_Legth, unsigned long *byte_sent) ;
 //Send data to the Super I/O data port, hardware

/**********************************************************************
Name: void Prt_Close(void)
Purpose: close the printing session
Input:
Output:
Note:
**********************************************************************/

void Prt_Close(void) ;


// ====================================================================

void ParallelTest(void) ;

#if defined(_NB_SHARE) || (_LPD >=1)

/*************************************************/
unsigned char Prt_Get_S_EPP_Sts(void) ;
/**********************************************************************
Name: U8 Prt_Check_Port_Pwr_Connect(void)
Purpose: Check the Printer port if it's powered & connected.
Input: none
Output: 1: everything is O.K.; otherwise, return 0
Note:
**********************************************************************/

 unsigned char Prt_Check_Port_Pwr_Connect(void);    //Check the Printer port if it's powered & connected.
#endif // defined(_NB_SHARE) || (_LPD >=1)

#if defined(_NB_SHARE) || (_LPD >=1)

/**********************************************************************
Name: U8 Prt_Sts_Check_On_Line(void)
Purpose: Check if the printer is in the on-line state
Input: none
Output: A logic 1 means the printer is on line;
        a logic 0 means it is not selected.
Note:
**********************************************************************/

unsigned char Prt_Sts_Check_On_Line(void); //Check if the printer is in the on-line state

/**********************************************************************
Name: U8 Prt_Sts_Check_Paper_End(void)
Purpose: Check if the printer has run out of the paper
Input: none
Output: A logic 1 indicates a paper end;
        a logic 0 means the presence of paper.
Note:
**********************************************************************/

 unsigned char Prt_Sts_Check_Paper_End(void);//Check if the printer has run out of the paper
 //  return : D_False : Bit Value 0 : Error

#endif // _NB_SHARE


#if (_LPD >= 1) || defined(_NB_SHARE)

 extern unsigned char Prt_Sts_Check_Error(void) ;
 
 /*
 extern U8 Prt_Sts_Check_Busy(void) ;
 */
#endif // _LPD


#if defined(_NB_SHARE) || (_LPD >=1)
/**********************************************************************
Name: Prt_Reset(void)
Purpose: Send a hardware INIT-low signal to the printer to reset to
        its power-up state
Input: none
Output: none
Note: When INIT becomes LOW, the printer controller is reset to its
        power-up state and the print buffer is cleared.
**********************************************************************/

 void Prt_Reset(void);   //Send a hardware INIT-low signal to the printer to reset to its power-up state

#endif // defined(_NB_SHARE) || (_LPD >=1)

// ====================================================================
/**********************************************************************
Name: U8 Prt_Write_Byte(U8 LV_BYTE)
Purpose: write data to printer port
Input: Data Byte
Output: D_OK: everything is O.K.; D_False: timeout has been reached.
Note:
**********************************************************************/

#ifndef NO_PRT_WRITE_BYTE
	unsigned char Prt_Write_Byte(unsigned char LV_BYTE) ;
#endif // ndef NO_PRT_WRITE_BYTE

#ifdef _NB_SHARE
/*************************************************/

void Prt_nStrobe(void) ;  //Cause nStrobe a low pulse, 19092001

/*************************************************/
void Prt_Config_83877_PPM(unsigned char LV_ppm) ;    /* Set Parallel Port Mode */
#endif // _NB_SHARE

// ====================================================================

/**********************************************************************
Name: U8 Prt_Sts_wait_nBusy(void)
Purpose: wait for nBusy to be released, i.e., going to high
Input: none
Output: D_OK: everything is O.K.; D_False: timeout has been reached.
Note: A logic 0 in this bit, hardware pin, means that the printer is
                busy and cannot accept a new character.
      A logic 1 means that it is ready to accept the next character.
**********************************************************************/

unsigned char Prt_Sts_wait_nBusy(void) ;

#ifdef _NB_SHARE
// **********************************************************************
// FUNCTION:  printerConnect
// PURPOSE:  get printer state (can be called from outside this module)
// RETURN:
//			0: off,  1: on,  2: printing
// **********************************************************************
 
extern unsigned char printerConnect(void) ;

#endif // _NB_SHARE

#ifdef _NB_SHARE
	// 2003/11/12 B. S. Liaw add this function
	extern unsigned char * Prt_GetId(void) ;
#endif // _NB_SHARE


// ====================================================================
#endif // ndef __USB_LPT_H__
// ====================================================================

// End of file : UsbLpt.h

