#ifndef	_ETCPIP_H_
#define	_ETCPIP_H_

#include "mt.h"

#define	NULL		(0)
#define size_t		int
#define	u_long		unsigned long
#define	ssize_t		int
#define uint		unsigned int
#define u_short		unsigned short

#define YIELD() scdtsk()
#define SIGNAL(signo) setevt(signo)
#define BLOCK_PREEMPTION	mt_busy++
#define UNBLOCK_PREEMPTION	mt_busy--
#define MSECTOTICKS(msecs) (unsigned long)(((unsigned long)msecs*CLOCKHZ)/1000)

/* Semaphore Declaration */
enum {
    ENUM_RSV_RES = 0,
    ENUM_IF_MT_RES,
#define IF_MT_RES       ENUM_IF_MT_RES
    ENUM_IP_MT_RES,
#define IP_MT_RES       ENUM_IP_MT_RES
#ifdef _ROUTING
    ENUM_MT_RES_RT,
#define MT_RES_RT       ENUM_MT_RES_RT
#endif				/* _ROUTING */
#ifdef _BRIDGING
    ENUM_BR_MT_RES,
#define BR_MT_RES       ENUM_BR_MT_RES
#endif				/* _BRIDGING */
#ifdef _HTTPD
    ENUM_TIMER_RESOURCE,
    ENUM_FS_RESOURCE,
#define TIMER_RESOURCE  ENUM_TIMER_RESOURCE
#define FS_RESOURCE    ENUM_FS_RESOURCE
#endif /* _HTTPD */
#ifdef _ADSL
    ENUM_MT_RES_ADSL,
#define MT_RES_ADSL     ENUM_MT_RES_ADSL
#endif				/* ADSL */
#ifdef _SYSLOG
    ENUM_MT_RES_LOG,
#define MT_RES_LOG      ENUM_MT_RES_LOG
#endif              /* _SYSLOG */
#ifdef _MPPE
	MPPE_RES,
#endif				/* _MPPE */
#ifdef _802DOT1X    /* 802.1X */
    ENUM_DOT1X_RES,
    #define MT_RES_DOT1X    ENUM_DOT1X_RES
#endif
#ifdef _NB_SHARE  // PTR-TI-0056 2004.07.01
	ENUM_NBIOS_RES_FILE,
	#define NBIOS_RES_FILE		ENUM_NBIOS_RES_FILE
	ENUM_NBIOS_RES_SS,
	#define NBIOS_RES_SS		ENUM_NBIOS_RES_SS
#endif // _NB_SHARE
#ifdef TSDFFS
	ENUM_FFS_RES,
	#define FFS_RESOURCE	ENUM_FFS_RES
#endif // TSDFFS
#ifdef FATFS  // PTR-TI-0056 2004.07.01
	ENUM_FATFS_RES,
	ENUM_FATFS_RES_DRV,
	ENUM_FATFS_RES_RCMD,
	ENUM_FATFS_RES_WCMD,
	ENUM_FATFS_RES_FILE,
	ENUM_FATFS_RES_HANDLE,
	ENUM_FATFS_RES_VOL0,
	ENUM_FATFS_RES_VOL1,
	ENUM_FATFS_RES_VOL2,
	ENUM_FATFS_RES_VOL3,
	ENUM_FATFS_RES_VOL4,
	ENUM_FATFS_RES_VOL5,
	ENUM_FATFS_RES_VOL6,
	ENUM_FATFS_RES_VOL7,
	ENUM_FATFS_RES_VOL8,
	ENUM_FATFS_RES_VOL9,
	ENUM_FATFS_RES_VOL10,
	ENUM_FATFS_RES_VOL11,
	#define FATFS_RES			ENUM_FATFS_RES
	#define FATFS_RES_DRV		ENUM_FATFS_RES_DRV
	#define FATFS_RES_RCMD		ENUM_FATFS_RES_RCMD
	#define FATFS_RES_WCMD		ENUM_FATFS_RES_WCMD
	#define FATFS_RES_FILE		ENUM_FATFS_RES_FILE
	#define FATFS_RES_HANDLE	ENUM_FATFS_RES_HANDLE
	#define FATFS_RES_VOL0		ENUM_FATFS_RES_VOL0
	#define FATFS_RES_VOL1		ENUM_FATFS_RES_VOL1
	#define FATFS_RES_VOL2		ENUM_FATFS_RES_VOL2
	#define FATFS_RES_VOL3		ENUM_FATFS_RES_VOL3
	#define FATFS_RES_VOL4		ENUM_FATFS_RES_VOL4
	#define FATFS_RES_VOL5		ENUM_FATFS_RES_VOL5
	#define FATFS_RES_VOL6		ENUM_FATFS_RES_VOL6
	#define FATFS_RES_VOL7		ENUM_FATFS_RES_VOL7
	#define FATFS_RES_VOL8		ENUM_FATFS_RES_VOL8
	#define FATFS_RES_VOL9		ENUM_FATFS_RES_VOL9
	#define FATFS_RES_VOL10		ENUM_FATFS_RES_VOL10
	#define FATFS_RES_VOL11		ENUM_FATFS_RES_VOL11
#endif // FATFS
#ifdef _UPNP
    ENUM_MT_RES_UPNP_START,
#define MT_RES_UPNP_DEBUG		ENUM_MT_RES_UPNP_START
    ENUM_MT_RES_UPNP_END = (ENUM_MT_RES_UPNP_START+10),
#define MT_RES_UPNP_END     ENUM_MT_RES_UPNP_END
#define MT_RES_UPNP_START		ENUM_MT_RES_UPNP_START
#endif //_UPNP
// PTR-TI-0126
#ifdef _JAVELIN
    ENUM_MT_RES_JAVELIN_SMLOCK,
#define MT_RES_JAVELIN_SMLOCK   ENUM_MT_RES_JAVELIN_SMLOCK
#endif
#if (_USB_MS >= 1)
	ENUM_MT_RES_USBMS_LOWER_IO,
#define MT_RES_USBMS_LOWER_IO	ENUM_MT_RES_USBMS_LOWER_IO
	ENUM_MT_RES_USBMS_IO,
#define MT_RES_USBMS_IO			ENUM_MT_RES_USBMS_IO
	ENUM_MT_RES_USBMS_CACHE,
#define MT_RES_USBMS_CACHE		ENUM_MT_RES_USBMS_CACHE
#endif // _USB_MS
#if (_USB2 >= 1)
	ENUM_MT_RES_USB_HW_DEVICE,
#define MT_RES_USB_HW_DEVICE	ENUM_MT_RES_USB_HW_DEVICE
	ENUM_MT_RES_USB_MEM,
#define MT_RES_USB_MEM		ENUM_MT_RES_USB_MEM
#endif	// _USB2
};

/* Event Declaration */
enum {
    MT_EVT_RESERVED = 0,
    PERIOD_EVT,
    TIMER_EVT,
#ifdef _CXEMAC
    EMAC_EVT,
#endif
#ifdef _MPC850
    UART_TX_EVT,		// used for interrupt driven UART, add by bnchen, 2000/06/14
    UART_RX_EVT,		// used for interrupt driven UART, add by bnchen, 2000/06/14
#endif				// _MPC850
#ifdef _VOIP            //Quantum Added for VOIP   900827
	VOIP_POLLING_EVT,
	VOIP_PLAYING_EVT,
#endif //_VOIP
#ifdef _DHCP_CLT
    PERIOD_DHCP_EVT,
    DHCP_ACT_EVT,
#endif
// MALONE-BACKUP-03, malone, 06/21/2001
#ifdef _BACKUP
    // MALONE-BACKUP-02, malone, 06/20/2001
    LNKTEST_EVT,		// link test event, malone 06/20/2001
#endif				// _BACKUP
#ifdef _ADSL
    LED_EVT,
    ENUM_MT_EVT_ADSL,
#define MT_EVT_ADSL ENUM_MT_EVT_ADSL
#endif				/* _ADSL */
#ifdef _USB_SLAVE  /* Charles 20040311 */
    USB_SLAVE_TIMER_EVT,
#endif				/* USB_SLAVE */
#ifdef _RIP
    ENUM_SIG_RIP,
#define SIG_RIP ENUM_SIG_RIP
#endif				/* _RIP */
#ifdef _802DOT1X    /* 802.1X */
	ENUM_DOT1X_EVT ,            // should be a period event
	#define MT_EVT_DOT1X ENUM_DOT1X_EVT
	// #endif
	//#ifdef BANDWIDTH_LIMIT
	//    BW_MANG_EVENT,
	//#endif
#endif
#ifdef TSDFFS
	FFS_GARBAGE_EVT,
#endif // TSDFFS
#ifdef _EDiMAX_WD_2
    EDiMAX_EVT,
#endif //_EDiMAX_WD_2
#if (_HWLAN==6)
	radarTask_EVT0,
	radarTask_EVT1,
#endif
 #if (_USB >= 1)  // PTR-TI-0056 2004.07.01
	ENUM_USB_EVT ,
	#define MT_EVT_USB ENUM_USB_EVT
	ENUM_USB_HC_EVT ,
	#define MT_EVT_USB_HC ENUM_USB_HC_EVT
	ENUM_USB_HUB_EVT ,
	#define MT_EVT_USB_HUB ENUM_USB_HUB_EVT
 	ENUM_USB_HOST_EVT,
 	#define MT_EVT_USBHOST_SYNC ENUM_USB_HOST_EVT
 #endif // _USB
 #if (_USB_MS >= 1)
	ENUM_USBMS_DOWN_EVT ,  // PTR-TI-0056 2004.07.01
	#define MT_EVT_USBMS_DOWN ENUM_USBMS_DOWN_EVT  // PTR-TI-0056 2004.07.01
	ENUM_USBMS_EH_EVT ,
	#define MT_EVT_USBMS_EH ENUM_USBMS_EH_EVT
	ENUM_USBMS_RQ_EVT ,
	#define MT_EVT_USBMS_RQ ENUM_USBMS_RQ_EVT
	ENUM_USBMS_RQBI_EVT ,
	#define MT_EVT_USBMS_RQBI ENUM_USBMS_RQBI_EVT
	ENUM_USBMS_CACHE_REQ_EVT,
	#define MT_EVT_USBMS_CACHE_REQ ENUM_USBMS_CACHE_REQ_EVT
	ENUM_USBMS_CACHE_CMPL_EVT,
	#define MT_EVT_USBMS_CACHE_CMPL ENUM_USBMS_CACHE_CMPL_EVT
 #endif // _USB_MS
 #if (_USB2 >= 1)
	ENUM_USB2_TIMER ,
	#define MT_EVT_USB2_TIMER ENUM_USB2_TIMER
 #endif	// _USB2
};

	#define STYPE_DISKTREE				0	// Disk Directory Tree
	#define STYPE_PRINTQ				1	// Printer Queue

#ifdef fd_set
#undef fd_set
#endif
typedef struct fd_set {
        u_short fd_count;               /* how many are SET? */
        u_long  fd_array[50];
} fd_set;

#endif	// _ETCPIP_H_
