// include/asm/byteorder.h
// include/asm-mips/byteorder.h

/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1996, 99, 2003 by Ralf Baechle
 */
#ifndef __ASM_BYTEORDER_H__
#define __ASM_BYTEORDER_H__

#ifdef BIG_ENDIAN
#ifndef __MIPSEB__
#define __MIPSEB__
#endif	// __MIPSEB__
#elif defined (LITTLE_ENDIAN)
#ifndef __MIPSEL__
#define __MIPSEL__
#endif	// __MIPSEL__
#endif

/*
#include <asm/types.h>
*/
#ifdef __GNUC__

#if !defined(__STRICT_ANSI__) || defined(__KERNEL__)
#  define __BYTEORDER_HAS_U64__
#define __u64 unsigned long long  // B. S. Liaw , from asm-mips/types.h
#  define __SWAB_64_THRU_32__
#endif

#endif /* __GNUC__ */

#if defined (__MIPSEB__)
/*
#  include <linux/byteorder/big_endian.h>
*/
#include "byteorder/big_endian.h"
#elif defined (__MIPSEL__)
/*
#  include <linux/byteorder/little_endian.h>
*/
#include "byteorder/little_endian.h"
#else
#  error "MIPS, but neither __MIPSEB__, nor __MIPSEL__???"
#endif

#endif // __ASM_BYTEORDER_H__ 
