#include	<stdarg.h>

#define GETAP(ap) \
    ap = (char *) va_arg(args,char *);

/**  the following routines are for sscnaf **/

static match(char *fmt, char cc)
{
    int exc=0;
    char *cp1;

    if (!cc)
	return 0;
    if (*fmt == '^')
    {
	exc = 1;
	fmt++;
    }
    for (cp1=fmt; *cp1 && *cp1 != ']'; )
    {
	if (cp1[1] == '-' && cp1[2] > cp1[0])
	{
	    if (cc >= cp1[0] && cc <= cp1[2])
		return exc^1;
	    cp1 += 3;
	}
	else
	{
	    if (cc == *cp1)
		return exc^1;
	    cp1++;
	}
    }
    return exc;
}

static long asclng(char **cp, int width, int base)
{
    long answer;
    char cc, sign, *cp1;

    answer = sign = 0;
    for (cp1=*cp; *cp1; cp1++)
    {
	if (*cp1 > ' ')
	    break;
    }
    if (*cp1 == '-' || *cp1 == '+')
	sign = *cp1++, width--;
    if (!*cp1 || !width)
	goto exi1;
    if (!base)
    {
	base = 10;
	if (*cp1 == '0')
	{
	    base = 8;
	    goto lab4;
	}
    }
    else if (base == 16)
    {
	if (*cp1 == '0')
	{
lab4:	    cp1++, width--;
	    if (width > 0)
	    {
		if (*cp1 == 'x' || *cp1 == 'X')
		    base = 16, cp1++, width--;
	    }
	}
    }
    for ( ; width && *cp1; cp1++,width--)
    {
	if ((cc = *cp1) < '0')
	    break;
        if (cc <= '9')
	    cc &= 0xf;
        else
        {
	    cc &= 0xdf;
	    if (cc >= 'A')
	        cc -= 'A' - 10;
        }
        if (cc >= base)
	    break;
	answer = base * answer + cc;
    }
exi1:
    *cp = cp1;
    if (sign == '-')
	answer = -answer;
    return answer;
}

int sscanf(char *buf, char *fmt, ...)
/*
	vsscanf:	Reentrant Scan Routine
	entry:		&input buffer
			&format string
			&argument list
	exit:		return value is number of fields scanned
*/
{
    int field;		/* field flag: 0=background, 1=%field */
    int sizdef;		/* size: 0=default, 1=short, 2=long, 3=long double */
    int width;		/* field width */
    int par1;
    long l1;
    int nfields;
    char fch;
    char *orgbuf, *prebuf;
    char *ap;
    va_list args;

    va_start(args,fmt);			/* get variable arg list address */
    if (!*buf)
	return -1;
    nfields = field = sizdef = 0;
    orgbuf = buf;
    while ((fch = *fmt++) != 0)
    {
	if (!field)
	{
	    if (fch == '%')
	    {
		if (*fmt != '%')
		{
		    field = 1;
		    continue;
		}
		fch = *fmt++;
	    }
	    if (fch <= ' ')
		for (; *buf== ' '||*buf=='\t'; buf++) ;
	    else if (fch == *buf)
		buf++;
	}
	else
	{
	    width = 0x7fff;
	    if (fch == '*')
	    {
		width = va_arg(args,int);
		goto lab6;
	    }
	    else if (fch >= '0' && fch <= '9')
	    {
		fmt--;
		width = asclng(&fmt,9,10);
lab6:		fch = *fmt++;
	    }
	    if (fch == 'h')
	    {
		sizdef = 1;
		goto lab7;
	    }
	    else if (fch == 'l')
	    {
		sizdef = 2;
lab7:       	fch = *fmt++;
	    }
	    prebuf = buf;
            switch (fch)
	    {
	    case 'd':				/* signed integer */
		par1 = 10;
		goto lab3;
	    case 'o':				/* signed integer */
		par1 = 8;
		goto lab3;
	    case 'x':				/* signed integer */
	    case 'X':				/* long signed integer */
		par1 = 16;
		goto lab3;
	    case 'u':				/* unsigned integer */
	    case 'i':				/* signed integer */
		par1 = 0;
lab3:		GETAP(ap);
		l1 = asclng(&buf, width, par1);
		if (prebuf == buf)
		    break;
		if (sizdef == 2)
		    *(long *)ap = l1;
		else if (sizdef == 1)
		    *(short *)ap = l1;
		else
		    *(int *)ap = l1;
		goto lab12;
	    case 'c':				/* character */
		GETAP(ap);
		for (; width && *buf; width--)
		{
		    *ap++ = *buf++;
		    if (width == 0x7fff)
			break;
		}
		goto lab12;
	    case '[':				/* search set */
		GETAP(ap);
		for (; width && match(fmt,*buf); width--)
		    *ap++ = *buf++;
		while (*fmt++ != ']') ;
		goto lab11;
	    case 's':				/* character array */
		GETAP(ap);
		for (; *buf==' '||*buf==0x07; buf++) ;
		for (; width && *buf && *buf>' '; width--)
		    *ap++ = *buf++;
lab11:		if (prebuf == buf)
		    break;
		*(char *)ap = 0;
		goto lab12;
	    case 'n':				/* store # chars */
		GETAP(ap);
		*(int *)ap = buf - orgbuf;
		break;
	    case 'p':				/* pointer */
		GETAP(ap);
		*(long *)ap = asclng(&buf, width, 16);
lab12:		nfields++;
		break;
	    default:				/* illegal */
		goto term;
	    }
	    field = 0;
	}
	if (!fch)
	    break;
    }
term:
    return nfields;
}

#if 0
/**  the following routines are for ssprintf **/

static void insert(char *s, char c)	/* insert c at head of string s */
{
    char *tmps;

    tmps = s;
    while (*tmps++);
    while( tmps > s ){
	tmps--;
	tmps[1] = tmps[0];
    }
    *s = c;
}


static void append(char *s, char c)	/* append c to end of string s */
{
    while(*s++);
    *s-- = 0;
    *s = c;
}

static int visprintf(char *buf, char *fmt, va_list args)
{
    int count;
    int pwidth,width,pcnt,base;
    unsigned long num;
    char fch, c;		/* format char */
    char *s, *bp;
    char ljust, zsup;	/* left justify, zero suppress flags */
    char sign;		/* signed number conversion flag */
    char letter;		/* hex conversion letter increment */
    char islong;		/* long integer flag */
    char pflag;

    count = 0;
    *buf = 0;
    bp = buf;				/* point to start of buf */
    while((fch = *fmt++) != 0){
	while(*bp)			/* find end of current string */
	    bp++;			/*  where next field starts */
	if( fch == '%' ){
	    if ((fch= *fmt++) == '%')
		goto copy;
	    if ((ljust = fch) == '-')	/* left justify flag */
		fch = *fmt++;
	    zsup = fch;			/* zero suppression */
	    pwidth = sizeof(void *)*2;	/* minimum pointer print width */
	    pcnt = 0;			/* printed length of current field */
	    sign = 0;			/* default unsigned */
	    pflag = 0;			/* not %p spec */
	    base = 10;			/* default base */
	    if (fch == '*')
		width = va_arg(args, int);
	    else
	    {
	        for (width=0; fch>='0' && fch<='9'; fch=*fmt++)
		    width = width * 10 + fch - '0';
	    }
	    if ((islong = (fch & 0xdf)) == 'L')
		fch = *fmt++;
	    switch( fch ){
		case 'd':
		    sign = 1;
		    goto donumber;
		case 'o':		/* octal */
		    base = 8;
		    goto donumber;
		case 'u':
		    goto donumber;
		case 'x':		/* hex */
		    base = 16;
		    letter = 'a'-10;
		    goto donumber;
		case 'X':
		    base = 16;
		    letter = 'A'-10;
		    goto donumber;
		case 'p':		/* void * */
		    pflag = 1;
		    if( width < pwidth )
			width = pwidth;
		    base = 16;
		    letter = 'A'-10;
		    num = (long)va_arg(args, void *);
		    goto doptr;
		case 'c':
		    fch = (char) va_arg(args, int);
		    goto copy;
		case 's':
		    s = va_arg(args,char *);
		    while( *s ){		/* copy string to buf */
			append(bp,*s++);
			count++;
			pcnt++;
		    }
		    for( ; pcnt<width; pcnt++){
			count++;
			if (ljust == '-')
			    append(bp, ' ');
			else{
			    insert(bp, ' ');
			}
		    }
		    goto endarg;
	    }
donumber:
    {
	if (islong == 'L')
	    num = va_arg(args, long int);		/* long argument */
	else if (sign)
	    num = (long)va_arg(args, int);		/* integer argument */
	else
	    num = (long)va_arg(args, unsigned int);	/* unsigned integer */
	if( sign && (num & 0x80000000) ){
	    sign = 1;		/* do sign */
	    num = -num;
	}else{
	    sign = 0;
	}
doptr:
	while( num != 0l ){
	    c = num % base;
	    num /= base;
	    insert(bp, (char)(c > 9 ? c + letter : (char)c + '0'));
	    pcnt++;			/* count digits */
	    count++;
	}
	if(!*bp){
	    insert(bp, '0');		/* at least 1 zero */
	    pcnt++;
	    count++;
	}
	if( pflag ){
	    for(;pcnt < pwidth; pcnt++){
		insert(bp, '0');
		count++;
	    }
	}
	if (zsup != '0') zsup = ' ';	/* pad char */
	for (pcnt += sign ;pcnt < width; pcnt++)
	    if (ljust == 'L'){		/* left justified ? */
		append(bp, ' ');
		count++;
	    }else{
		insert(bp, zsup);
		count++;
	    }
	if (sign)
	    insert(bp, '-');
    }

	}else{
copy:	    append(bp++, fch);		/* copy char to output */
	    count++;
	}
endarg:
	continue;
    }
    return count;
}
#endif //0

int x_visprintf(char *buf, char *fmt, va_list args);

int sprintf(char *buf, char *fmt, ...)
{
    va_list args;

    va_start(args,fmt);
    //return visprintf(buf,fmt,args);
    return x_visprintf(buf,fmt,args);
}

