
// Name of File : UsbMsDbg.h
// ====================================================================

#ifndef __USB_MS_DBG_H__
#define __USB_MS_DBG_H__

// ====================================================================
// Macro for deciding whether to print a lot of 
// debugging information for USBMS .


// #ifdef _CODE_TYPE_DEBUG // 2003/01/24 B. S. Liaw
#ifdef USB_CODE_TYPE_DEBUG // 2003/5/19 B. S. Liaw
	
    // Turn On debug message Needed
	#define USBMS_CODE_TYPE_DEBUG // 2003/5/19 B. S. Liaw
    #define USBMS_BS_ASSERT
    
    // Turn Off all debug message and Turn On Debug Assert Only !!
	/*
	#undef USBMS_CODE_TYPE_DEBUG // 2003/5/19 B. S. Liaw
    #undef USBMS_BS_ASSERT
    */
 #else
	#undef USBMS_CODE_TYPE_DEBUG // 2003/5/19 B. S. Liaw
    #undef USBMS_BS_ASSERT
#endif // _CODE_TYPE_DEBUG // 2003/01/24 B. S. Liaw

// ====================================================================

#ifdef USB_BS_ASSERT
    #define USBMS_BS_ASSERT
#endif // USB_BS_ASSERT

#ifdef USBMS_BS_ASSERT
    #warning: USBMS_BS_ASSERT : ON !!
#endif // USBMS_BS_ASSERT

// ====================================================================
// Macro for deciding whether to print a lot of 
// debugging information.

#ifdef USBMS_CODE_TYPE_DEBUG // 2003/01/24 B. S. Liaw
	#warning : USB MAC Debug Message : ON !!
	// ================================================================

	/*
	#define    CONFIG_USB_STORAGE_DEBUG
	*/
	//#define    CONFIG_SCSI_REPORT_LUNS
	// #define CONFIG_SCSI_MULTI_LUN
	// #define CONFIG_SCSI_PROC_FS

	// ASCII values for a number of symbolic constants, printing functions
	//#define CONFIG_SCSI_CONSTANTS

	// ================================================================

     #define USBMS_DBG_INFO_ON
	 #define USBMS_DBG_INIT_ON
    
     // #define USBMS_DBG_FLOW_ON

	// #define USBMS_DBG_PLUG_ON
      // #define USBMS_DBG_MEM_ON

	// #define  USBMS_DBG_BUFFER_ON  // I/O Buffer alocate/dump

    // ----- High Layer Disk -------

	// #define USBMS_DBG_DISABLE_FATIF  // will not do FAT init
										// and not do sector R/W
	// #define USBMS_DBG_SECTOR_ON   // include Sector dump

	// #define USBMS_DBG_PARTITION_ON

	// #define USBMS_DBG_EMU_FLOPPY  // Emulate floppy disk for FatBlockIo.c

    // ----- Block Device I/O Modle -------
	#define USBMS_DBG_RD_CACHE_ON      // Block I/O Layer Cache
	#define USBMS_DBG_WR_CACHE_ON      // Block I/O Layer Cache

	//#define USBMS_DBG_BLOCK_INFO_ON    // Block I/O sector count
	// #define USBMS_DBG_BLOCK_ON
    // #define USBMS_DBG_READ_ONLY  // Not Really do the Sector Write

    // ----- Middle Layer SCSI -------
	// #define USBMS_DBG_SCAN_ON
	// #define USBMS_DBG_SCSI_ON
    
    // ----- Low Level USB URB I/O -------
    // #define USBMS_DBG_URB_ON
    //#define USBMS_DBG_CALLBACK_ON
	// #define  USBMS_DBG_URB_BUFFER_ON  // URB Buffer dump

    // ============================= 
    // Debug Assert !!
    //#define USBMS_BS_ASSERT        
    // #define USBMS_DBG_ABORT   // for debug Abort/Prefetch Error !!
    
    #ifdef USBMS_DBG_INIT_ON
		#define USBMS_BS_SYSCAL_ASSERT
	 #else
		#undef USBMS_BS_SYSCAL_ASSERT
		// #define USBMS_BS_SYSCAL_ASSERT
    #endif
 #else
   // #error : Not Turn Debug Message !!
   // #warning : USB MAC Debug Message : OFF !!
	#undef USBMS_BS_SYSCAL_ASSERT
#endif

#ifdef USBMS_BS_ASSERT
	#warning: USBMS_BS_ASSERT : ON !!
#endif // def USBMS_BS_ASSERT

// --------------------------------------------------------------------

#ifdef USBMS_DBG_INFO_ON
     #define USBMS_DBG_INFO(A) { A ; }
 #else
     #define USBMS_DBG_INFO(A)
#endif

#ifdef USBMS_DBG_FLOW_ON
     #define USBMS_DBG_FLOW(A) { A ; }
 #else
     #define USBMS_DBG_FLOW(A)
#endif

#ifdef USBMS_DBG_FLOWTIMCRY_ON
     #define USBMS_DBG_FLOWTIMCRY(A) { A ; }
 #else
     #define USBMS_DBG_FLOWTIMCRY(A)
#endif

#ifdef USBMS_DBG_INIT_ON
     #define USBMS_DBG_INIT(A) { A ; }
   #else
     #define USBMS_DBG_INIT(A)
#endif

#ifdef USBMS_DBG_PLUG_ON
     #define USBMS_DBG_PLUG(A) { A ; }
   #else
     #define USBMS_DBG_PLUG(A)
#endif

#ifdef USBMS_DBG_SECTOR_ON
     #define USBMS_DBG_SECTOR(A) { A ; }
   #else
     #define USBMS_DBG_SECTOR(A)
#endif

#ifdef USBMS_DBG_PARTITION_ON
     #define USBMS_DBG_PARTITION(A) { A ; }
   #else
     #define USBMS_DBG_PARTITION(A)
#endif

#ifdef USBMS_DBG_SCAN_ON
     #define USBMS_DBG_SCAN(A) { A ; }
   #else
     #define USBMS_DBG_SCAN(A)
#endif

#ifdef USBMS_DBG_SCSI_ON
	#define    CONFIG_SCSI_LOGGING
	#define USBMS_DBG_SCSI(A) { A ; }
 #else
	#define USBMS_DBG_SCSI(A)
#endif

#ifdef  USBMS_DBG_BUFFER_ON
     #define  USBMS_DBG_BUFFER(A) { A ; }
   #else
     #define  USBMS_DBG_BUFFER(A)
#endif


#ifdef USBMS_DBG_MEM_ON
     #define USBMS_DBG_MEM(A) { A ; }
   #else
     #define USBMS_DBG_MEM(A)
#endif


#ifdef USBMS_DBG_URB_ON
	#define  CONFIG_USB_STORAGE_DEBUG
	#define USBMS_DBG_URB(A) { A ; }
  #else
	#undef  CONFIG_USB_STORAGE_DEBUG
	#define USBMS_DBG_URB(A)
#endif

#ifdef USBMS_DBG_CALLBACK_ON
     #define USBMS_DBG_CALLBACK(A) { A ; }
   #else
     #define USBMS_DBG_CALLBACK(A)
#endif

#ifdef USBMS_DBG_ATTACH_ON
     #define USBMS_DBG_ATTACH(A) { A ; }
   #else
     #define USBMS_DBG_ATTACH(A)
#endif

#ifdef USBMS_DBG_PIPE_ON
     #define USBMS_DBG_PIPE(A) { A ; }
   #else
     #define USBMS_DBG_PIPE(A)
#endif

#ifdef USBMS_DBG_CTLMSG_ON
     #define USBMS_DBG_CTLMSG(A) { A ; }
   #else
     #define USBMS_DBG_CTLMSG(A)
#endif

#ifdef USBMS_DBG_RD_CACHE_ON
     #define USBMS_DBG_RD_CACHE(A) { A ; }
   #else
     #define USBMS_DBG_RD_CACHE(A)
#endif

#ifdef USBMS_DBG_WR_CACHE_ON
     #define USBMS_DBG_WR_CACHE(A) { A ; }
   #else
     #define USBMS_DBG_WR_CACHE(A)
#endif

#ifdef USBMS_DBG_BLOCK_INFO_ON
     #define USBMS_DBG_BLOCK_INFO(A) { A ; }
   #else
     #define USBMS_DBG_BLOCK_INFO(A)
#endif

#ifdef USBMS_DBG_BLOCK_ON
     #define USBMS_DBG_BLOCK(A) { A ; }
   #else
     #define USBMS_DBG_BLOCK(A)
#endif

// --------------------------------------------------------------------

#ifdef USBMS_DBG_READ_ONLY
	#warning: USBMS_DBG_READ_ONLY : ON , Donot Really do Write !!
#endif // USBMS_DBG_READ_ONLY

// ====================================================================

extern void sector_read_verify(void) ; // on storage/FatBlockIo.c
extern void sector_read_speed(void) ; // on storage/FatBlockIo.c
// extern void DumpSector(unsigned long SectorNo) ;
extern void DumpSector(unsigned long PartitionID,unsigned long SectorNo) ;

// ====================================================================

#endif // ndef __USB_MS_DBG_H__

// ====================================================================
// End of File : UsbMsDbg.h

