
// Name of File : UsbMsInit.c
// ====================================================================

#define __USB_MS_INIT_C__

// ====================================================================

#define __KERNEL__
#ifdef _NEWLIB
	#include "string.h"
#endif
#include "EtcpipDbg.h" // 2002/10/25 B. S. Liaw
	// for deciding whether to compile
	//  Debug Version or Release Version
#include "etcpip.h"
#include "UsbDbg.h"
#include "PoList.h" // osport_list.h
#include "UsbCfg.h" // Config and Setting
#include "UsbMsCfg.h" // Config and Setting for Mass Storage Class
#include "UsbMsDbg.h"
#include "UsbMsInit.h"
#include "UsOsport.h" // "usb_osport.h"
#ifndef NO_WAITQUEUE
	#include  "PoWait.h" // osport_wait.h
#endif // ndef NO_WAITQUEUE
#include "UsMemLib.h" // UsbMemLib.h


#ifdef _USB_SYSLOG
	#include "syslog.h"
	#include "logStr.h"

	#include "config.h"
	extern struct III_Config_t gSetting;
 #else
	// #error: Please Make Sure : Not _USB_SYSLOG !!
	#warning: Not _USB_SYSLOG !!
#endif // _USB_SYSLOG

// ====================================================================

/*
 * Define several data structures, all of them start with a lone char
 * in order to present an unaligned offset for the next field
 */
#ifdef USBMS_DBG_INFO_ON
	struct c   {char c;  char      t;} c;
	struct s   {char c;  short     t;} s;
	struct i   {char c;  int       t;} i;
	struct l   {char c;  long      t;} l;
	struct ll  {char c;  long long t;} ll;
	struct p   {char c;  void *    t;} p;
	struct u1b {char c;  __u8      t;} u1b;
	struct u2b {char c;  __u16     t;} u2b;
	struct u4b {char c;  __u32     t;} u4b;
	// struct u8b {char c;  __u64     t;} u8b;
	struct u8b {char c;  u64     t;} u8b;
	struct sector_t_b   {char c;  sector_t t;} sector_t_b;
#endif // USBMS_DBG_INFO_ON


// ====================================================================

void UsbMsInit(void)
{
 #ifdef USBMS_BS_SYSCAL_ASSERT
	if (!(  mt_busy == 0
	   ) ) {
		iprintf("[ASSERT][USBMS] UsbMsInit() : " ) ;
	    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
	    iprintf("[ASSERT][USBMS] Continue ..\n") ;
	   }
 #endif // USB_BS_ASSERT


 BLOCK_PREEMPTION;
 /*
 USBMS_DBG_INFO(iprintf(
	// "[USBMS INFO] UsbMsInit() : arch   Size:  char  short  int  long   ptr long-long "
	// " u8 u16 u32 u64\n"
	"[USBMS INFO] UsbMsInit() : char  short  int  long   ptr long-long "
	" u8 u16 u32 sector_t\n"
	));
 USBMS_DBG_INFO(iprintf(
	// "[USBMS INFO] UsbMsInit() : %-12s  %3i   %3i   %3i   %3i   %3i   %3i      "
	// "%3i %3i %3i %3i\n",
	// name.machine,
	"[USBMS INFO] UsbMsInit() : %3i   %3i   %3i   %3i   %3i   %3i      "
	"%3i %3i %3i \n",
	(int)sizeof(char), (int)sizeof(short), (int)sizeof(int),
	(int)sizeof(long),
	(int)sizeof(void *), (int)sizeof(long long), (int)sizeof(__u8),
	(int)sizeof(__u16), (int)sizeof(__u32) ,
	// , (int)sizeof(__u64)
	(int)sizeof(sector_t)
	));
 */

 USBMS_DBG_INFO(iprintf(
	"[USBMS INFO] UsbMsInit(1) : Data Type Size (bytes) : \n"
	));
 USBMS_DBG_INFO(iprintf(
	"[USBMS INFO] UsbMsInit(2) : char  short  int  long   ptr long-long \n"
	));
 USBMS_DBG_INFO(iprintf(
	"[USBMS INFO] UsbMsInit(3) : %2i    %2i    %2i    %2i    %2i   %2i \n" ,
	(int)sizeof(char), (int)sizeof(short), (int)sizeof(int),
	(int)sizeof(long),
	(int)sizeof(void *), (int)sizeof(long long)
	));


 USBMS_DBG_INFO(iprintf(
	"[USBMS INFO] UsbMsInit(4) : __u8 __u16 __u32   u8  u16  u32 u64 sector_t\n"
	));

 USBMS_DBG_INFO(iprintf(
	"[USBMS INFO] UsbMsInit(5) : %2i    %2i    %2i    %2i   %2i   %2i  %2i  %2i\n" ,
	(int)sizeof(__u8),
	(int)sizeof(__u16), (int)sizeof(__u32) ,
	(int)sizeof(u8),
	(int)sizeof(u16), (int)sizeof(u32) ,
	// (int)sizeof(__u64) ,
	(int)sizeof(u64) ,
	(int)sizeof(sector_t)
	));

 /*
 printf("arch  Align:  char  short  int  long   ptr long-long "
           " u8 u16 u32 u64\n");
 printf(       "%-12s  %3i   %3i   %3i   %3i   %3i   %3i      "
           "%3i %3i %3i %3i\n",
           name.machine,
           // note that gcc can subtract void * values, but it's not ansi 
           (int)((void *)(&c.t)   - (void *)&c),
           (int)((void *)(&s.t)   - (void *)&s),
           (int)((void *)(&i.t)   - (void *)&i),
           (int)((void *)(&l.t)   - (void *)&l),
           (int)((void *)(&p.t)   - (void *)&p),
           (int)((void *)(&ll.t)  - (void *)&ll),
           (int)((void *)(&u1b.t) - (void *)&u1b),
           (int)((void *)(&u2b.t) - (void *)&u2b),
           (int)((void *)(&u4b.t) - (void *)&u4b),
           (int)((void *)(&u8b.t) - (void *)&u8b));
 */
 USBMS_DBG_INFO(iprintf(
	"[USBMS INFO] UsbMsInit(6) : Align (bytes) :  \n"));
 USBMS_DBG_INFO(iprintf(
	"[USBMS INFO] UsbMsInit(7) : char  short  int  long   ptr long-long \n"
	));
 USBMS_DBG_INFO(iprintf(
	"[USBMS INFO] UsbMsInit(8) : %3i   %3i   %3i   %3i   %3i   %3i \n",
	// note that gcc can subtract void * values, but it's not ansi 
	(int)((void *)(&c.t)   - (void *)&c),
	(int)((void *)(&s.t)   - (void *)&s),
	(int)((void *)(&i.t)   - (void *)&i),
	(int)((void *)(&l.t)   - (void *)&l),
	(int)((void *)(&p.t)   - (void *)&p),
	(int)((void *)(&ll.t)  - (void *)&ll)
	));

 USBMS_DBG_INFO(iprintf(
	"[USBMS INFO] UsbMsInit(9)  : u8  u16 u32 u64 sector_t\n"
	));
 USBMS_DBG_INFO(iprintf(
	"[USBMS INFO] UsbMsInit(9) : %3i %3i %3i %3i %3i \n",
	// note that gcc can subtract void * values, but it's not ansi 
	(int)((void *)(&u1b.t) - (void *)&u1b),
	(int)((void *)(&u2b.t) - (void *)&u2b),
	(int)((void *)(&u4b.t) - (void *)&u4b),
	(int)((void *)(&u8b.t) - (void *)&u8b) ,
	(int)((void *)(&sector_t_b.t) - (void *)&sector_t_b)
	));
 USBMS_DBG_INFO(iprintf(
	"[USBMS INFO] UsbMsInit(10) : ENOMEM=%3i \n",
	(int)ENOMEM
	));
 UNBLOCK_PREEMPTION;


 // device driver base system

 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(1) ====== call devices_init() ... \n"));
 USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(11) ====== call devices_init() ... \n"));
 devices_init() ; // on storage/base/core.c
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(2) ====== after call devices_init() \n"));
 // YIELD();

 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(3) ====== call buses_init() ... \n"));
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(2) ====== call buses_init() ... \n"));
 buses_init() ; // on storage/base/bus.c
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(4) ====== after call buses_init() \n"));
 
 // YIELD();

 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(5) ====== call classes_init() ... \n"));
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(3) ====== call classes_init() ... \n"));
 classes_init() ; // on storage/base/class.c
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(6) ====== after call classes_init() \n"));
 // YIELD();
 
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(7) ====== call platform_bus_init() ... \n"));
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(4) ====== call platform_bus_init() ... \n"));
 platform_bus_init() ; // on storage/base/platform.c
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(8) ====== after call platform_bus_init() \n"));
 // YIELD();
 

 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(9) ====== call bdev_cache_init() ... \n"));
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(5) ====== call bdev_cache_init() ... \n"));
 bdev_cache_init() ; // on block_dev.c
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(10) ====== after call bdev_cache_init() \n"));
 // YIELD();

 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(11) ====== call inode_init() ... \n"));
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(6) ====== call inode_init() ... \n"));
 inode_init() ; // on inode.c
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(12) ====== after call inode_init() \n"));
 // YIELD();

 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(13) ====== call buffer_init() ... \n"));
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(7) ====== call buffer_init() ... \n"));
 buffer_init() ; // on buffer.c
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(14) ====== after call buffer_init() \n"));
 // YIELD();


 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(15) ====== call init_bio() ... \n"));
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(8) ====== call init_bio() ... \n"));
 init_bio() ; // on bio.c
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(16) ====== after call init_bio() \n"));
 // YIELD();


 // upper-level genhd for disk partition

 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(17) ====== call device_init() ... \n"));
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(9) ====== call device_init() ... \n"));
 device_init() ; // on genhd.c
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(18) ====== after call device_init() \n"));
 
 
 // YIELD();

 // mid-level SCSI driver
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(19) ====== call init_scsi() ... \n"));
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(10) ====== call init_scsi() ... \n"));
 init_scsi() ; // on storage/scsi.c
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(20) ====== after call init_scsi() \n"));
 
 // YIELD();

 #ifndef USBMS_NO_DBGHOST
	USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(21) ====== call scsi_debug_init() ... \n"));
	// USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(11) ====== call scsi_debug_init() ... \n"));
	scsi_debug_init() ;
	USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(22) ====== after call scsi_debug_init() \n"));
    // YIELD();
 #endif // ndef USBMS_NO_DBGHOST

 #ifndef USBMS_NO_SG
	// SCSI Generic Support
	USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(23) ====== call init_sg() ... \n"));
	// USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(12) ====== call init_sg() ... \n"));
	init_sg() ;
	USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(24) ====== after call init_sg() \n"));
    // YIELD();
 #endif // ndef USBMS_NO_SG

 // SCSI Disk Support
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(25) ====== call init_sd() ... \n"));
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(13) ====== call init_sd() ... \n"));
 init_sd() ; // on sd.c
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(26) ====== after call init_sd() \n"));

 // YIELD();

 // USB Mass Storage Class Core
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(27) ====== call usb_stor_init() ... \n"));
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(14) ====== call usb_stor_init() ... \n"));
 usb_stor_init() ;
 USBMS_DBG_INIT(iprintf("[USBMS INIT] UsbMsInit(28) ====== after call usb_stor_init() \n"));
 USBMS_DBG_INFO(iprintf("[USBMS INFO] UsbMsInit(25) ====== after call usb_stor_init() \n"));

 // YIELD();


 #ifdef USBMS_BS_SYSCAL_ASSERT
	if (!(  mt_busy == 0
	   ) ) {
		iprintf("[ASSERT][USBMS] UsbMsInit() : " ) ;
	    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
	    iprintf("[ASSERT][USBMS] Continue ..\n") ;
	   }
 #endif // USBMS_BS_ASSERT
             
} // funciton UsbMsInit()

// ====================================================================

// ====================================================================

// End of File : UsbMsInit.c
